#include 'FILEIO.CH'
/*
   INDEXNOM()

   Creacin de ndices pero incluyendo en
   la cabecera del mismo el nombre del
   fichero .DBF al que pertenece

   (c) Grupo EIDOS. Abril 1993
*/
FUNCTION IndexNom( cFichDBF, cFichNTX, bClave, cClave )
   LOCAL nHandle, cAlias

   // Comprobacin de parmetros
   IF ValType( cFichDBF ) != 'C' .OR.;
      ValType( cFichNTX ) != 'C' .OR.;
      ValType( bClave )   != 'B' .OR.;
      ValType( cClave )   != 'C'
      // No se genera ndice
      RETURN .F.
   END IF

   // Comprobar si hay fichero en uso
   cAlias := Alias()
   IF EMPTY( cAlias )
      // No hay fichero en uso
      RETURN .F.
   END IF

   cFichDBF := AllTrim( cFichDBF )
   cFichNTX := AllTrim( cFichNTX )

   // Comprobamos extensin y nombre de fichero .DBF
   IF At( '.',cFichDBF ) == 0
      IF Len( cFichDBF ) > 8
         RETURN .F.            // Nombre de fichero no es vlido
      ELSE
         cFichDBF += ".DBF"
      END IF
   END IF

   // Comprobamos extensin y nombre de fichero .NTX
   IF At( '.',cFichNTX ) == 0
      IF Len( cFichNTX ) > 8
         RETURN .F.            // Nombre de fichero no es vlido
      ELSE
         cFichNTX += ".NTX"
      END IF
   END IF

   // Creacin normal del ndice
   DbCreateIndex( cFichNTX, cClave, bClave )

   // Cerramos el fichero .NTX para
   // poder escribir el nombre del fichero .DBF
   DbClearInd()

   // Se graba el nombre del fichero en la cabecera del
   // ndice creado

   // Apertura de fichero
   IF (nHandle := FOpen( cFichNTX, FO_READWRITE) ) = -1
      RETURN .F.
   END IF

   FSeek( nHandle, 1012, 0 )
   FWrite( nHandle, cFichDBF, 12 )
   FClose( nHandle )

   // Abrimos nuevamente el fichero .NTX para dejarlo activado
   DbSetIndex( cFichNTX )
RETURN .T.


/*
   INDEXDIDBF()

   Devuelve el nombre del fichero .DBF al que
   pertenece. Dicho ndice previamente fue
   creado con IndexNom()
*/
FUNCTION IndexDiDbf( cFicNTX )
   LOCAL cFDbf, nHandle

   // Apertura de fichero
   IF (nHandle := FOpen( cFicNTX, FO_READWRITE) ) = -1
      RETURN .F.
   END IF

   FSEEK( nHandle, 1012, 0 )
   cFDbf := FREADSTR( nHandle,12 )
   FCLOSE( nHandle )
RETURN cFDbf
