#include 'BOX.CH'
#include 'INKEY.CH'
#include 'MEMOEDIT.CH'

/*
   MEMO3.PRG

   Pequeo editor de ficheros de textos

   (c) Grupo EIDOS. Abril 1993
*/
FUNCTION Main()
   LOCAL GetList := {}
   LOCAL cNombre
   LOCAL cNotas
   LOCAL cColor := SetColor( '/W' )

   Set( _SET_SCOREBOARD, .F. )

   CLS

   SetColor( 'W+/B' )
   @ 01,01,23,78 BOX B_SINGLE + Space( 1 )
   @ 01,58 SAY   ' EDITOR DE FICHEROS ';
           COLOR 'GR+/B'

   @ 03,01 SAY '' + Replicate( '', 76 ) + ''
   @ 21,01 SAY '' + Replicate( '', 76 ) + ''

   WHILE .T.
         cNombre := Space( 65 )

         @ 02,03 SAY     'Nombre ';
                 GET     cNombre   ;
                 PICTURE '@!'
         READ

         IF LastKey() == K_ESC
            EXIT
         END IF

         IF File( cNombre )
            IF (cNotas := MemoRead( cNombre ) ) == ''
               Alert( 'Error de lectura' )
               LOOP
            END IF
         ELSE
            @ 21,03 SAY ' Nuevo Fichero '
         END IF

         cNotas := MemoEdit( cNotas, 04, 03, 20, 77,,'EditUsu()' )

         IF !MemoWrit( cNombre, cNotas )
            Alert( 'Error de escritura en fichero' )
         END IF

         @ 04,02 CLEAR TO 20,77
         @ 21,03 SAY Replicate( '', 15 )
         @ 22,02 CLEAR TO 22,77
   END WHILE

   CLS
RETURN NIL
//

/*
   EditUsu()

   Funcin de usuario para ser tratada con MemoEdit()
*/
FUNCTION EditUsu( nModo, nFila, nCol )
   LOCAL nTecla := LastKey()
   LOCAL nValor

   @ 22,51 SAY '[F10] Grabar / [Esc] Salir'

   DO CASE
      CASE nModo == ME_IDLE    // Inactivo
           @ 22,03 SAY 'Lnea '
           @ 22,14 SAY 'Col.  '

           @ 22,09 SAY Str( nFila, 3 ) COLOR 'R/B'
           @ 22,20 SAY Str( nCol , 3 ) COLOR 'R/B'
           RETURN ME_DEFAULT

      CASE nModo == ME_UNKEYX  // Tecla desconocida
                               // Se altera texto
           IF nTecla == K_F10
              RETURN 23
           END IF
   END CASE

   DO CASE
      CASE nTecla == K_INS
           SetCursor( IIf( SetCursor() != 3, 3, 1 ) )

      CASE nTecla == K_ESC
           IF Alert( 'Desea finalizar edicin?' ,;
                     { 'SI', 'NO' } ) = 1
              RETURN ME_DEFAULT
           ELSE
              RETURN ME_IGNORE
           END IF
   END CASE
RETURN ME_DEFAULT
