/**************************************************/
// Nombre.....: BROWSE_H.PRG                      //
/**************************************************/

#include "Inkey.ch"
#include "browse_h.ch"
#include "rddAuxil.ch"

Static aMens := { "Registro. N.:" , ;
                  "Principio....." , ;
                  "Fin de fichero" , ;
                  "Busca.:  "       , ;
                  "Pasar a: "         ;
                }

/* EXPLICACION DE PARAMETROS ( que son posiciones de un solo array )

   1 Array de las cuatro esquinas
   2 Array de cabeceras
   3 Array de contenido de campos
   4 Cantidad de columnas que queremos congelar a la izquierda
   5 Teclado rpido ( Parpados )
   6 Condicin de ambito de visualizacin
   7 Caracter de separacin
   8 Cadena de pie de Pgina
   9 Array de Teclas especiales
  10 Array de Codeblocks a ejecutar con teclas especiales
  11 Codeblock opcional a ejecutar dentro de Browse_h

*/

/* SALIDA
   1 Esta funcin devuelve siempre un Nmero, que es el Recno()
   sobre el cual est posicionada la base de datos principal.
*/

/**************************/
Func Browse_H( aControl ) //
/**************************/

If (! Used() ) .Or. ( pCount() == 0 ) ; Retu ( 0 ) ; EndI

aSize ( aControl , 25 )

/* AJUSTE DE PARAMETROS POR DEFECTO */

If Empty( aCabecera )
   DefCampo( aControl , 1 ) // Array de Cabeceras
EndI

If Empty( aCampos )
   DefCampo( aControl , 2 ) // Array de Campos
EndI

DEFECTO cSepara     := " "                      // Caracter de separacin
DEFECTO lTecRapid   := .F.                      // Teclado rpido NO
DEFECTO nCongel     :=  0                       // No hay columnas congeladas
DEFECTO lSetDeleted := .T.                      // Set deleted on

cPanAnt := SaveScreen( nTrow , nTcol , nBrow + 1 , nBcol + 1 )


DispBox( nTrow , nTcol , nBrow  , nBcol , X_CAJA_S , X_CO_CAJ )

If cPieDeP # Nil                      // Pie de Pgina
   @ MaxRow() , 0 SAY PadL( cPieDeP , MaxCol() + 1 ) COLOR X_CO_CAB
EndI

Crea_Bro( aControl )

oBrowse:ColSep    := cSepara               // Separadores
oBrowse:ColorSpec := X_CO_BRO              // Colores
oBrowse:Freeze    := nCongel               // Columnas congeladas
nAncho            := ( nBcol - nTcol ) - 1 // Recalcula el ancho
nRecNoEnt         := RecNo ()              // RecNo() al antrar
nDevol            := nRecNoEnt             // Devolver el mismo por defecto

Set( _SET_DELETED , lSetDeleted )          // Modo delete

If xCond # Nil
   xCond := Iif( ValType( xCond ) # "A" , { xCond , xCond } , xCond )
   oBrowse:GoTopBlock    := Inici( xCond )
   oBrowse:GoBottomBlock := Final( xCond )
   oBrowse:SkipBlock     := Salta( cIndice , xCond )
EndI

If ValType( cbOpcional ) == "B"
   Eval( cbOpcional , oBrowse )
EndI

/* BUCLE PRINCIPAL DE MANEJO DE TBROWSE */

lBucle := .T. // Condiciona la salida del bucle WHILE.

Whil lBucle

   If oBrowse:ColPos <= oBrowse:Freeze
      oBrowse:ColPos := oBrowse:Freeze + 1
   EndI

   nTecla := 0
   Whil nTecla == 0 .and. !oBrowse:Stable
      oBrowse:Stabilize()
      If lTecRapid
         nTecla := InKey()
      EndI
   EndD

   if oBrowse:Stable

      If oBrowse:HitTop                      // Inicio de Rango
         Mensajes( aControl , aMens[ 02 ] )
         Tone( 125 , 0 )
      EndI

      If oBrowse:HitBottom                   // Fin de Rango
         Mensajes( aControl , aMens[ 03 ] )
         Tone( 125 , 0 )
      EndI

      /* Dibuja pie de Browse */

      Mensajes( aControl , aMens[ 01 ] + Str( RecNo() , 5 ) + Chr( 179 ) )

      Refresca( aControl  , .F. ) // Solo refresca Linea

      nTecla := InKey( 0 )  // TECLAZO DE USUARIO

   EndI


   If TeclaEsp( aControl )
      Loop
   EndI

   Do Case
      Case nTecla == K_ENTER // Saldr de la funcin y devolver
         lBucle := .F.       // el RecNo()
         nDevol := RecNo()
      Case nTecla == K_ESC   // Saldr de la funcin y devolver 0
         lBucle := .f.
         nDevol := 0
      Case nTecla > 47 .and. nTecla < 123
         Busca_Ch( aControl )  // Busca un Carcter
      OtherWise
         /*
         La cadena CadBusca que acumula carcteres de bsqueda
         para Busca_Ch() , se reinicializa. y se procesan las
         teclas de movimiento de Tbrowse
         */
         cCadBusca := ""
         Tecla_Br( aControl )
   EndC

EndD


If cPieDeP # Nil                      // Pie de Pgina
   @ MaxRow() , 0 SAY Spac( MaxCol() + 1 ) COLOR X_CO_MSG
EndI
RestScreen( nTrow , nTcol , nBrow + 1 , nBcol + 1 , cPanAnt )
Retu nDevol
//

/******************************************/
Static Func Refresca( aControl , lTotal ) //
/******************************************/
If lTotal
   oBrowse:RefreshAll( )
Else
   oBrowse:RefreshCurrent( )
EndI
Whil !oBrowse:Stabilize()
EndD
Retu Nil

/*****************************************/
Static Func Mensajes( aControl , cMens ) //
/*****************************************/
Local cCadena :=  cMens + Spac( nAncho - ( 11 + Len(cMens) ) ) + ;
                  Chr(179)+Chr(240)+Chr(179)+Chr(024)+Chr(179) + ;
                  Chr(025)+Chr(179)+Chr(027)+Chr(179)+Chr(026)

@  nBrow - 1 , nTcol + 1  SAY PadR( cCadena , nAncho ) COLOR X_CO_CAB
Retu Nil

/*********************************/
Static Func Busca_Ch( aControl ) // Busca un caracter
/*********************************/
cCadBusca += Upper( Chr( nTecla ) )
dbSeek( cCadBusca , .T. )
Refresca( aControl , .T. , aMens[ 01 ] )
Retu Nil
//

/*********************************/
Static Func TeclaEsp( aControl ) //
/*********************************/
Local cEjec , lDevol := .F.
If ValType( aTecEsp ) == "A"                    // Si existe un array de teclas especiales
   nPosTec := aScan( aTecEsp , nTecla )         // Busca la tecla en el array
   if nPosTec > 0                               // Si la encuentra busca el bloque
      If ValType( aFuncEsp[ nPosTec ] ) == "C"  // SI es una cadena
         cEjec := aFuncEsp[ nPosTec ]           // Lo pasa a variable
         aFuncEsp[ nPosTec ] := { |x| &(cEjec) } // Convierte la cadena en CB
         dbGoto( Eval( aFuncEsp[ nPosTec ] , oBrowse ) )
         lDevol := .T.
      ElseIf ValType( aFuncEsp[ nPosTec ] ) == "B" // SI es CB
         dbGoto( Eval( aFuncEsp[ nPosTec ] , oBrowse ) )
         lDevol := .T.
      Endi
   EndI
EndI
retu lDevol

/*********************************/
Static Func Crea_Bro( aControl ) //
/*********************************/
Local nCont
nLonaCamp  := Len( aCampos )
oBrowse := tBrowseDB( nTrow + 1 , nTcol + 1 , nBrow - 2 , nBcol - 1 )

For nCont := 1 to nLonaCamp

   if ValType( aCampos[ nCont ] ) == "N"
      aCampos[ nCont ] := FieldwBlock( Field( aCampos[ nCont ] ) , Sele( ) )
   end

   if ValType( aCampos[ nCont ] ) == "C"
      aCampos[ nCont ] := FieldwBlock( aCampos[ nCont ] , Sele( ) )
   end

   oColumn := tbColumnNew( aCabecera[ nCont ] , aCampos[ nCont ] )
   oBrowse:addColumn( oColumn )

Next

retu Nil
//
/*********************/
Func Inici( aRango ) //  Primer registro vlido
/*********************/
Retu( {||dbSeek(aRango[1],.T.)} )
//

/*********************/
Func Final( aRango ) //  Ultimo registro vlido
/*********************/
Retu( {||dbSeek(Clavesi(aRango),.T.),dbSkip(-1)} )
//

/******************************/
Static Func Clavesi( aRango ) //
/******************************/
Local cTipo := ValType( aRango[ 2 ] ) , eSigui
Do Case
   Case cTipo == "C" ; eSigui := Stuff(aRango[2],Len(aRango[2]),1,;
                                 Chr(Asc(Right(aRango[2],1))+1))
   Case cTipo == "N" ; eSigui := aRango[ 2 ] ++
   Case cTipo == "D" ; eSigui := aRango[ 2 ] ++
Endc
Retu( eSigui )
//

/*******************************/
Func Salta( eIndice , aRango ) //
/*******************************/
Retu( {|nCant| Saltarn( nCant , eIndice , aRango )} )
//

/************************************************/
Static Func Saltarn( nCant , eIndice , aRango ) //
/************************************************/
Local nReal   := 0
if     nCant  == 0 .OR. LastRec() == 0 ; dbSkip( 0 )
ElseIf nCant  >  0 .And. RecNo() # LastRec() + 1
   Whil nReal <= nCant .And. ! Eof() .And. &( eIndice ) <= aRango[ 2 ]
      dbSkip( 1 )  ; nReal ++
   EndD
   dbSkip( -1 )    ; nReal --
ElseIf nCant < 0
   Whil nReal >= nCant .And. ! Bof() .And. &( eIndice ) >= aRango[ 1 ]
      dbSkip( -1 ) ; nReal --
   EndD
   If ! Bof() ; dbSkip( 1 ) ; Endi
   nReal ++
Endi
Retu ( nReal )
//
/**************************/
Func Tecla_Br( aControl ) //
/**************************/
Do Case
   Case nTecla == K_DOWN       ; oBrowse:Down()
   Case nTecla == K_PGDN       ; oBrowse:PageDown()
   Case nTecla == K_CTRL_PGDN  ; oBrowse:GoBottom()
   Case nTecla == K_UP         ; oBrowse:Up()
   Case nTecla == K_PGUP       ; oBrowse:PageUp()
   Case nTecla == K_CTRL_PGUP  ; oBrowse:GoTop()
   Case nTecla == K_RIGHT      ; oBrowse:Right()
   Case nTecla == K_LEFT       ; oBrowse:Left()
   Case nTecla == K_HOME       ; oBrowse:Home()
   Case nTecla == K_END        ; oBrowse:End()
   Case nTecla == K_CTRL_LEFT  ; oBrowse:PanLeft()
   Case nTecla == K_CTRL_RIGHT ; oBrowse:PanRight()
   Case nTecla == K_CTRL_HOME  ; oBrowse:PanHome()
   Case nTecla == K_CTRL_END   ; oBrowse:PanEnd()
EndCase
Retu Nil
//

/*******************************************/
Static Func DefCampo( aControl , nOpcion ) //
/*******************************************/
If nOpcion     == 1                 // Hay que definir Cabeceras
   aCabecera   := Array( fCount() )   //
   aEval( aCabecera , { |x,y| aCabecera[ y ] := FieldName( y ) } )
ElseIf nOpcion == 2
   aCampos     := Array( fCount() )   //
   aEval( aCampos   , { | x,y| aCampos[ y ]  := y } )
End If
Retu Nil
