/*
  Programa Ŀ
    Aplicacin: CAJAS.EXE                                                  
       Fichero: CAJA.PRG                                                   
         Autor: Grupo EIDOS                                                
         Fecha: 21/05/93                                                   
          Hora: 00:00:00                                                   
     Copyright: 1993 by Grupo Eidos                                        
 
 
*/

/*
 Ŀ
       Funcin: Main()                                                     
      Utilidad: Demo de declaracin y uso de Objetos CAJA                  
    Parmetros: cCant  -> Cantidad de Cajas                                
              nTemp    -> Temporizador                                     
    Devuelve  : Nil                                                        
 
 
*/

Function Main( cCant , cTemp )

	Local nCont , ;                             // Contador para seudo-Random
	nCajas      , ;                             // Contador de cajas
	nBucle      , ;                             // Control de Bucle activo
	nRand       , ;                             // Temporal de Random
	nCanCajas   , ;                             // Cantidad de Cajas
        nTempo      , ;                             // Control de temporizador
        cTit        , ;                             // Cadena de ttulo
	cTexto      , ;                             // Cadena de texto
        cColor      , ;                             // Cadena de Color
        nY1         , ;                             // Coordenadas
	nY2         , ;                             //     "
	nX1         , ;                             //     "
	nX2                                         //     "


/* DEFINIMOS LOS TRES OBJETOS CAJA */

	Local oCaja1 := Caja1():CajaNew()           // Objeto Caja Bsico
	Local oCaja2 := Caja2():CajaNew()           // Objeto Caja 1 Herencia
	Local oCaja3 := Caja3():CajaNew()           // Objeto Caja 2 Herencia


/* CONTROLAMOS CANTIDAD Y TEMPORIZACION */

	nCanCajas := Iif( cCant == Nil , 100 , Val( cCant ) )
	nTempo    := Iif( cTemp == Nil ,  0  , Val( cTemp ) )

	Scroll()                                    // Limpiamos Pantalla
	SetCursor( 0 )                              // Anulamos cursor

	nBucle := 1                                 // Control de Bucle
	nCont  := 1                                 // Contador para Random
	nCajas := 0                                 // Contador de Cajas

	While .T.                                   // Inicio de Bucle

   /* Control de coordenadas seudo-Random */

		nRand := Random( nCont )

		nY1      := ( nRand % ( MaxRow() - 08 ) ) + 01 // Coordenadas
		nY2      := ( nRand % ( MaxRow() - 05 ) ) + 05 // Coordenadas
		nX1      := ( nRand % ( MaxCol() - 29 ) ) + 01 // Coordenadas
		nX2      := ( nRand % ( MaxCol() - 10 ) ) + 10 // Coordenadas

		++ nCont

		If ( nY1 + 3 > nY2 .Or. nX1 + 6 > nX2 )
			LOOP
		End If


		If nCajas ++ == nCanCajas              // Control de Bucle
			++ nBucle
			nCajas := 0
			nCont  := 1
		End If


   /* Definimos Ttulo, Texto y Color */

		cTit   := " Ventana N " + Str( nCajas , 4 )
                cTexto := " Este es el texto de la" + cTit
		cColor := Str( nRand - 1 ) + "/" + Str( nRand )

		If        nBucle == 1                     // CAJA SENCILLA

			oCaja1:AbreIni(nY1,nX1,nY2,nX2, cColor )

		ElseIf nBucle == 2                     // CAJA CON TITULO

			oCaja2:AbreTit(nY1,nX1,nY2,nX2, cColor , cTit )

		ElseIf nBucle == 3                     // CAJA CON TITULO Y TEXTO

			oCaja3:AbreTxt(nY1,nX1,nY2,nX2, cColor , cTit , cTexto )

		Else

			Exit

		End If

		If nTempo # 0
			InKey( nTempo )
		End If

	End Do

	@ 24 , 00 SAY PadC( "HA DIBUJADO " + ;
	Str( nCanCajas * 3 , 6 ) + ;
	" VENTANAS " , 80 )

	oCaja1:AbreIni( 18 , 01 , 22 , 79 )
	oCaja1:Mueve()
	oCaja1:Cierra()
	@ 24 , 00 SAY Space( 80 )

	nBucle := 3
	nCajas := 0

	While .T.

		If        nBucle == 3                     // CERRAMOS CAJAS CON TITULO Y TEXTO
			oCaja3:Cierra()
		ElseIf nBucle == 2                     // CERRAMOS CAJAS CON TITULO
			oCaja2:Cierra()
		ElseIf nBucle == 1                     // CERRAMOS CAJAS
			oCaja1:Cierra()
		Else
			Exit
		End If

		If nCajas ++ == nCanCajas - 1          // Control de Bucles
			-- nBucle
			nCajas := 0
		End If

		If nTempo # 0
			InKey( nTempo )
		End If

	End Do

Return Nil

/*
 Ŀ
       Funcin: Random()                                                   
      Utilidad: Calcular nmeros al azar                                   
    Parmetros: nSemilla -> un nmero en que basar su algoritmo            
    Devuelve  : Un Nmero seudo-aleatorio                                  
 
 
*/
Function Random( nSemilla )
Return( Val(SubS(Str(Log(nSemilla)*nSemilla*100000),6,5)))

/*
 Ŀ
       Funcin: CLIPPER501()                                               
      Utilidad: Compatibilizar OBJECTS con CLIPPER 5.2                     
    Parmetros: Ninguno                                                    
      Devuelve: Nil                                                        
 
 
*/
Function Clipper501
Return Nil
