/*
  Programa Ŀ
    Aplicacin: CAJAS.EXE                                                  
       Fichero: CLASE1.PRG                                                 
         Autor: Grupo EIDOS                                                
         Fecha: 21/05/93                                                   
          Hora: 00:00:00                                                   
     Copyright: 1993 by Grupo Eidos                                        
 
 
*/

#include "Objects.ch"
#include "Inkey.ch"


CLASS Caja1                                      // INICIAMOS LA DEFINICION DE LA CLASE


    /* ESTOS SON LOS DATOS */

	DATA nRowIni , ;                            // Linea   Inicial
	     nColIni , ;                            // Columna Inicial
	     nRowFin , ;                            // Lnea   Final
	     nColFin , ;                            // Columna Final
	     cCadena , ;                            // Cadena de carcteres de la Caja
	     cColor  , ;                            // Cadena de colores de la Caja
	     aPilaPa                                // Array de Pila de Pantallas anteriores



    /* ESTOS SON LOS METODOS */

   METHOD CajaNew()         // Crea el Objeto caja
   METHOD AbreIni(nRowT,nColT,nRowB,nColB,cColor)        // Inicializa la caja
   METHOD Abre()            // Abre   la caja
   METHOD Cierra()          // Cierra la caja
   METHOD Mueve()           // Mueve  la caja
                  

ENDCLASS                                         // FINALIZA LA DEFINICION

/*
 Ŀ
        Mtodo: CajaNew()                                                  
      Utilidad: Inicializa las variables de la clase CAJA1                 
    Parmetros: Ninguno                                                    
    Devuelve  : Self ( Un Objeto de la Clase CAJA1 )                       
 
 
*/

METHOD CajaNew() CLASS Caja1

	::aPilaPa := {}                             // Inicializa el array de pantallas.
	::cCadena := "ķԳ "                    // Inicializa la cadena de Caja.
	::cColor  := SetColor()                     // Inicializa los colores de la Caja.
	::nRowIni := 0                              // Inicializa Linea   Inicial
	::nColIni := 0                              // Inicializa Columna Inicial
	::nRowFin := 0                              // Inicializa Lnea   Final
	::nColFin := 0                              // Inicializa Columna Final


Return Self                                      // Devuelve el Objeto.

/*
 Ŀ
        Mtodo: AbreIni()                                                  
      Utilidad: 1 Asigna las coordenadas y el color                       
                      2 Llama al mtodo Abre()                            
    Parmetros: nRowT  -> Coordenada                                       
                nColT  -> Coordenada                                       
                nRowB  -> Coordenada                                       
                nColB  -> Coordenada                                       
                cColor -> Cadena de Color de la caja                       
    Devuelve  : Self ( El Propio Objeto )                                  
 
 
*/

METHOD AbreIni( nRowT , ;
                nColT , ;
                nRowB , ;
                nColB , ;
                cColor         ) CLASS Caja1

	::nRowIni := nRowT                          // Asignamos los parmetros recibidos
	::nColIni := nColT                          // a las variables internas del Objeto
	::nRowFin := nRowB                          //
	::nColFin := nColB                          //
	::cColor  := cColor                         //


	::Abre()                                    // Llamamos al mtodo ABRE() de la misma CLASE

Return Self

/*
 Ŀ
        Mtodo: Abre()                                                     
      Utilidad: Almacena la pantalla que se encuentra debajo de            
                sus coordenadas y la salva en un array de pila.            
                Muestra la ventana en sus coordenadas y con su color       
    Parmetros: Ninguno                                                    
    Devuelve  : Self ( El Propio Objeto )                                  
 
 
*/

METHOD Abre() CLASS Caja1

	aAdd( ::aPilaPa , { ::nRowIni , ::nColIni , ;
	                    ::nRowFin , ::nColFin , ;
                SaveScreen( ::nRowIni , ::nColIni , ;
                            ::nRowFin , ::nColFin ) } )

       DispBox( ::nRowIni , ::nColIni , ::nRowFin , ;
                ::nColFin , ::cCadena , ::cColor )

Return Self

/*
 Ŀ
        Mtodo: Cierra()                                                   
      Utilidad: Cierra LA ULTIMA ventana abierta, y ELIMINA sus            
                datos del array de pila                                    
    Parmetros: Ninguno                                                    
    Devuelve  : Self ( El Propio Objeto )                                  
 
 
*/

METHOD Cierra() CLASS Caja1

	Local nLonPan := Len( ::aPilaPa )

	RestScreen( ::aPilaPa[ nLonPan , 1 ] , ;
	            ::aPilaPa[ nLonPan , 2 ] , ;
	            ::aPilaPa[ nLonPan , 3 ] , ;
	            ::aPilaPa[ nLonPan , 4 ] , ;
	            ::aPilaPa[ nLonPan , 5 ] )

	aSize( ::aPilaPa , nLonPan - 1 )

Return Self

/*
 Ŀ
        Mtodo: Mueve()                                                    
      Utilidad: Mueve una ventana, cambiando sus coordenadas,              
                cerrandola y volviendola a abrir.                          
    Parmetros: Ninguno                                                    
      Devuelve: Self ( El Propio Objeto )                                  
         Notas: El uso de una variable LOCAL en este mtodo, ilustra       
                la total similitud con las funciones.                      
                                                                           
 
 
*/

METHOD Mueve() CLASS Caja1

	Local nTecla

	While .T.

		nTecla := InKey( 0 )

		If     nTecla == K_UP    ; -- ::nRowIni ; -- ::nRowFin
		ElseIf nTecla == K_DOWN  ; ++ ::nRowIni ; ++ ::nRowFin
		ElseIf nTecla == K_LEFT  ; -- ::nColIni ; -- ::nColFin
		ElseIf nTecla == K_RIGHT ; ++ ::nColIni ; ++ ::nColFin
		Else                     ;  EXIT
		EndI

		::Cierra()
		::Abre()

	End Do

Return Self