#Include "Inkey.ch"
#Include "GetExit.ch"
#Include "Box.ch"

/***
*       MiLector()
*       Lector Personalizado de GETs
*/
FUNCTION MiLector( get, cMensaje, cColMsg, pos, nTimeOut, bTimeOut, bLista )

  /// Control para los nuevos parmetros que se le envan  ////
  //                                                         //
   LOCAL nPos                                                //
   LOCAL nKey := 0                                           //
   LOCAL cSaveMsg
   LOCAL nRow
                                                             //
   IF ValType( pos ) # "N"                                   //
      pos := 0                                               //
   END IF                                                    //
                                                             //
   IF ValType( nTimeOut ) # "N"                              //
      nTimeOut := 0                                          //
   END IF                                                    //
                                                             //
   IF ValType( bTimeOut ) # "B"                              //
      bTimeOut := {|| .T.}                                   //
   END IF                                                    //
  /////////////////////////////////////////////////////////////

   // edita el GET si se cumple la condicin WHEN
   IF ( GetPreValidate(get) )

      // Pinta lo determinado por la clusula MESSAGE
      IF cMensaje # NIL
         nRow     := Set(_SET_MESSAGE)
         cSaveMsg := SaveScreen(nRow,0,nRow,MaxCol())
         @ nRow, 0 SAY PADC(cMensaje,MaxCol()+1) COLOR cColMsg
      END IF

      // Activa el foco
      get:SetFocus()

      WHILE ( get:exitState == GE_NOEXIT )

        // controla la salida de la edicin
        IF ( get:typeOut )
           get:exitState := GE_ENTER
        END IF

        //////////////////////////////////////////////////////
        // Cambiado para GET con POSICION                   //
        FOR nPos := get:pos TO pos-1                        //
            get:right()                                     //
        END FOR                                             //
        //////////////////////////////////////////////////////

        // procesa las pulsaciones
        WHILE ( get:exitState == GE_NOEXIT )
          //// Este proceso controla la temporizacin ///////////////
          CogeTecla( get, nKey := InKey( nTimeOut ), bLista )      //
          If( nKey == 0 .AND. Eval(bTimeOut, get ),   ;            //
               __keyboard( Chr( K_ESC ) ), NIL )                   //
           // Vase como aadimos EVAL() del CodeBlock pasado      //
           // como POSTIMEOUT. ojo! tenga en cuenta que su        //
           // programa puede pasar al CodeBlock como parmetro el  //
           // objeto GET en cuestin.                              //
           // Si no se pulsa ninguna tecla, sale como [Esc]        //
          ///////////////////////////////////////////////////////////
        END WHILE

        // Si no se cumple el VALID, no salimos
        IF ( !GetPostValidate(get) )
           get:exitState := GE_NOEXIT
        END IF

      END WHILE

      // mata el foco
      get:KillFocus()

      // Borra lo determinado por la clusula MESSAGE
      IF cMensaje # NIL
         RestScreen(nRow,0,nRow,MaxCol(),cSaveMsg)
      END IF

   END IF

RETURN NIL



/***
*       CogeTecla()
*       Procesa los teclazos de un GET
*
*       NOTA: El GET debe tener el foco
*/
FUNCTION CogeTecla(get, key, bLista)

   LOCAL cKey
   LOCAL bKeyBlock
   LOCAL nValor            //Modificado para nmeros incrementales

   // controla SET KEYs
   IF ( (bKeyBlock := SetKey(key)) <> NIL )
       GetDoSetKey(bKeyBlock, get)
       RETURN NIL                                                                  // NOTE
   END IF

   DO CASE
      CASE ( key == K_UP )
           get:exitState := GE_UP

      CASE ( key == K_SH_TAB )
           get:exitState := GE_UP

      CASE ( key == K_DOWN )
           get:exitState := GE_DOWN

      CASE ( key == K_TAB )
           get:exitState := GE_DOWN

      CASE ( key == K_ENTER )
           get:exitState := GE_ENTER

      CASE ( key == K_ESC )
           IF ( Set(_SET_ESCAPE) )
              get:undo()
              get:exitState := GE_ESCAPE
           END IF

      CASE ( key == K_PGUP )
           get:exitState := GE_WRITE

      CASE ( key == K_PGDN )
           get:exitState := GE_WRITE

      CASE ( key == K_CTRL_HOME )
           get:exitState := GE_TOP

      CASE (key == K_CTRL_W)
           get:exitState := GE_WRITE

      CASE (key == K_INS)
           Set( _SET_INSERT, !Set(_SET_INSERT) )

      CASE (key == K_CTRL_U)
           get:Undo()

      CASE (key == K_HOME)
           get:Home()

      CASE (key == K_END)
           get:End()

      CASE (key == K_RIGHT)
           get:Right()

      CASE (key == K_LEFT)
           get:Left()

      CASE (key == K_CTRL_RIGHT)
           get:WordRight()

      CASE (key == K_CTRL_LEFT)
           get:WordLeft()

      CASE (key == K_BS)
           get:BackSpace()

      CASE (key == K_DEL)
           get:Delete()

      CASE (key == K_CTRL_T)
           get:DelWordRight()

      CASE (key == K_CTRL_Y)
           get:DelEnd()

      CASE (key == K_CTRL_BS)
           get:DelWordLeft()

      // Modificado para que [F1] alterne un carcter entre maysculas
      // y minsculas
      CASE (key == K_ALT_F1)
           IF IsLower(SubStr(get:buffer,get:pos,1))
              get:overStrike(Upper(SubStr(get:buffer,get:pos,1)))
            ELSE
              get:overStrike(Lower(SubStr(get:buffer,get:pos,1)))
           END IF

      // Modificado para nmeros incrementales
      CASE (get:type == "N" .OR.get:type == "D")  .and.;
           ( key == 330 .or. key == 334 )
           nValor := get:varGet()
           get:varPut( IIF( key == 334, ++nValor, --nValor ) )
           get:updateBuffer()

      // Modificado para Listas de Valores
      CASE ( key == K_F2 )
           IF ValType( bLista ) == "B"
              get:varPut( EVAL( bLista ) )
              get:UpdateBuffer()
              IF LASTKEY() == K_ESC
                 get:undo()
              END IF
           END IF

      OTHERWISE

           IF (key >= 32 .AND. key <= 255)
              cKey := Chr(key)

              IF (get:type == "N" .AND. (cKey == "." .OR. cKey == ","))
                 get:ToDecPos()
               ELSE
                 IF ( Set(_SET_INSERT) )
                    get:Insert(cKey)
                  ELSE
                    get:Overstrike(cKey)
                 END IF

                 IF (get:typeOut .AND. !Set(_SET_CONFIRM) )
                    IF ( Set(_SET_BELL) )
                       ?? Chr(7)
                    END IF

                    get:exitState := GE_ENTER
                 END IF
              END IF
           END IF
   ENDCASE

RETURN NIL



// Funcin auxiliar para la gestin de las listas de valores
// Parmetros:
// -----------
// bCampo --> CodeBlock que contiene el campo (con alias) a devolver
// oTbCol --> objeto columna para construir la lista de valores
// cColor --> Color para la caja y el TBrowse de la lista
FUNCTION LisVal(bCampo,oTbCol,cColor)
   LOCAL oTbLis,nCol,nTecla
   LOCAL cPantalla := SaveScreen(0,0,MaxRow(),MaxCol())

   oTbCol:width := LEN(EVAL(oTbCol:block))

   nCol   := (MaxCol() - oTbCol:width) / 2
   oTbLis := TBrowseDB(10,nCol,20,MaxCol()-nCol)
   oTbLis:addColumn(oTbCol)
   oTbLis:colorSpec := cColor
   oTbLis:headSep   := ""

   @ 9,nCol-1,21,(MaxCol()-nCol+1) BOX B_SINGLE COLOR cColor

   WHILE .T.
     nTecla := TbStd(oTbLis)
     DO CASE
        CASE nTecla == K_ENTER
             KEYBOARD CHR( K_ENTER )
             EXIT
        CASE nTecla == K_ESC
             EXIT
     END CASE
   END WHILE
   RestScreen(,,,,cPantalla)
RETURN EVAL(bCampo)


// Funcin para obtener la tecla de salida de un TBrowse
FUNCTION TbStd(oTb)
   LOCAL nTecla

   WHILE .T.
     DispBegin()
     WHILE  NextKey() == 0 .AND. !oTb:stabilize();  END WHILE
     DispEnd()

     nTecla := Inkey(0)

     DO CASE
        CASE nTecla == K_DOWN;                       oTb:down()
        CASE nTecla == K_UP;                         oTb:up()
        CASE nTecla == K_PGDN ;                      oTb:pageDown()
        CASE nTecla == K_PGUP ;                      oTb:pageUp()
        CASE nTecla == K_CTRL_PGUP ;                 oTb:goTop()
        CASE nTecla == K_CTRL_PGDN ;                 oTb:goBottom()
        OTHERWISE;                                   EXIT
     END CASE
   END WHILE

RETURN nTecla