/*
  Tb12.prg .... TBrowses anidados

  (c) Grupo EIDOS, abril 1993

*/


#include "Inkey.Ch"
#include "SetCurs.Ch"
#include "Set.Ch"
#include "Common.Ch"
#include "Box.Ch"


FUNCTION Tb12()
  // Objeto para el manejo de Director.Dbf
  LOCAL oDire    := TBrowseDB(2,11,12,68)
  LOCAL oColD1   := TBColumnNew("CODIGO", {|| Director->CdDirec})
  LOCAL oColD2   := TBColumnNew("DIRECTOR", {|| Director->Director})
  LOCAL oColD3   := TBColumnNew("PAIS",   {|| Director->Nacion})

  // Objeto para el manejo de Film.Dbf
  LOCAL oFilm    := TBrowseNew(16,3,22,76)
  LOCAL oColF1   := TbColumnNew("CODIGO",{|| Film->CdFilm})
  LOCAL oColF2   := TbColumnNew("PELICULA",{|| Film->Film})
  LOCAL oColF3   := TbColumnNew("GENERO",{|| Film->Genero})

  // Varios
  LOCAL nTecla
  LOCAL cColor  := SetColor("w/n")
  LOCAL nCursor := SetCursor( SC_NONE )

  // Datos y Mtodos adicionales para el objeto que maneja Film.Dbf
  oFilm:addColumn(oColF1)
  oFilm:addColumn(oColF2)
  oFilm:addColumn(oColF3)
  oFilm:colorSpec := "w/bg*,bg/b*"
  oFilm:goTopBlock    := {| | Film->(IrInicio(Director->CdDirec))}
  oFilm:goBottomBlock := {| | Film->(IrFin   (Director->CdDirec))}
  oFilm:skipBlock     := {|n| Film->(IrA     ( n,;
                               {|| Director->CdDirec == Film->CdDirec }))}
  oFilm:colSep   := "  "
  oFilm:headSep  := ""


  // Datos y Mtodos adicionales para el objeto que maneja Impres.Dbf
  oDire:addColumn(oColD1)
  oDire:addColumn(oColD2)
  oDire:addColumn(oColD3)
  oDire:colorSpec := "b/w*,r/bg*"
  oDire:colSep   := "  "
  oDire:headSep  := ""


  CLS
  SetBlink(.F.)
  Set(_SET_SCOREBOARD,"OFF")

  DispBox(1,10,13,69,1,"b/w*,r/rb*")
  @ 24,0 SAY PadC("[Tab]   = Conmuta entre listas",79)


  // Apertura de ficheros
  USE Director INDEX I1Dire, I2Dire NEW
  USE Film     INDEX I2Film, I1Film NEW


  // Proceso principal
  WHILE .T.

    // TBrowse para las Directores
    nTecla := Director->(TbStd(oDire,{|| VerFilms(oFilm)}))
    DO CASE
       CASE nTecla == K_ESC
            EXIT
       CASE nTecla == K_TAB            // Llama al TBrowse de Films,
                                       // cedindole el control
            oDire:deHilite()           // Apaga barra del TBrowse
            Film->(EditFilm(oFilm))
    END CASE
  END WHILE

  SetColor(cColor)
  SetCursor(nCursor)
  DbCloseAll()
  CLS
RETURN NIL


/*
  Funcin para visualizar los films realizados por un director.
  A esta funcin se la evala cada vez que se estabiliza el TBrowse de
  directores para que aparezca otro TBrowse con los films asociados
*/

FUNCTION VerFilms(oFilm)

  oFilm:goTop()      // Se posiciona en el film adecuado
                     // (primero del filtro)
  DispBox(15,2,23,77,1,"w/bg*,bg/b*")

  oFilm:forceStable()
  oFilm:deHilite()
RETURN NIL

/*
  Funcin para visualizar los films, pero pasando a ser el
  TBrowse activo para poder movernos a travs del mismo. Con [Tab] o
  [Esc] se devuelve el control al TBrowse de directores
*/

FUNCTION EditFilm(oFilm)
  LOCAL nTecla

  oFilm:goTop()            // Se posiciona en el film adecuado
                           // (primero del filtro)
   WHILE .T.
     nTecla := Film->(TbStd(oFilm))
     IF nTecla == K_ESC .OR. nTecla == K_TAB
        EXIT
     END IF
   END WHILE

RETURN NIL

