/*

  Tb14.prg .... Ejemplo de un TBrowse para visualizar ficheros

  (c) Grupo EIDOS, abril 1993
    
*/

#include "FileIo.ch"
#include "InKey.ch"

#define CRLF  Chr(13) + Chr(10)
#define LINEA 256


STATIC nHandle     
STATIC cLine       
STATIC nLong   


FUNCTION View(cFile)
   LOCAL oTxt, oTxtCol, oTxtCol1, nTecla
   LOCAL cColor := SetColor('W/B ,W+/R,,,W/B')


   IF !File(cFile)
      Alert("El fichero no existe")
      RETURN NIL
   END IF

   DispBox(1,1,22,79,1, 'W/B ,W+/R,,,W/B')

   nHandle := FOpen(cFile)
   FSeek(nHandle, 0, FS_END)
   nLong := FSeek(nHandle,0,FS_RELATIVE)
   FirstTxt()

   oTxt := TBrowseNew(2, 2, 21, 78)

   oTxtCol := TBColumnNew(, {|| cLine })

   oTxt:colorSpec = "W/B,W+/R,N,N,B/W,R/B,B/R,R/B,B/R"


   oTxtCol1 := TbColumnNew(, {|| SubStr(cLine, 76) })
   oTxtCol1:width := 76
   oTxtCol:width := 76

   oTxt:addColumn(oTxtCol)
   oTxt:addColumn(oTxtCol1)
   oTxt:goTopBlock         := {| | FirstTxt() }
   oTxt:goBottomBlock      := {| | LastTxt()  }
   oTxt:skipBlock          := {|n| SkipTxt(n) }

   // Bucle de proceso
   WHILE .T.
      
      nTecla := TbStd(oTxt)       // Teclas automatizadas
      IF nTecla == K_ESC
         EXIT
      END IF

   END WHILE
   
   FClose(cFile)   
   SetColor(cColor)
   CLS

RETURN NIL   


// Funcin para el CodeBlock que posiciona en la primera lnea
FUNCTION FirstTxt()
   FSeek(nHandle, 0, FS_SET)
   FLine(nHandle, @cLine)
   FSeek(nHandle, 0, FS_SET)
RETURN NIL


//Funcin que lee cada lnea
FUNCTION FLine(nHandle, cBuffer)
   LOCAL nEol, nRead, nPos

   cBuffer := Space(LINEA)

   nPos := FSeek(nHandle,0,FS_RELATIVE)
   nRead = FRead(nHandle, @cBuffer, LINEA)

   IF (nEol := At(CRLF, SubStr(cBuffer, 1, nRead))) # 0
      cBuffer := SubStr(cBuffer, 1, nEol - 1)
      FSeek(nHandle, nPos + nEol + 1, FS_SET)
   END IF

RETURN nRead != 0


// Funcin para el CodeBlock que posiciona en la ltima lnea
FUNCTION LastTxt()
   FSeek(nHandle, 0, FS_END)
   GoPrevLn()
RETURN NIL


// Funcin para el CodeBlock que salta lneas
FUNCTION SkipTxt(n)
   LOCAL nSaltados := 0

   IF n > 0
      
      WHILE nSaltados != n .AND. GoNextLn()
            nSaltados++
      END WHILE

    ELSE
      WHILE nSaltados != n .AND. GoPrevLn()
            nSaltados--
      END WHILE

   ENDIF

RETURN nSaltados


// Mueve a la siguiente lnea
FUNCTION GoNextLn()
   LOCAL nPos := FSeek(nHandle,0,FS_RELATIVE), ;
         cBuff := "", lMoved, nNewPos

   FSeek(nHandle, Len(cLine) + 2, FS_RELATIVE)
   nNewPos := FSeek(nHandle,0,FS_RELATIVE)

   IF FLine(nHandle, @cBuff)
      lMoved := .T.
      cLine := cBuff
      FSeek(nHandle, nNewPos, FS_SET)
    ELSE
      lMoved := .F.
      FSeek(nHandle, nPos, FS_SET)
   END IF

RETURN lMoved


// Mueve a la lnea anterior
FUNCTION GoPrevLn()
   LOCAL nPos := FSeek(nHandle,0,FS_RELATIVE), nMaxRead, nNewPos, ;
         lMoved, cBuff, nWhereCrLf, nPrev

   IF nPos == 0
      lMoved := .F.
    ELSE
      lMoved := .T.
      FSeek(nHandle, -2, FS_RELATIVE)
      
      IF nLong >= nPos                        //Controla finales de 
         IF FReadStr(nHandle,2) == CRLF       //fichero con CRLF,
            FSeek(nHandle, -2, FS_RELATIVE)   //Chr(26) o sin nada
         END IF   
      END IF

      nMaxRead := Min(LINEA, FSeek(nHandle,0,FS_RELATIVE))
      cBuff := Space(nMaxRead)
      nNewPos := FSeek(nHandle, -nMaxRead, FS_RELATIVE)
      FRead(nHandle, @cBuff, nMaxRead)
      nWhereCrLf := Rat(CRLF, cBuff)
      IF nWhereCrLf == 0
         nPrev := nNewPos
         cLine := cBuff
       ELSE
         nPrev := nNewPos + nWhereCrLf + 1
         cLine := SubStr(cBuff, nWhereCrLf + 2)
      END IF

      FSeek(nHandle, nPrev, FS_SET)
   END IF

RETURN lMoved