/*
  Tb16.prg .... Ejemplo de un TBrowse para seleccin de datos
                pasando a otro TBrowse los datos seleccionados

  (c) Grupo EIDOS, abril 1993

*/

#Include "Inkey.ch"

FUNCTION Tb16()
   // Construye las columnas
   LOCAL oCol1  := TBColumnNew("CODIGO", {|| If( AScan(aDirector       ,;
                                                 Director->CdDirec) # 0,;
                                                 " "+Director->CdDirec,;
                                                 "  "+Director->CdDirec)})
   LOCAL oCol2  := TBColumnNew("DIRECTOR", {|| Director->Director})

   LOCAL oSel1  := TBColumnNew("SELECCIONADOS",;
                               {|| aDirector[nIndice]})

   LOCAL oBrw   := TBrowseDB(5,2,13,50)   // Construye el TBrowse principal
   LOCAL oSel   := TBrowseNew(5,54,16,74) // Construye el TBrowse
                                          // con los seleccionados
        
    
   LOCAL cColor := SetColor("w/n")
   LOCAL nTecla, nPos
   LOCAL aDirector := {}    //Array para contener los datos marcados
   LOCAL nIndice   := 1

   SetBlink(.F.)
   CLS
   DispBox(4,1,14,51,1,"r/w*,gb+/b")

   USE Director INDEX I1Dire

   // Efectos especiales Browse principal
   oBrw:colorSpec("r/w*,gb+/b")
   oBrw:colSep   := "  "
   oBrw:headSep  := ""

   // Efectos especiales Browse seleccionados
   oSel:colorSpec("b/bg*,r/w*")
   oSel:colSep   := "  "
   oSel:headSep  := ""

   // CodeBlocks de movimiento para Browse seleccionados
   oSel:goTopBlock    := { | | nIndice := 1 }
   oSel:goBottomBlock := { | | nIndice := Len( aDirector ) }
   oSel:skipBlock     := { |n| PasArray( n, LEN( aDirector ),;
                                                   @nIndice ) }

   // Carga las columnas los Browses
   oBrw:addColumn(oCol1)
   oBrw:addColumn(oCol2)
   oSel:addColumn(oSel1)


   // Bucle de proceso
   WHILE .T.
      
      nTecla := TbStd(oBrw)           // Teclas automatizadas
      IF nTecla == K_ESC              // Browse principal
         EXIT

       ELSEIF nTecla == K_SPACE       // Esta tecla marca el dato
         
         nPos := AScan(ADirector, Director->CdDirec)
         IF  nPos # 0                 // quita la marca si ya la tiene
             ADel(aDirector, nPos)
             ASize(aDirector, Len(aDirector)-1)
             IF Len(aDirector) == 0   // Si quitamos todas las marcas
                @ 4,53 CLEAR TO 17,75 // borramos la ventana de
             END IF                   // los seleccionados
          ELSE
             AAdd(aDirector, Director->CdDirec)  // pone la marca
             ASort(aDirector)
         END IF
         oBrw:refreshCurrent()
         IF Len(aDirector) # 0        // Si ya hay seleccionados
            DispBox(4,53,17,75,1,"b/bg*,r/w*")
            oSel:refreshAll()
            oSel:forceStable()
         END IF


       ELSEIF nTecla == K_TAB         // Pasamos el control al Browse
                                      // de seleccionados
         IF Len(aDirector) == 0
            Alert("No hay datos seleccionados")
            LOOP
         END IF
         
         oBrw:deHilite()
         oSel:refreshAll()
         oSel:forceStable()
   
         // Bucle de proceso Browse de seleccionados
         WHILE .T.
      
           nTecla := TbStd(oSel)           // Teclas automatizadas
                                           // Browse de seleccionados
           IF nTecla == K_TAB
              oSel:deHilite()
              EXIT

           END IF

         END WHILE

         oBrw:hilite()

      END IF

   END WHILE
      
   SetColor(cColor)
   CLS
RETURN NIL