/*
  Tb17.prg .... Ejemplo de un TBrowse simple con edicin
                e insercin de registros

  (c) Grupo EIDOS, abril 1993

*/

#Include "Inkey.ch"
#Include "SetCurs.ch"

FUNCTION Tb17()
   // Construye las columnas
   LOCAL oCol1   := TBColumnNew("CODIGO", FieldBlock("CdDirec"))
   LOCAL oCol2   := TBColumnNew("NOMBRE", FieldBlock("Director"))
   LOCAL oCol3   := TBColumnNew("PAIS",   FieldBlock("Nacion"))

   LOCAL oBrw    := TBrowseDB(5,2,15,50) // Construye el TBrowse
    
   LOCAL cColor  := Select("w/n")
   LOCAL nKey,oGet,xOldKey,xNewKey
   LOCAL bAppend := {|| Append(oBrw) }
   LOCAL nCursor := SetCursor(SC_NONE)

   SetBlink(.F.)
   Set(_SET_DELETED, .T.)
   Set(_SET_SCOREBOARD, .F.)

   CLS
   DispBox(4,1,16,51,1,"r/w*,gb+/b")

   USE Director INDEX I1Dire, I2Dire, I3Dire

   
   // Efectos especiales
   oBrw:colorSpec("r/w*,gb+/b")
   oBrw:colSep   := "  "
   oBrw:headSep  := ""

   // Carga las columnas al TBrowse
   oBrw:addColumn(oCol1)
   oBrw:addColumn(oCol2)
   oBrw:addColumn(oCol3)

   // Bucle de proceso
   WHILE .T.
      
      nKey := TbStd(oBrw,,bAppend)       // Teclas automatizadas
      IF nKey == K_ESC
         EXIT

       ELSEIF nKey == K_DEL
         Director->(DbDelete())
         IF oBrw:rowPos == 1
            oBrw:up()
         END IF
         oBrw:refreshAll()

       ELSEIF nKey == K_ENTER
         
         // Proceso de edicin. Controla el movimiento de la clave 
         // cuando el nuevo valor tecleado altera la posicin
         // del registro
         SetCursor(SC_NORMAL)
         xOldKey := If( Empty(IndexKey()), NIL, &(IndexKey()) )
         
         oGet := GetNew(row(),col(),;
                        oBrw:getColumn(oBrw:colPos):block)
         ReadModal({oGet})
         SetCursor(SC_NONE)

         xNewKey := If( Empty(IndexKey()), NIL, &(IndexKey()) )

         IF xOldKey != xNewKey
            oBrw:refreshAll()

            WHILE &(IndexKey()) > xNewKey .AND. !oBrw:hitTop()
              oBrw:up()
            END WHILE
            oBrw:forceStable()
          
          ELSE
            oBrw:refreshCurrent()
            oBrw:forceStable()

         END IF

      END IF

   END WHILE
      
   Select(cColor)
   SetCursor(nCursor)
   CLS
RETURN NIL   


// Funcin para insertar registros
FUNCTION Append(oBrw)
   LOCAL GetList  := {}
   LOCAL CdDirec  := Space(3)
   LOCAL Director := Space(35)
   LOCAL Nacion   := Space(2)
   LOCAL cColor   := SetColor("n/gb,gb+/b")

   SetCursor(SC_NORMAL)
   Tone(450,1)
   Tone(300,1)

   DispBox(18,1,23,51,1,"n/gb,gb+/b")
   @ 19,2 CLEAR TO 22,50

   @ 20,2 SAY "Cdigo..: " GET CdDirec PICTURE "999";
                           VALID !Director->(DbSeek(CdDirec))
   @ 21,2 SAY "Nombre..: " GET Director PICTURE "@!"
   @ 22,2 SAY "Pas....: " GET Nacion PICTURE "@!"
   READ

   IF LastKey() # K_ESC
      Director->(DbAppend())
      Director->CdDirec  := CdDirec
      Director->Director := Director
      Director->Nacion   := Nacion

      oBrw:refreshAll()
      oBrw:forceStable()

   END IF
     
   SetCursor(SC_NONE)
   SetColor(cColor)
   @ 18,1 CLEAR TO 23,51

RETURN NIL   