/*
  Tb18.prg .... Ejemplo de un TBrowse para arrays bidemensionales

  (c) Grupo EIDOS, abril 1993

*/

#Include "Inkey.ch"
#Include "SetCurs.Ch"

FUNCTION Tb18()
   LOCAL aOpciones := {{"1","Uno","AAAAAAA"}    ,;
                       {"2","Dos","BBBBBBB"}    ,;
                       {"3","Tres","CCCCCCC"}   ,;
                       {"4","Cuatro","DDDDDDD"} ,;
                       {"5","Cinco","EEEEEEEE"}}

   LOCAL cColor := "W+/BG, GB+/B,,,,W/BG, GB/B"
   LOCAL oColumn1,oColumn2,oColumn3
   LOCAL cCurColor := SetColor("w/n")
   LOCAL oBrw   := TBrowseNew(2,2,10,30) // Construye el TBrowse
    
   LOCAL nTecla, nIndice := 1
   LOCAL nCursor := SetCursor(SC_NONE)

   // Construye las columnas
   oColumn1      := TBColumnNew("",{|| aOpciones[nIndice,1]})
   oColumn2      := TBColumnNew("",{|| aOpciones[nIndice,2]})
   oColumn3      := TBColumnNew("",{|| aOpciones[nIndice,3]})
   oColumn2:width := 6

   SetBlink(.F.)
   CLS
   DispBox(1,1,11,31,1, cColor)

   // Efectos especiales
   oBrw:colorSpec(cColor)


   //CodeBlock de movimiento
   oBrw:goTopBlock    := { | | nIndice := 1 }
   oBrw:goBottomBlock := { | | nIndice := LEN( aOpciones ) }
   oBrw:skipBlock     := { |n| PasArray( n, LEN( aOpciones ),;
                                                   @nIndice ) }

   // Carga las columnas al TBrowse
   oBrw:addColumn(oColumn1)
   oBrw:addColumn(oColumn2)
   oBrw:addColumn(oColumn3)

   // Bucle de proceso
   WHILE .T.
      
      nTecla := TbStd(oBrw)       // Teclas automatizadas
      IF nTecla == K_ESC
         EXIT
      END IF

   END WHILE
      
   SetColor(cCurColor)
   SetCursor(nCursor)
   CLS
RETURN NIL   