/*
  Tb3.prg .... Movimiento de un TBrowse
  (c) Grupo EIDOS, abril 1993

*/

#Include "Inkey.ch"

FUNCTION Tb3()
   // Construye las columnas
   LOCAL oCol1  := TBColumnNew("CODIGO", {|| Director->CdDirec})
   LOCAL oCol2  := TBColumnNew("NOMBRE", {|| Director->Director})
   LOCAL oCol3  := TBColumnNew("PAIS",   {|| Director->Nacion})

    
   LOCAL cColor := SetColor("w/n")
   LOCAL nTecla
   LOCAL nTopRow    := 5
   LOCAL nTopCol    := 2
   LOCAL nBottomRow := nTopRow + 12
   LOCAL nBottomCol := nTopCol + 47

   LOCAL oBrw   := TBrowseDB(nTopRow,;
                             nTopCol,;
                             nBottomRow,;
                             nBottomCol)   // Construye el TBrowse
                
   LOCAL lMoved := .F.

   SetBlink(.F.)
   CLS
   DispBox(nTopRow-1,;
           nTopCol-1,;
           nBottomRow+1,;
           nBottomCol+1,1,"r/w*,gb+/b")

   USE Director INDEX I1Dire

   // Efectos especiales
   oBrw:colorSpec("r/w*,gb+/b")
   oBrw:colSep   := "  "
   oBrw:headSep  := ""

   // Carga las columnas al TBrowse
   oBrw:addColumn(oCol1)
   oBrw:addColumn(oCol2)
   oBrw:addColumn(oCol3)

   // Bucle de proceso
   WHILE .T.
      
      lMoved := .F.
      nTecla := TbStd(oBrw)
      DO CASE
         CASE nTecla == K_ESC
              EXIT

         // Lo muevo hacia abajo
         CASE nTecla == K_ALT_DOWN
              IF oBrw:nBottom < MaxRow()-1
                 oBrw:nBottom := oBrw:nBottom+1   
                 oBrw:nTop    := oBrw:nTop+1   
                 lMoved       := .T.
              END IF

         // Lo muevo hacia arriba
         CASE nTecla == K_ALT_UP
              IF oBrw:nTop > 1
                 oBrw:nBottom := oBrw:nBottom-1   
                 oBrw:nTop    := oBrw:nTop-1   
                 lMoved       := .T. 
              END IF

         // Lo muevo hacia la izquierda
         CASE nTecla == K_ALT_LEFT
              IF oBrw:nLeft > 1
                 oBrw:nLeft   := oBrw:nLeft-1   
                 oBrw:nRight  := oBrw:nRight-1
                 lMoved       := .T.
              END IF
              
         // Lo muevo hacia la derecha
         CASE nTecla == K_ALT_RIGHT
              IF oBrw:nRight < MaxCol()-1
                 oBrw:nLeft   := oBrw:nLeft+1   
                 oBrw:nRight  := oBrw:nRight+1
                 lMoved       := .T.
              END IF
                 
      END CASE

      // Vuelve a mostrar el objeto con la nueva configuracin
      IF lMoved
         CLS
         DispBegin()
         DispBox(oBrw:nTop-1,;
                 oBrw:nLeft-1,;
                 oBrw:nBottom+1,;
                 oBrw:nRight+1,1,"r/w*,gb+/b")
         oBrw:forceStable()
         DispEnd()
      END IF

   END WHILE
      
   SetColor(cColor)
   CLS
RETURN NIL   