#include "fileio.ch"
#define  BUFFER (62*1024)

//
FUNCTION FGoTop( nHandle )
RETURN FSeek( nHandle, 0, FS_SET )

//
FUNCTION FGoBottom( nHandle )
RETURN FSeek( nHandle, 0, FS_END )

//
FUNCTION FPos( nHandle )
RETURN FSeek( nHandle, 0, FS_RELATIVE )

//
FUNCTION FSize( nHandle )
LOCAL nPosActual:=FPos( nHandle ), nFSize := FSeek(nHandle, 0 , FS_END)
FSeek( nHandle, nPosActual, FS_SET )
RETURN nFSize

//
FUNCTION FEof( nHandle )
RETURN FPos( nHandle ) == FSize( nHandle )

//
FUNCTION FCopy( cFicDesde, cFicHasta, nBuffer )
LOCAL nLeidos := 1, cBuffer := Space( nBuffer )    , ;
      nHandleDesde := FOpen( cFicDesde, FO_SHARED ), ;
      nHandleHasta := FCreate( cFicHasta )

WHILE nLeidos > 0
   nLeidos := FRead( nHandleDesde, @cBuffer, Len( cBuffer ) )
   FWrite( nHandleHasta, cBuffer, nLeidos )
END

FClose( nHandleDesde  )
FClose( nHandleHasta )
RETURN FError()

//
FUNCTION FLocate( nHandle, cPalabra )
LOCAL nPos := 0, n := 0, cBuffer := Space( BUFFER ), lFound := .F.

// Mientras no termine de ver el fichero
FOR n := 0 TO FSize( nHandle ) / BUFFER - 1
    // Bucle para extraer una palabra del fichero
    FRead( nHandle, @cBuffer, BUFFER )
    IF (nPos := AT(cPalabra, cBuffer) ) <> 0
       lFound := .T.
       EXIT
    END IF
NEXT

IF !lFound
   cBuffer := SPACE( FSIZE( nHandle ) % BUFFER )
   FRead( nHandle, @cBuffer, Len(cBuffer) )
   lFound := ( (nPos := AT(cPalabra, cBuffer) ) <> 0 )
END IF

IF lFound
   FSEEK( nHandle, nPos + (n * BUFFER) - 1 )
END IF

RETURN lFound

// Salvar pantalla a disco
FUNCTION FSaveScreen( nFilaS, nColS, nFilaI, nColI, cFichero )
LOCAL nHandle := FCreate( cFichero )

 FWrite( nHandle, SaveScreen( nFilaS, nColS, nFilaI, nColI ) )

RETURN FClose( nHandle )

// Restaurar pantalla desde disco
FUNCTION FRestScreen( nFilaS, nColS, nFilaI, nColI, cFichero )
LOCAL nHandle := FOpen( cFichero ), cPant := Space( 4000 )

 FRead( nHandle, @cPant, 4000 )
 RestScreen( nFilaS, nColS, nFilaI, nColI, cPant )

RETURN FClose( nHandle )