#include "Inkey.ch"
#include "Box.ch"

//
FUNCTION Ayuda()
LOCAL nAntReg, cTexto
LOCAL nAntAyuda := SetAyuda()     // Salvar la ayuda anterior 
                                  // por si se cambia a travs
                                  // de Indice() o Ademas()

// Funcin que visualizar la lista de ayudas relacionadas
LOCAL bKeyF2 := SetKey( K_F2, { || Ademas->( VerAdemas() )} )

// Variables que guardan entorno anterior
LOCAL nAntCursor   := SetCursor( 1 ) ,;
      cAntColor    := SetColor()     ,;
      cAntPantalla := SaveScreen()   ,;
      nFila        := Row()          ,;
      nCol         := Col()

 // Funcin que visualizar el Indice. De camino se anula [F1]
 // como tecla de ayuda evitando la recur sividad.
 SetKey( K_F1, { || Ayuda->( Indice() ) } )

 // Nota: Segn este sistema, los ficheros de ayuda deben 
 // estar previamente abiertos desde nuestra aplicacin.

 // Nos posicionamos en la ayuda actual
 IF !Ayuda->( DbSeek( SetAyuda( ) ) )
    IF SetEdit()                     // Si la ayuda no existe,
       Ayuda->( DbAppend() )         // Aadir un registro en
       Ayuda->NuAyuda := SetAyuda()  // blanco
       // Aqu podra recogerse el ttulo de la ayuda y sus
       // posibles relaciones
    ELSE
       Alert( 'No existe la ayuda' )
    END IF
 END IF

 @ 2, 2, 21, 77 BOX B_SINGLE + CHR( 32 )
 WHILE !Ayuda->( EOF() ) .AND. LastKey() != K_ESC

   @ 2, 2, 21, 77 BOX B_SINGLE + CHR( 32 )
   @ 2, 4 SAY " " + RTrim( Ayuda->Titulo ) + " "
   nAntReg := Ayuda->(RecNo())  // Guardar el registro actual
   cTexto := MemoEdit(Ayuda->Texto,3,3,20,76,SetEdit())

   // Si se puede grabar, no se ha cambiado de registro y no se ha pulsado [ESC]
   // se graban los cambios del texto
   IF SetEdit() .AND. Ayuda->( RecNo() ) == nAntReg .AND. LastKey()<>K_ESC
      Ayuda->Texto := cTexto
   END IF

 END WHILE

 // Restaurar entorno anterior
 SetAyuda( nAntAyuda )            // Restaurar ayuda por si
                                  // se ha cambiado

 SetKey( K_F1, { || Ayuda() } )   // Restaurar [F1] como tecla
                                  // de ayuda

 SetKey( K_F2, bKeyF2 )           // Restaurar [F2] por si
                                  // estaba definida

 SetCursor( nAntCursor )          // Restaurar forma del
                                  // cursor
 SetColor( cAntColor )            // Restaurar color
 RestScreen( ,,,, cAntPantalla )  // Restaurar pantalla 
 DevPos( nFila, nCol )            // Restaurar posicin del
                                  // cursor

RETURN NIL 


//
STATIC FUNCTION Indice()
LOCAL oTbIndice := TBrowseDb( 5, 5, 16, 60 ), ;
      nTecla, nActAyuda := Ayuda->NuAyuda

 oTbIndice:AddColumn( TbColumnNew( , { || Ayuda->Titulo } ) )
 oTbIndice:goTop()

 SetKey( K_F1, NIL )              // Evitar la recursividad

 SetCursor( 0 )
 @ 4, 4, 17, 61 BOX B_SINGLE + CHR( 32 )
 @ 4, 6 SAY " Indice de Ayudas "
 WHILE .T.
   DispBegin()
   WHILE NextKey() == 0 .AND. !oTbIndice:stabilize() ; END
   DispEnd()

   nTecla := InKey( 0 )

   DO CASE
    CASE nTecla == K_DOWN      ; oTbIndice:down()
    CASE nTecla == K_UP        ; oTbIndice:up()
    CASE nTecla == K_PGDN      ; oTbIndice:pageDown()
    CASE nTecla == K_PGUP      ; oTbIndice:pageUp()
    CASE nTecla == K_HOME      ; oTbIndice:home()
    CASE nTecla == K_END       ; oTbIndice:end()
    CASE nTecla == K_CTRL_HOME ; oTbIndice:panHome()
    CASE nTecla == K_CTRL_END  ; oTbIndice:panEnd()
    CASE nTecla == K_CTRL_PGDN ; oTbIndice:goBottom()
    CASE nTecla == K_CTRL_PGUP ; oTbIndice:goTop()
    CASE nTecla == K_ESC       
         Ayuda->( DbSeek( nActAyuda ) )
         EXIT
    CASE nTecla == K_ENTER     ; EXIT
   END CASE

 END WHILE

 SetKey( K_F1, { || Ayuda->( Indice() ) } ) // Restaura [F1]
                                            // como tecla de
                                            // Indice

 KEYBOARD Chr( K_CTRL_W )                   // Para salir de
                                            // MemoEdit()

 SetCursor( 1 )

RETURN NIL


//
STATIC FUNCTION VerAdemas()
LOCAL oTbAdemas := TBrowseNew( 7, 7, 18, 62 ), nTecla, ;
      nActAyuda := Ayuda->NuAyuda

 IF Ademas->( DbSeek( nActAyuda ) )
   SetKey( K_F2, NIL )              // Evitar la recursividad
   SetCursor( 0 )

   // Inicializacin del objeto TBrowse para VerAdemas()
   oTbAdemas:AddColumn(TbColumnNew(                         ,;
                       {|| Ayuda->(DbSeek(Ademas->NuAdemas)),;
                           Ayuda->Titulo } ) )

   oTbAdemas:goTopBlock := {|| Ademas->(DbSeek(nActAyuda))}
   oTbAdemas:goBottomBlock := { || Ademas->(IrFin(nActAyuda))}
   oTbAdemas:skipBlock := ;
     {|n| Ademas->(IrA(n, {|| nActAyuda==Ademas->NuAyuda} ) )}

   // Pantalla
   @ 6, 6, 19, 63 BOX B_SINGLE + CHR( 32 )
   @ 6, 8 SAY " Ver tambin "

   // Proceso
   WHILE .T.
     DispBegin()
     WHILE NextKey() == 0 .AND. !oTbAdemas:stabilize() ; END
     DispEnd()

     nTecla := InKey( 0 )

     DO CASE
      CASE nTecla == K_DOWN      ; oTbAdemas:down()
      CASE nTecla == K_UP        ; oTbAdemas:up()
      CASE nTecla == K_PGDN      ; oTbAdemas:pageDown()
      CASE nTecla == K_PGUP      ; oTbAdemas:pageUp()
      CASE nTecla == K_HOME      ; oTbAdemas:home()
      CASE nTecla == K_END       ; oTbAdemas:end()
      CASE nTecla == K_CTRL_HOME ; oTbAdemas:panHome()
      CASE nTecla == K_CTRL_END  ; oTbAdemas:panEnd()
      CASE nTecla == K_CTRL_PGDN ; oTbAdemas:goBottom()
      CASE nTecla == K_CTRL_PGUP ; oTbAdemas:goTop()
      CASE nTecla == K_ESC       
           Ayuda->(DbSeek( nActAyuda)) 
           EXIT
      CASE nTecla == K_ENTER     ; EXIT
     END CASE

   END WHILE

   SetKey( K_F2, { || Ademas->( VerAdemas() ) } )
   KEYBOARD Chr( K_CTRL_W )
   SetCursor( 1 )
 END IF

RETURN NIL

//
FUNCTION SetAyuda( nActAyuda )
 STATIC nAyuda    := 1
 LOCAL  nAntAyuda := nAyuda

 nAyuda := If(ValType(nActAyuda) == "N", nActAyuda, nAyuda)

RETURN nAntAyuda

//
FUNCTION SetEdit( lActEdit )
STATIC lEdit    := .F.
LOCAL  lAntEdit := lEdit

 lEdit := If( ValType(lActEdit) == "L", lActEdit, lEdit )

RETURN lAntEdit


/***
*  FUNCIONES PARA EL MOVIMIENTO DE TBROWSE CON FILTRO
*
*/
//
STATIC FUNCTION IrFin( xExpr )
 DbSeek( xExpr + 1, .T. )
 DbSkip( -1 )
RETURN NIL

//
STATIC FUNCTION IrA( n, bWhile )
LOCAL nSalto := 0, nDireccion := If( n > 0, 1, -1)

 WHILE nSalto != n .AND. Eval( bWhile ) .AND. ;
       !EOF()      .AND. !BOF()

  DbSkip( nDireccion )
  nSalto += nDireccion

 END WHILE

 DO CASE
    CASE EOF()
         DbSkip( -1 )
         nSalto += -nDireccion

    CASE BOF()
         DbGoTo( RecNo() )
         nSalto++

    CASE !Eval( bWhile )
         DbSkip( -nDireccion )
         nSalto += -nDireccion

 END CASE

RETURN nSalto
