/*
   MULTBLO3.PRG

   Ejemplos de multibloqueo.

   Este ejemplo bloquear los registros que cumplan la
   condicin especificada, y luego, visualizar un array
   con todos los registros bloqueados.

   (c) Grupo EIDOS. Abril 1993
*/
FUNCTION Main()
   LOCAL nAux
   LOCAL aTabLock := {}
   CLS

   IF !NetUse( 'USUARIOS', .F., 10 )
      ? 'Error de apertura de fichero'
   END IF

   // Bloqueo de registros que cumplen una determina condicin
   Usuarios->(DbEval( {|| DbRLock( RecNo() ) } ,;
                      {|| !Empty( Usuarios->Clave ) } ) )

   aTabLock := Usuarios->(DbRLockList())

   IF Len( aTabLock ) == 0
      ? 'Este terminal no tiene ningn registro bloqueado'
   END IF

   // Visualizar array con registros bloqueados
   FOR nAux := 1 TO Len( aTabLock )
       ? 'Registro ', aTabLock[ nAux ], ' bloqueado'
   NEXT

   InKey(0)
RETURN NIL

