/*
   MULTBLO6.PRG

   Ejemplos de multibloqueo.

   Este ejemplo bloquear los registros que cumplan la
   condicin especificada mediante una funcin de usuario
   a la que se le pasa un array con los registros a
   bloquear.

   (c) Grupo EIDOS. Abril 1993
*/
FUNCTION Main()
   LOCAL nAux
   LOCAL aTabla := {}
   CLS

   IF !NetUse( 'USUARIOS', .F., 10 )
      ? 'Error de apertura de fichero'
   END IF

   // Preparar el array que se pasar como
   // parmetro con los registros que cumplen
   // una determina condicin
   Usuarios->(DbEval( {|| AADD( aTabla, RecNo() )   }  ,;
                      {|| !Empty( Usuarios->Clave ) } ) )

   IF !Usuarios->(MultiBlo( aTabla ))
      ? 'Imposible bloquear los registros especificados'
   ELSE
      ? 'TODO OK'
   END IF


   InKey(0)
RETURN NIL

FUNCTION MultiBlo( aArray )
   LOCAL nAux

   // Bloqueo de registros que cumplen una determina condicin
   FOR nAux := 1 TO Len( aArray )
       IF !DbRLock( aArray[ nAux ] )
          RETURN .F.
       END IF
   NEXT
RETURN .T.


