#Include "FileIO.ch"
#Define   BUFFER     (10*1024)

// Funcin que cuenta el nmero de ocurrencias de una subcadena en una
// cadena
FUNCTION StrCount( cCad1, cCad2, nPos)
   LOCAL nContador

   // Control de parmetros opcionales
   IF nPos = NIL
      nPos := 1
   END IF

   // Control del tipo de los parmetros
   IF ValType( cCad1 ) # "C" .OR. ;
      ValType( cCad2 ) # "C" .OR. ;
      ValType( nPos )  # "N"
      RETURN -1
   END IF

   // Si alguna de las cadenas est vaca no la
   // encuentra y no seguimos ms
   IF Len( cCad2 ) = 0 .OR. Len( cCad1 ) = 0
      RETURN 0
   END IF

   // Proceso
   nContador := 0
   WHILE nPos <= Len( cCad1 )
      IF SubStr( cCad1, nPos, Len( cCad2 )) = cCad2
         ++nContador
         nPos += Len( cCad2 )
       ELSE
         ++nPos
      END IF
   END WHILE

RETURN nContador


// Funcin para localizar una cadena dentro de un fichero
FUNCTION FLocate( nHandle, cPalabra )
LOCAL nPos:=0, n:=0, cBuffer:=Space( BUFFER ), lFound := .F.

FOR n := 0 TO FSize( nHandle ) / BUFFER - 1
    FRead( nHandle, @cBuffer, BUFFER )
    IF (nPos := At(cPalabra, cBuffer) ) <> 0
       lFound := .T.
       EXIT
    END IF
NEXT

IF !lFound
   cBuffer := Space( FSize( nHandle ) % BUFFER )
   FRead( nHandle, @cBuffer, Len(cBuffer) )
   lFound := ( (nPos := At(cPalabra, cBuffer) ) <> 0 )
END IF

IF lFound
   FSeek( nHandle, nPos + (n * BUFFER) - 1 )
END IF

RETURN lFound


// Funcin usada por FLocate()
STATIC FUNCTION FSize( nHandle )

// Guarda la posicin actual y se va al fin de fichero
// Guarda el nmero de la ltima posicin (longitud del
// fichero) y restaura el puntero en su posicin
// anterior.
// Se usa la funcin anterior FPOS()

LOCAL nPosActual:=FPos( nHandle ), ;
      nFSize := FSeek(nHandle, 0 , FS_END)

 FSeek( nHandle, nPosActual, FS_SET )

RETURN nFSize


// Funcin usada por FLocate()
FUNCTION FPos( nHandle )
   //Se mueve 0 bytes de la posicin actual y devuelve sta
RETURN FSeek( nHandle, 0, FS_RELATIVE )

//////////////////////////////////////////////////////////////////
///////////////Funcin para imprimir los cdigos de escape ///////
//////////////////////////////////////////////////////////////////
FUNCTION Tipo(cLetra)
  LOCAL Start := 1           // Escapes->Valor se analiza desde Start
  LOCAL End   := 0           // Hasta End
  LOCAL Pos   := 0           // Posiciones para cada cdigo
  LOCAL cCad  := ""          // Recoge la secuencia completa a imprimir

  Escapes->(DbSeek(Str(Impres->NmImp,3)+cLetra))
  End := At(" ", Escapes->Valor)
  Pos := End

  // Se recorre Escapes->Valor para construir la secuencia de escape
  WHILE Pos # 0
    cCad+=Chr(Val(SubStr(Escapes->Valor, Start, Pos)))
    Start := End+1
    End   += At(" ",SubsTr(Escapes->Valor, Start))
    Pos   := End-Start
  END WHILE

RETURN cCad
