#include "Inkey.ch"

/*
*
  !ojo!.- En esta nueva versin lModo .T. -> MODO COMPARTIDO
                                      .F. -> MODO EXCLUSIVO
*
*/
FUNCTION AbreDbf( cFichero,lModo,nTiempo,lArea )
  // lArea -> Indicar si se desea abrir en un rea nueva
  //          .t. -> NEW
  // Por defecto en nueva area
  LOCAL lControl,cPantal,nVpos

  // Comprobacin de parmetros
  IF VALTYPE( cFichero ) != "C" .OR.;
     VALTYPE( lModo )    != "L" .OR.;
     VALTYPE( nTiempo )  != "N"
     RETURN ( .F. )
  ENDIF

  IF VALTYPE( lArea ) != 'L'
     lArea := .T.
  END IF

  // Comprueba la extensin del fichero
  IF RIGHT( cFichero,4 ) != ".DBF"
     cFichero += ".DBF"
  ENDIF

  // Comprueba la existencia del fichero
  IF !FILE( cFichero )
     RETURN ( .F. )
  ENDIF

  // Para diferenciar si es tiempo indefinido
  lControl := IIF( nTiempo == 0 , .T. , .F. )

  cPantal := SAVESCREEN( 12,20,14,61 )
  WHILE nTiempo > 0 .OR. lControl
     DBUSEAREA( lArea,,cFichero,,lModo )

     IF !NETERR()          // Si no hay ningn tipo de error
        EXIT
     END IF

     INKEY( 1 )

     // Se activa pantalla de visualizacin
     IF LASTKEY( ) == K_ENTER
        // Mostramos el nombre del fichero
        nVpos := RAT( "\",cFichero )
        IF nVpos == 0
           nVpos := RAT( ":",cFichero )
        END IF
        @ 12,20,14,61 BOX "Ŀ "
        @ 13,23 SAY "Intentado usar fichero  " +;
                    UPPER( SUBSTR( cFichero,nVpos+1 ) )
     END IF

     IF LASTKEY() == K_ESC
        EXIT
     END IF

     nTiempo--
  END

  RESTSCREEN(12,20,14,61,cPantal)

  IF !NETERR()
     RETURN ( .T. )
  ENDIF
RETURN (.F.)


/*
*
*
*/
FUNCTION BloqueaDbf( nTiempo )
  LOCAL lControl,cPantal

  // Comprobacin de si se ha pasado o no parmetro
  IF VALTYPE( nTiempo ) != "N"
     nTiempo := 0
  END IF

  // Se comprueba si existe fichero .DBF activo
  IF EMPTY( ALIAS( ) )
     RETURN ( .F. )
  END IF

  // Si el bloqueo tiene xito
  IF FLOCK()
     RETURN ( .T. )
  END IF

  // Para diferenciar si es tiempo indefinido
  lControl := IIF( nTiempo == 0 , .T. , .F. )

  cPantal := SAVESCREEN( 12,20,14,61 )
  WHILE nTiempo > 0 .OR. lControl
     INKEY( 1 )

     // Se activa pantalla de visualizacin
     IF LASTKEY( ) == K_ENTER
        // Mostramos el nombre del fichero
        @ 12,20,14,61 BOX "Ŀ "
        @ 13,23 SAY "Intentado usar fichero  " +;
                    UPPER( ALIAS( ) )
     ENDIF

     nTiempo--

     IF LASTKEY() == K_ESC
        EXIT
     END IF

     // Si bloqueo tiene xito
     IF FLOCK( )
        RESTSCREEN( 12,20,14,61,cPantal )
        RETURN ( .T. )
     ENDIF
  END

  RESTSCREEN( 12,20,14,61,cPantal )
RETURN ( .F. )         // No se ha podido realizar el bloqueo


/*
*
*
*/
FUNCTION BloqueaReg( nTiempo )
  LOCAL lControl,cPantal

  // Comprobacin del tipo de parmetro
  IF VALTYPE( nTiempo ) != "N"
     nTiempo := 0
  END IF

  // Se comprueba si existe fichero .DBF activo
  IF EMPTY( ALIAS( ) )
     RETURN ( .F. )
  END IF

  // Si el bloqueo tiene xito
  IF RLOCK( )
     RETURN ( .T. )
  END IF

  // Para diferenciar si es tiempo indefinido
  lControl := IIF( nTiempo == 0 , .T. , .F. )

  cPantal := SAVESCREEN( 12,15,14,58 )
  WHILE nTiempo > 0 .OR. lControl
     INKEY( 1 )

     // Se activa pantalla de visualizacin
     IF LASTKEY( ) == K_ENTER
        // Mostramos el nombre del fichero
        @ 12,15,14,58 BOX "Ŀ "
        @ 13,17 SAY "Intentado Bloquear Registro de " +;
                    UPPER( ALIAS( ) )
     END IF

     nTiempo--

     IF LASTKEY() == K_ESC
        EXIT
     END IF

     // Si el bloqueo tiene xito
     IF RLOCK( )
        RESTSCREEN( 12,15,14,58,cPantal )
        RETURN ( .T. )
     END IF
  END
  RESTSCREEN( 12,15,14,58,cPantal )
RETURN ( .F. )      // No se ha podido realizar el bloqueo



/*
*
*
*/
FUNCTION InsertaReg( nTiempo )
  LOCAL lControl,cPantal

  // Comprobacin del tipo de parmetro
  IF VALTYPE( nTiempo ) != "N"
     nTiempo := 0
  END IF

  // Se comprueba si existe fichero .DBF activo
  IF EMPTY( ALIAS( ) )
     RETURN ( .F. )
  END IF

  DBAPPEND()
  // Si no se ha producido error
  IF !NETERR( )
     RETURN ( .T. )
  ENDIF

  // Para diferenciar si es tiempo indefinido
  lControl := IIF( nTiempo == 0 , .T. , .F. )

  cPantal := SAVESCREEN( 12,15,14,58 )
  WHILE nTiempo > 0 .OR. lControl
     INKEY( 1 )

     // Se activa pantalla de visualizacin
     IF LASTKEY( ) == K_ENTER
        // Mostramos el nombre del fichero
        @ 12,15,14,58 BOX "Ŀ "
        @ 13,17 SAY " Intentado Aadir Registro a " +;
                    UPPER( ALIAS( ) )
     END IF

     IF LASTKEY() == K_ESC
        EXIT
     END IF

     nTiempo--

     DBAPPEND()
     // Si no se produce error
     IF !NETERR( )
        RESTSCREEN( 12,15,14,58,cPantal )
        RETURN ( .T. )
     ENDIF
  END
  RESTSCREEN( 12,15,14,58,cPantal )
RETURN ( .F. )      // No se pudo aadir nuevo registro