#include "Inkey.Ch"
#include "SetCurs.Ch"
#include "Set.Ch"
#define TRUE                    .T.
#define FALSE                   .F.
#define B_SIN                   CHR( 32) + CHR( 32) + CHR( 32) + CHR( 32) +   ;
                                CHR( 32) + CHR( 32) + CHR( 32) + CHR( 32) +   ;
                                CHR( 32)

#xcommand @ <top>, <left>, <bottom>, <right> BOX <string>                     ;
                                            [COLOR <color>]                   ;
                                            [TITLE <titulo>]                  ;
                                            [NOSHADOW]                        ;
      => DispBox(                                                             ;
                  <top>, <left>, <bottom>, <right>, <string>                  ;
                  [, <color> ]                                                ;
                )                                                             ;
       ; BoxTitulo( <top>, <left>, <right>, <titulo>, <color>, <string> )


#xcommand DEFAULT <xVar1> TO <xDefaultValue1>                                 ;
               [, <xVarN> = <xDefaultValueN> ] =>                             ;
                  <xVar1> = If( <xVar1> == nil, <xDefaultValue1>, <xVar1> );  ;
                [ <xVarN> = If( <xVarN> == nil, <xDefaultValueN>, <xVarN> );]


FUNCTION Main()
  // Objeto para el manejo de Impres.Dbf
  LOCAL oImpres  := TBrowseDB(2,2,15,37)
  LOCAL oColImp  := TbColumnNew(,{|| Impres->DsImp})

  // Objeto para el manejo de Escapes.Dbf
  LOCAL oEscapes := TBrowseNew(2,42,22,54)
  LOCAL oColEsc  := TbColumnNew(,{|| Escapes->Escape})

  // Varios
  LOCAL nTecla
  LOCAL cColor  := SetColor("w/n")
  LOCAL nCursor := SetCursor( SC_NONE )
  LOCAL cPant   := SaveScreen()

  // Datos y Mtodos adicionales para el objeto que maneja Escapes.Dbf
  oEscapes:addColumn(oColEsc)
  oEscapes:colorSpec := "w/bg*,bg/b*"
  oEscapes:goTopBlock    := {| | Escapes->(IrInicio(Str(Impres->NmImp,3)))}
  oEscapes:goBottomBlock := {| | Escapes->(IrFin   (Str(Impres->NmImp,3)))}
  oEscapes:skipBlock     := {|n| Escapes->(IrA     ( n,;
                               {|| Impres->NmImp == Escapes->NmImp }))}

  // Datos y Mtodos adicionales para el objeto que maneja Impres.Dbf
  oImpres:addColumn(oColImp)
  oImpres:colorSpec := "b/w*,r/bg*"

  CLS
  SetBlink(FALSE)
  Set(_SET_SCOREBOARD,"OFF")

  @ 1,1,16,38 BOX B_SIN TITLE "IMPRESORAS" COLOR "b/w*,r/rb*"
  @ 20,1 SAY "[Tab]   = Conmuta entre listas"
  @ 21,1 SAY "[Intro] = Imprime ejemplo"


  // Apertura de ficheros
  IF AbreDbf("Impres.Dbf",FALSE,0)           // Abre fichero Impresoras
     Impres->(DbSetIndex("I1Impr"))
   ELSE
     DevOut("Imposible abrir IMPRES.DBF")
     RETURN NIL
  ENDIF

  IF AbreDbf("Escapes.Dbf",FALSE,0)          // Abre ficheros de tipos
     Escapes->(DbSetIndex("I1Esca"))
   ELSE
     DevOut("Imposible abrir ESCAPES.DBF")
     RETURN NIL
  ENDIF


  // Proceso principal
  WHILE TRUE

    // TBrowse para las Impresoras
    nTecla := Impres->(TbStd(oImpres,{|| VerEscapes(oEscapes)}))
    DO CASE
       CASE nTecla == K_ESC
            EXIT
       CASE nTecla == K_TAB            // Llama al TBrowse de tipos,
                                       // cedindole el control
            oImpres:deHilite()         // Apaga barra del TBrowse
            Escapes->(EditEscapes(oEscapes))
    END CASE
  END WHILE

  SetColor(cColor)
  SetCursor(nCursor)
  DbCloseAll()
  RestScreen(,,,,cPant)
RETURN NIL


/*
  Funcin para visualizar los tipos de letra asociados a una impresora.
  A esta funcin se la evala cada vez que se estabiliza el TBrowse de
  impresoras para que aparezca otro TBrowse con los tipos asociados
*/

FUNCTION VerEscapes(oEscapes)

  oEscapes:goTop()      // Se posiciona en el tipo adecuado
                        // (primero del filtro)
  @ 1,41,23,55 BOX B_SIN TITLE "TIPOS" COLOR "w/bg*,bg/b*"

  WHILE !Escapes->(oEscapes:stabilize()); END WHILE
  oEscapes:deHilite()
RETURN NIL

/*
  Funcin para visualizar los tipos de letra, pero pasando a ser el
  TBrowse activo para poder movernos a travs del mismo. Con [Tab] o
  [Esc] se devuelve el control al TBrowse de impresoras
*/

FUNCTION EditEscapes(oEscapes)
  LOCAL nTecla

  oEscapes:goTop()            // Se posiciona en el tipo adecuado
                              // (primero del filtro)
   WHILE TRUE
     nTecla := Escapes->(TbStd(oEscapes))
     DO CASE
        CASE nTecla == K_ESC .OR. nTecla == K_TAB
          EXIT
        CASE nTecla == K_ENTER
          Set(_SET_DEVICE, "PRINTER")
          @ 22,10 SAY Tipo(Escapes->Escape)+ "Esto es un Ejemplo"
          Set(_SET_DEVICE, "SCREEN")
        OTHERWISE
          LOOP
     END CASE
   END WHILE

RETURN NIL


// Funcin para pintar cajas, con algunas adiciones
// Ver su preproces como @ .. BOX
FUNCTION BoxTitulo( nFila, nDesde, nHasta, cTitulo, cColor, cString )
LOCAL    cInvColor

IF cTitulo # NIL

   DEFAULT  cColor TO SETCOLOR()

   cColor := LEFT( cColor, At( ",", cColor ) - 1 )

   IF RIGHT( cColor, 1 ) == "*"
      cColor := LEFT( cColor, LEN( cColor ) - 1 ) + "+"
   END IF

   cInvColor := SUBSTR( cColor, AT( "/", cColor ) + 1 ) + "/" +             ;
                LEFT( cColor, AT( "/", cColor ) - 1 )

   IF RIGHT( cInvColor, 1 ) == "+"
      cInvColor := LEFT( cInvColor, Len(cInvColor) - 1 ) + "*"
   END IF

   IF !EMPTY( cString )
      @   nFila, (((nHasta - nDesde) - LEN( cTitulo ) ) / 2 ) + nDesde + 1  ;
      SAY cTitulo COLOR cInvColor

   ELSE
      @     nFila, nDesde                                                   ;
      SAY   PADC( cTitulo, nHasta - nDesde + 1, CHR( 32 ) )                 ;
      COLOR cInvColor

   END IF

END IF

RETURN NIL



/*
  Funciones para el movimiento de TBrowse con y sin filtros
  IrInicio() --> Va al principio del filtro
  IrFin()    --> Va al final del filtro
  IrA()      --> DbSkip() para filtros
  TbStd()    --> Control estndar de teclas

*/

//
FUNCTION IrInicio( xExpr )
 DbSeek( xExpr )
RETURN NIL

//
FUNCTION IrFin( xExpr )
LOCAL lSS := Set(_SET_SOFTSEEK, .T.)
 IF ValType( xExpr ) = "C"
    DbSeek( SubStr( xExpr, 1, Len( xExpr ) - 1 ) +;
            Chr( Asc( SubStr( xExpr, Len( xExpr ) ) ) + 1) )
 ELSE
    DbSeek( xExpr + 1 )
 END IF
 DbSkip(-1)

 Set(_SET_SOFTSEEK, lSS)
RETURN NIL

//
FUNCTION IrA( n, bWhile )
LOCAL nSkipped := 0, nDireccion := IF(n > 0, 1, -1)

 WHILE nSkipped != n .AND. Eval( bWhile ) .AND. !Eof() .AND. !Bof()
    DbSkip( nDireccion )
    nSkipped += nDireccion
 END WHILE

 DO CASE
    CASE Eof()
         DbSkip(-1)
         nSkipped += -nDireccion

    CASE Bof()
         DbGoto( RecNo() )
         nSkipped++

    CASE !Eval( bWhile )
         DbSkip(-nDireccion)
         nSkipped += -nDireccion

 END CASE

RETURN nSkipped


FUNCTION TbStd(oTb,bAccion)
   LOCAL nTecla

   WHILE TRUE

     DispBegin()
     WHILE  NextKey() == 0 .AND. !oTb:stabilize();  END WHILE
     DispEnd()

     IF bAccion # NIL
        Eval(bAccion)
     END IF

     nTecla := Inkey(0)

     DO CASE
        CASE nTecla == K_DOWN;                       oTb:down()
        CASE nTecla == K_UP;                         oTb:up()
        CASE nTecla == K_PGDN ;                      oTb:pageDown()
        CASE nTecla == K_PGUP ;                      oTb:pageUp()
        CASE nTecla == K_CTRL_PGUP ;                 oTb:goTop()
        CASE nTecla == K_CTRL_PGDN ;                 oTb:goBottom()
        OTHERWISE;                                   EXIT
     END CASE
   END WHILE

RETURN nTecla
///////////////Fin Funciones para el manejo de TBrowse  //////////
//////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////
///////////////Funcin para imprimir los cdigos de escape ///////
//////////////////////////////////////////////////////////////////
FUNCTION Tipo(Letra)
  LOCAL Start := 1           // Escapes->Valor se analiza desde Start
  LOCAL End   := 0           // Hasta End
  LOCAL Pos   := 0           // Posiciones para cada cdigo
  LOCAL cCad  := ""          // Recoge la secuencia completa a imprimir

  // Busca si existe el tipo de letra pasado e inicializa End y Pos
  Escapes->(DbSeek(Str(Impres->NmImp,3)+Letra))
  End := At(" ", Escapes->Valor)
  Pos := End

  // Se recorre Escapes->Valor para construir la secuencia de escape
  WHILE Pos # 0
    cCad+=Chr(Val(SubStr(Escapes->Valor, Start, Pos)))
    Start := End+1
    End   += At(" ",SubsTr(Escapes->Valor, Start))
    Pos   := End-Start
  END WHILE

RETURN cCad
