/*
   ERRORSYS.PRG

   ERRORSYS modificado partiendo del estndar

   Compilar /N/W

   Cuando se enlace con la aplicacin hay que tener presentes
   si se utiliza o no VERERROR.PRG

   (c) Grupo EIDOS. Febrero 1993
*/

#include "ERROR.CH"

#command ? <list,...>   =>  ?? Chr(13) + Chr(10) ; ?? <list>
#command ?? <list,...>  =>  OutErr(<list>)

#define NTRIM(n)                ( LTrim(Str(n)) )

/*
   ErrorSys()
*/

STATIC nNumero := 0    // Control de impresora

PROC ErrorSys()
   ErrorBlock( {|e| DefError(e)} )
RETURN

/*
   DefError()
*/
STATIC FUNCTION DefError( e )
   // Control de errores en el propio ERRORSYS
   LOCAL oErrAct := ErrorBlock( {|oError| OhError(oError)} )

   // Control de divisin por 0
   IF e:genCode == EG_ZERODIV
      ErrorBlock( oErrAct )     // Establecemos estndar
      RETURN (0)
   END IF

   // Control de apertura en red
   IF e:genCode == EG_OPEN .AND.;
      e:osCode  == 32      .AND.;
      e:canDefault

      ErrorBlock( oErrAct )     // Establecemos estndar

      NetErr( .T. )
      RETURN .F.
   END IF

   // Control de insercin de registros
   IF e:genCode == EG_APPENDLOCK .AND. e:canDefault
      ErrorBlock( oErrAct )     // Establecemos estndar

      NetErr( .T. )
      RETURN .F.
   END IF

   // Control de Impresora
   IF e:genCode == EG_PRINT .AND. ;
      e:canRetry            .AND. ;
      nNumero++ <= 10
      RETURN CtlImpre()
   END IF

   // Error desviado a fichero de LOG
   // !OJO! No se permite ningn tipo de recuperacin del
   // error

   CreaLog( e )

   // Si adems de grabar el error al fichero ERROR.LOG deseamos
   // que aparezca de la forma habitual que aparecen los errores
   // en Clipper, quitar comentario  a  las siguientes lneas de
   // cdigo
   //     // Generar mensaje de error
   //     cMessage := ErrorMessage(e)
   //
   //     // Generar array con distintas opciones
   //     aOptions := { "Salir" }
   //
   //     IF e:canRetry
   //        AAdd( aOptions, "Reintentar" )
   //     END IF
   //
   //     IF e:canDefault
   //        AAdd( aOptions, "Por defecto" )
   //     END IF
   //
   //     // Generar caja alert
   //     nChoice := 0
   //     WHILE nChoice == 0
   //           IF Empty( e:osCode )
   //              nChoice := Alert( cMessage, aOptions )
   //           ELSE
   //              nChoice := Alert( cMessage + ;
   //                                ";(DOS Error " + NTRIM(e:osCode) + ")",;
   //                                aOptions )
   //           END IF
   //
   //           IF nChoice == NIL  // Si se pulsa ESC
   //               EXIT
   //           END
   //     END
   //
   //     IF !Empty( nChoice )
   //        IF aOptions[nChoice] == "Break"
   //           Break( e )
   //        ELSEIF aOptions[nChoice] == "Reintentar"
   //           RETURN .T.
   //        ELSEIF aOptions[nChoice] == "Por Defecto"
   //           RETURN .F.
   //        END
   //     END
   //
   //     // Visualizar mensaje de error en pantalla
   //     IF !Empty( e:osCode )
   //        cMessage += " (DOS Error " + NTRIM( e:osCode ) + ") "
   //     END IF
   //
   //     ? cMessage
   //     i := 2
   //     WHILE ( !Empty(ProcName(i)) )
   //           ? "Called from", Trim( ProcName( i ) ) + ;
   //             "(" + NTRIM( ProcLine( i ) ) + ")  "
   //           i++
   //     END

   // Si queremos utilizar el visualizador de errores del fichero
   // ERROR.LOG durante los procesos de desarrollo incluiremos

   VerError()

   // y acabado el desarrollo, lo eliminaremos de ERRORSYS y lo
   // prepararemos con ejecutable para poder visualizar los errores
   // en fases distintas a las de desarrollo.

   // Salida
   ErrorLevel(1)
   QUIT
RETURN .F.
//

/*
   ErrorMessage()

   Generar el mensaje de error
*/
STATIC FUNCTION ErrorMessage(e)
   LOCAL cMessage
   LOCAL aTexto := {                                       ;
                     'Error en parmetros'                ,;
                     'Error de lmites'                   ,;
                     'Desbordamiento de cadena'           ,;
                     'Desbordamiento nmerico'            ,;
                     'Divisin por 0'                     ,;
                     'Error numrico'                     ,;
                     'Error de sintaxis'                  ,;
                     'Operacin demasiado compleja'       ,;
                     ''                                   ,;
                     ''                                   ,;
                     'No hay memoria'                     ,;
                     'Funcin sin definir'                ,;
                     'Mensaje sin definir'                ,;
                     'La variable no existe'              ,;
                     'No existe el alias'                 ,;
                     ''                                   ,;
                     ''                                   ,;
                     ''                                   ,;
                     ''                                   ,;
                     'Error de creacin'                  ,;
                     'Error de apertura'                  ,;
                     'Error al cerrar'                    ,;
                     'Error al leer'                      ,;
                     'Error al escribir'                  ,;
                     'Error al imprimir'                  ,;
                     ''                                   ,;
                     ''                                   ,;
                     ''                                   ,;
                     ''                                   ,;
                     'Operacin no soportada'             ,;
                     'Lmite excedido'                    ,;
                     'Corrupcin detectada'               ,;
                     'Error en el tipo de dato'           ,;
                     'Error en la longitud de los datos'  ,;
                     'El rea de trabajo no est en uso'  ,;
                     'El rea de trabajo no est indexada',;
                     'Se requiere exclusividad'           ,;
                     'Se requiere bloqueo'                ,;
                     'Escritura no permitida'              ;
                   }

   // Tipo de mensaje
   cMessage := if( e:severity > ES_WARNING, "Error ", "Warning " )

   // Subsistema que causa error
   IF ValType( e:subsystem ) == "C"
      cMessage += e:subsystem()
   ELSE
      cMessage += "???"      // No hay Subsistema para ese error
   END IF

   // Nmero de error
   IF ValType( e:subCode ) == "N"
      cMessage += ( "/" + NTRIM( e:subCode ) )
   ELSE
      cMessage += "/???"
   END IF

   // Informacin del error en Castellano
   IF ValType( e:description ) == 'C'
      cMessage += ( '  ' + aTexto[e:genCode] )
   END IF

   // Si en el error interviene algn fichero
   IF !Empty( e:filename )
      cMessage += ( ": " + e:filename )
   ELSEIF !Empty(e:operation)
          cMessage += ( ": " + e:operation )
   END IF
RETURN cMessage
//

/*
   OHERROR()

   Control de errores del propio ERRORSYS
*/
STATIC FUNCTION OhError( oError )
   Alert( Space( 13 )                  + ;
          'ERROR en el propio ERRORSYS'+ ;
          Space( 13 )                  + ;
          ' Proc.  ' + ProcName( 3 )   + ;
          ' Lnea  ' + NTRIM(ProcLine(3))   ,;
          { 'Quit' } )
   ErrorLevel( 1 )
   QUIT
RETURN NIL
//

/*
   CTLIMPRE()

   Control de impresora desde ERRORSYS
*/
FUNCTION CtlImpre()
   LOCAL nOpc   := 0
   LOCAL lValor := .F.
   LOCAL cFichero
   LOCAL nManip
   LOCAL nRow := Row()
   LOCAL nCol := Col()

   Set( _SET_DEVICE, "SCREEN" )

   nOpc := Alert( "IMPRESORA NO ESTA EN LINEA", ;
                  { "Reintentar","Cancelar Impresin","A fichero"} )

   DO CASE
      CASE nOpc == 1
           lValor := .T.

      CASE nOpc == 2 .OR. nOpc == 0
           BREAK  // o QUIT

      CASE nOpc == 3
           cFichero := 'PRN' + SubStr( Time(), 1, 2 ) +;
                       SubStr( Time(), 4, 2 ) + '.PRN'
           nManip   := FCreate( cFichero )
           FClose( nManip )

           Set( _SET_PRINTFILE, cFichero )
           lValor := .T.
   END CASE
   SetPos( nRow, nCol )
   Set( _SET_DEVICE, "PRINT" )
RETURN lValor
//

#include "FileIO.ch"
FUNCTION CreaLog( oError )
   LOCAL nHandle
   LOCAL cCadena := ''
   LOCAL nAux, xValor
   LOCAL aLineas := {}
   LOCAL cNumero := Space( 4 ), nNumero

   // Comprobamos si existe o no el fichero
   IF !File( "ERROR.LOG" )
      nHandle := FCreate( "ERROR.LOG", FC_NORMAL )
      // Grabar cabecera con el nmero del error
      cNumero := '001'
      FWrite(nHandle, 'K' + cNumero + Chr( 13 ) + Chr( 10 ))
      nNumero := Val( Right( cNumero, 3 ) )
   ELSE
      nHandle := FOpen( "ERROR.LOG", FO_READWRITE )
      FRead( nHandle, @cNumero, 4 )

      // Se incrementa el nmero de error en 1
      nNumero := Val( Right( cNumero, 3 ) )
      nNumero++
      cNumero := StrZero( nNumero,3 )

      FSeek( nHandle, 0, FS_SET )
      FWrite( nHandle,'K' + cNumero + Chr( 13 ) + Chr( 10 ) )
   END IF

   // Nos posicionamos al final del fichero
   FSeek( nHandle, 0, FS_END )

   // Comprobamos lista de argumentos
   IF ValType( oError:args ) == 'A'
      FOR nAux := 1 TO Len( oError:args )
          xValor := ValType( oError:args[ nAux ] )

          cCadena += ' - '

          DO CASE
             CASE xValor == 'C'
                cCadena += oError:args[ nAux ]
             CASE xValor == 'N'
                cCadena += AllTrim(Str(oError:args[nAux]))
             CASE xValor == 'D'
                cCadena += DToC( oError:args[ nAux ] )
             CASE xValor == 'L'
                cCadena += IIf( oError:args[ nAux ], '.T.',;
                                '.F.' )
          END CASE
      END FOR
   END IF

   // Creamos array con las diferentes lneas a escibir por
   // cada  Error
   aLineas := {                                            ;
                '<>' + cNumero +                           ;
                ' Error '            ,;
                ''                                        ,;
                '  ' + oError:description                ,;
                '   ' + DToC( Date() ) + ' ' + Time()     ,;
                ''                                        ,;
                'Variables del objeto:'                   ,;
                '   Lista de ARGS  ' + cCadena            ,;
                '   CANDEFAULT     ' +                     ;
                IIf( oError:canDefault   , '.T.','.F.' )  ,;
                '   CANRETRY       ' +                     ;
                IIf( oError:canRetry     , '.T.','.F.' )  ,;
                '   CANSUBSTITUTE  ' +                     ;
                IIf( oError:canSubstitute, '.T.','.F.' )  ,;
                '   DESCRIPTION    ' + oError:description ,;
                '   FILENAME       ' +                     ;
                IIf( Empty( oError:filename )  ,;
                     'No existe fichero en uso',;
                     oError:filename )                    ,;
                '   GENCODE        ' +                     ;
                AllTrim( Str( oError:genCode ) )          ,;
                '   OPERATION      ' + oError:operation   ,;
                '   OSCODE         ' +                     ;
                AllTrim( Str( oError:osCode ) )           ,;
                '   SEVERITY       ' +                     ;
                AllTrim( Str( oError:severity ) )         ,;
                '   SUBCODE        ' +                     ;
                AllTrim( Str( oError:subCode ) )          ,;
                '   SUBSYSTEM      ' + oError:subSystem   ,;
                '   TRIES          ' +                     ;
                AllTrim( Str( oError:tries ) )            ,;
                ''                                        ,;
                'Estado de MEMORIA:'                      ,;
                '   MEMORIA LIBRE            (0) ' +       ;
                AllTrim( Str( Memory( 0 ) ) )             ,;
                '   BLOQUE DE MAYOR TAMAO   (1) ' +       ;
                AllTrim( Str( Memory( 1 ) ) )             ,;
                '   AREA DISPONIBLE PARA RUN (2) ' +       ;
                AllTrim( Str( Memory( 2 ) ) )             ,;
                ''                                        ,;
                'Espacio disponible en disco ' +           ;
                lTrim( Transform( DiskSpace(),             ;
                                  "999,999,999,999")) +    ;
                                  + ' Bytes '             ,;
                '   Variable CLIPPER  ' +                 ;
                IIf( Empty( Gete( 'CLIPPER' ) ),           ;
                        'No declarada',Gete( 'ClIPPER' ) ),;
                ''                                        ,;
                'Pantalla del Error:'                     ,;
                SaveScreen()                              ,;
                ''                                         ;
              }

   // Aadimos al final del array las lneas informativas del
   // los procedimientos afectados por el error
   aAdd( aLineas, 'Procedimientos afectados por el Error:' )
   nAux := 3
   WHILE ( !Empty( ProcName( nAux ) ) )
         aAdd( aLineas, Space( 3 ) + ProcName( nAux ) + ;
                         ' Lnea: ' + ;
                         AllTrim( Str( ProcLine( nAux ) ) ) )
         nAux++
   END
   aAdd( aLineas, '##' + cNumero )

   // Grabamos las diferentes lneas informativas
   aEval( aLineas,;
          {|x| FWrite( nHandle, x + Chr( 13 ) + Chr( 10 ) )})
   FClose( nHandle )
RETURN NIL

