/*
   NTXERR.PRG

   Modificaciones con respecto al NTXERR.PRG original
   que trae Clipper 5.2.

   Controlaremos aquellos posibles errores que no
   causen una finalizacin del programa
*/

ANNOUNCE _ntxerr

INIT PROCEDURE InitHandler()
   LOCAL bDefError
   bDefError := ErrorBlock({|err| LockErrHandler(err,bDefError)})
RETURN

STATIC FUNCTION LockErrHandler( oErr, bDefError )
   // Fallos de bloqueo de ndices
   IF oErr:genCode == EG_LOCK
      RETURN .T.
   END IF

   // Divisin por 0
   IF oErr:genCode == EG_ZERODIV
      return (0)
   END IF

   // Error de apertura de .DBF en red
   IF oErr:genCode == EG_OPEN .AND.;
      oErr:osCode  == 32      .AND.;
      oErr:canDefault
      NetErr(.T.)
      RETURN .F.
   END IF

   // Error de insercin de registros en red
   IF oErr:genCode == EG_APPENDLOCK .AND. oErr:canDefault
      NetErr(.t.)
      return (.f.)                                                                    // NOTE
   END

   // Pasamos al manejador de errores estandar
RETURN ( Eval( bDefError, oErr ) )
