/*
  VERERROR
  Visualizar pantallas los errores almacenados en ERROR.LOG
  Permite ver ficheros .DBF y ASCII

  Utilizacin:

  - Durante desarrollo:    Dentro del propio ERRORSYS
  - Aplicacin finalizada: Ejecutable independiente

  (C) Grupo EIDOS. Febrero 1993
*/
#include "INKEY.CH"
#include "FILEIO.CH"

#define  BUFFER (62*1024)

FUNCTION VerError( cTipo )
   LOCAL nCursor := SetCursor( 0 )
   LOCAL nHandle, cCar, nPos, nInicio, nFinal
   LOCAL cError, cPantErr
   LOCAL nNumero, cNumero, nAux, nAux1, cProc
   LOCAL cColor := SetColor()

   CLS

   // Si el fichero ERROR.LOG empleo la tcnica del
   // .DBF
   IF cTipo == 'DBF'
      DbUseArea( .T.,,'PANTERR.LOG' )  // Pantallas
      DbUseArea( .T.,,'ERROR.LOG'   )  // Errores

      SetBlink( .F. )

      WHILE !Panterr->( Eof() )
            RestScreen( ,,,,Panterr->Pantal )

            @ 24,00,24,80 BOX Space( 9 ) COLOR '/W+'
            Error->(__dbLocate( {|| Error->Numero ==;
                                    Panterr->Numero } ) )
            @ 24,00 SAY 'Err N ' +                   ;
                        StrZero( Error->Numero, 3 )   ;
                        COLOR 'R/W*+'
            @ 24,10 SAY PadC( Error->Descripcio, 70 ) ;
                        COLOR 'R/W*+'
            @ 24,71 SAY '[F2] Ver'                    ;
                        COLOR 'B/W*+'

            InKey(0)

            IF LastKey() == K_F2
               @ 07,09,20,63 BOX Space( 9 )       COLOR 'W+/R'
               @ 08,12 SAY 'Error'                COLOR 'W+/R'
               @ 08,31 SAY 'Usuario'              COLOR 'W+/R'
               @ 10,12 SAY 'Fecha'                COLOR 'W+/R'
               @ 10,31 SAY 'Hora'                 COLOR 'W+/R'
               @ 12,12 SAY 'Descripcin Error'    COLOR 'W+/R'
               @ 15,12 SAY 'Error afecta a:    ' COLOR 'W+/R'
               @ 16,30 SAY ' '               COLOR 'W+/R'
               @ 17,30 SAY ''             COLOR 'W+/R'
               @ 18,30 SAY ' '         COLOR 'W+/R'

               @ 08,18 SAY StrZero( Error->Numero, 3 ) COLOR 'GR+/R'
               @ 08,40 SAY Error->Usuario              COLOR 'GR+/R'
               @ 10,18 SAY Dtoc( Error->Fecha )        COLOR 'GR+/R'
               @ 10,36 SAY Error->Hora                 COLOR 'GR+/R'
               @ 13,12 SAY Error->Descripcio           COLOR 'GR+/R'
               @ 15,42 SAY Error->Proc1                COLOR 'GR+/R'
               @ 16,42 SAY Error->Proc2                COLOR 'GR+/R'
               @ 17,42 SAY Error->Proc3                COLOR 'GR+/R'
               @ 18,42 SAY Error->Proc4                COLOR 'GR+/R'
               InKey(0)
            END IF

            Panterr->(DbSkip( 1 ))
      END WHILE
   ELSE
      // Utilizando ERROR.LOG pero como fichero ASCII
      nHandle := FOpen( 'Error.Log' )

      // Determinar ltimo error
      cNumero := Space( 4 )
      FRead( nHandle, @cNumero, 4 )
      cNumero := Right( cNumero, 3 )
      nNumero := Val( cNumero )

      nAux := 1
      WHILE .T.
          // Posicionarse al principio del fichero
          FSeek( nHandle,0,FS_SET )

          // Buscar comienzo error
          FLocate( nHandle, '<>' + StrZero( nAux, 3 ) )
          nInicio := FPos( nHandle )

          // Buscar final error
          FSeek( nHandle,0,FS_SET )
          FLocate( nHandle, '##' + StrZero( nAux, 3 ) )
          nFinal  := FPos( nHandle )

          // Cargar informacin del error
          cError  := Space( nFinal - nInicio + 5 )

          FSeek( nHandle, nInicio, FS_SET )
          FRead( nHandle, @cError, nFinal - nInicio + 5 )

          //
          @ 00,00,24,80 BOX Space( 9 ) COLOR '/B'
          @ 00,00,00,80 BOX Space( 9 ) COLOR '/BG'

          @ 23,00,23,80 BOX Space( 9 ) COLOR '/BG'
          @ 23,01 SAY Chr( 24 ) + Chr( 25 ) + ' Mover' COLOR 'R/BG'
          @ 23,54 SAY '[TAB] Ver Procedimientos'       COLOR 'R/BG'

          @ 24,00,24,80 BOX Space( 9 ) COLOR '/W+'
          @ 24,00 SAY PadC( 'Visualizar ERROR.LOG (ASCII)',80 );
                  COLOR 'R/W'
          @ 24,01 SAY '[ESC] Salir' COLOR 'N/W'
          @ 24,71 SAY '[F2] Ver' COLOR 'B/W*+'

          // N de Error
          @ 00,01 SAY 'Error N ' + SubStr( cError,3,3 );
                  COLOR 'R/BG'

          // Descripcin del Error
          @ 02,01 SAY SubStr(                                  ;
                        AllTrim( MemoLine ( cError,, 3 ) ), 2 );
                  COLOR 'W+/B'

          // Fecha y Hora del error
          @ 00,43 SAY 'Fecha/Hora ERROR  ' + ;
                      AllTrim( MemoLine ( cError,, 4 ) ) ;
                  COLOR 'R/BG'

          @ 04,01,16,43 BOX Space( 9 ) COLOR '/W'
          SetColor( 'B/W' )

          // Valor de datos del objeto error
          @ 04,01 SAY PadC( 'Variables',43 ) COLOR 'W+/R'
          @ 05,03 SAY Left(                                 ;
                       AllTrim( MemoLine ( cError,, 7 ) )   ;
                       ,40 )
          @ 06,03 SAY AllTrim( MemoLine( cError,, 8 ) )
          @ 07,03 SAY AllTrim( MemoLine( cError,, 9 ) )
          @ 08,03 SAY AllTrim( MemoLine( cError,,10 ) )
          @ 09,03 SAY AllTrim( MemoLine( cError,,12 ) )
          @ 10,03 SAY AllTrim( MemoLine( cError,,13 ) )
          @ 11,03 SAY AllTrim( MemoLine( cError,,14 ) )
          @ 12,03 SAY AllTrim( MemoLine( cError,,15 ) )
          @ 13,03 SAY AllTrim( MemoLine( cError,,16 ) )
          @ 14,03 SAY AllTrim( MemoLine( cError,,17 ) )
          @ 15,03 SAY AllTrim( MemoLine( cError,,18 ) )
          @ 16,03 SAY AllTrim( MemoLine( cError,,19 ) )

          // Estado de Memoria
          @ 18,01,21,43 BOX Space( 9 ) COLOR '/W'
          @ 18,01 SAY PadC( 'Estado de la Memoria',43 );
                  COLOR 'W+/R'
          @ 19,03 SAY AllTrim( MemoLine( cError,,22 ) ) +;
                      ' KBytes'
          @ 20,03 SAY AllTrim( MemoLine( cError,,23 ) ) +;
                      '  KBytes'
          @ 21,03 SAY AllTrim( MemoLine( cError,,24 ) ) +;
                      ' KBytes'

          // Procesos afectados
          nAux1 := At( 'Procedimientos', cError )
          cProc := SubStr( cError, nAux1 + 38 )
          VerProc( cProc, .F. )

          // Otra informacin
          @ 14,46,20,78 BOX Space( 9 ) COLOR '/R'
          @ 14,46,14,78 BOX Space( 9 ) COLOR '/W'
          @ 14,46 SAY PadC( 'Ms informacin..',32 )

          // Informacin espacio en disco, CLIPPER
          @ 15,47 SAY 'Espacio en Disco' COLOR 'W/R'
          @ 16,54 SAY SubStr( AllTrim( MemoLine( cError,,26 ) ),28 );
                      COLOR 'W+/R'
          @ 17,48 SAY 'Variable CLIPPER' COLOR 'W/R'
          @ 18,47 SAY SubStr( AllTrim( MemoLine( cError,,27 ) ),20,31 );
                      COLOR 'W+/R'
          @ 19,47 SAY SubStr( AllTrim( MemoLine( cError,,27 ) ),51,31 );
                      COLOR 'W+/R'
          InKey(0)

          // Movimiento
          DO CASE
             CASE LastKey() == K_F2
                  // Visualizar Pantalla [F2]
                  cPantErr := SubStr( cError, ;
                          At( 'Pantalla del Error:', cError ) + 19, ;
                          4096 )
                  RestScreen( ,,,,cPantErr )
                  InKey( 0 )
                  CLEAR TYPEAHEAD

             CASE LastKey() == K_UP
                  nAux--
                  IF nAux < 1
                     nAux := nNumero
                  END IF
                  LOOP

             CASE LastKey() == K_DOWN
                  nAux++
                  IF nAux > nNumero
                     nAux := 1
                  END IF
                  LOOP

             CASE LastKey() == K_ESC
                  EXIT

             CASE LastKey() == K_TAB
                  VerProc( cProc, .T. )

             OTHERWISE
                  LOOP
          END CASE

          IF nAux == nNumero
             LOOP
          END IF
          nAux++
      END WHILE
   END IF

   SetBlink( .T. )
   SetCursor( nCursor )
   SetColor( cColor )
   CLS
RETURN NIL
//


/*
   FUNCIONES AUXILIARES
*/

/*
   FLocate()

   Localizar una palabra
*/
FUNCTION FLocate( nHandle, cPalabra )
   LOCAL nPos:=0, n:=0, cBuffer:=Space( BUFFER ), lFound := .F.

   FOR n := 0 TO FSize( nHandle ) / BUFFER - 1
       FRead( nHandle, @cBuffer, BUFFER )
       IF (nPos := At(cPalabra, cBuffer) ) <> 0
          lFound := .T.
          EXIT
       END IF
   END FOR

   IF !lFound
      cBuffer := Space( FSize( nHandle ) % BUFFER )
      FRead( nHandle, @cBuffer, Len(cBuffer) )
      lFound := ( (nPos := At(cPalabra, cBuffer) ) <> 0 )
   END IF

   IF lFound
      FSeek( nHandle, nPos + (n * BUFFER) - 1 )
   END IF
RETURN lFound
//

/*
   FSize()

   Guarda la posicin actual y se va al fin de fichero
   Guarda el nmero de la ltima posicin (longitud del
   fichero) y restaura el puntero en su posicin
   anterior.
   Se usa la funcin anterior FPOS()
*/
FUNCTION FSize( nHandle )
   LOCAL nPosActual:=FPos( nHandle ), ;
         nFSize := FSeek(nHandle, 0 , FS_END)
   FSeek( nHandle, nPosActual, FS_SET )
RETURN nFSize
//

/*
   FPos()

   Se mueve 0 bytes de la posicin actual y devuelve sta
*/
FUNCTION FPos( nHandle )
RETURN FSeek( nHandle, 0, FS_RELATIVE )


/*
   VerProc()

   Visualiza los procesos afectados por el error
*/
FUNCTION VerProc( cDat, lValor )
   LOCAL nAux1, nOpcion
   LOCAL cColor := SetColor()
   LOCAL cPanta := SaveScreen( 04,46,12,78 )
   LOCAL aTabla := {}

   @ 05,47,11,77 BOX Space( 9 ) COLOR '/W'
   @ 05,47,05,77 BOX Space( 9 ) COLOR 'W+/R'
   @ 05,47 SAY PadC( 'Procesos afectados', 31 ) COLOR 'W+/R'

   FOR nAux1 := 1 TO MlCount( cDat ) - 1
       IF !Empty( AllTrim( MemoLine ( cDat,,nAux1 ) ) )
          aAdd( aTabla, AllTrim( MemoLine ( cDat,,nAux1 ) ) )
       END IF
   END FOR

   IF !lValor
      FOR nAux1 := 1 TO Len( aTabla )
          @ nAux1 + 5,50 SAY aTabla[ nAux1 ] COLOR 'B/W'

          IF nAux1 > 5
             EXIT
          END IF
      END FOR
   ELSE
      @ 24,71 SAY Space( 8 )       COLOR '/W'
      @ 23,00,23,80 BOX Space( 9 ) COLOR '/BG'
      @ 04,46,12,78 BOX Space( 8 ) COLOR '/BG+'
      SetColor( ',R+/W' )
      Achoice( 06,50,11,77,aTabla )
      RestScreen( 04,46,12,78,cPanta )
   END IF

   SetColor( cColor )
RETURN NIL
