#include "extend.api"
#include "dos.h"

CLIPPER video()
/*
   Formato: video([<expN1>])

   Uso:     Devuelve el modo de vdeo actual y si se le pasa el
            parmetro <expN1> establece el modo de vdeo correspon-
            diente. Los distintos modos de vdeo son:

                   0    CGA   40x25
                   1    CGA   40x25
                   2    CGA   80x25
                   3    CGA   80x25
                   4    CGA   320x200
                   5    CGA   320x200
                   6    CGA   640x200
                   7    MA    80x25
                  13    EGA   320x200
                  14    EGA   640x200
                  15    EGA   640x350
                  16    EGA   640x350
                  17    VGA   640x480
                  18    VGA   640x480
                  19    VGA   320x200
*/
{
 union REGS inregs            ;
 union REGS outregs           ;
 int modo                     ;
 inregs.x.ax = 0x0F00         ;
 int86(0x10,&inregs,&outregs) ;
 modo = outregs.x.ax & 0xFF   ;
 if (PCOUNT)
   {
     unsigned int *puntero    ;
     puntero = (int *) 0x0410 ;
     if (_parni(1)==7)    /* Si el modo es monocromo */
        *puntero = *puntero & 0xCF | 0x30;
     else
        *puntero = *puntero & 0xCF | 0x10;

     inregs.h.al = _parni(1);
     inregs.h.ah = 0;
     int86(0x10,&inregs,&outregs);
   }
 _retni(modo);
}


CLIPPER pixel()
/*
   Formato: pixel(<expN1>,<expN2>,<expN3>)

   Uso:     Escribe un pixel en pantalla, donde <expN1> y <expN2> son
            las coordenadas fila/columna donde se desea escribir y
            <expN3> es el color en el que se pretende escribir. Los
            colores posibles dependen del modo de video. La siguiente
            lista equivale a un modo de 16 colores:

                  0     Negro                    8    Gris
                  1     Azul               9    Azul Intenso
                  2     Verde                   10    Verde Intenso
                  3     Cian              11    Cian Intenso
                  4     Rojo              12    Rojo Intenso
                  5     Magenta           13    Magenta Intenso
                  6     Marrn            14    Amarillo
                  7     Blanco            15    Blanco Intenso
*/
{
 union REGS regs;
 regs.h.ah  = 0x0C ;
 regs.h.al  = _parni(3);   // COLOR
 regs.x.dx  = _parni(1);   // FILA
 regs.x.cx  = _parni(2);   // COLUMNA
 int86(0x10,&regs,&regs);
}