#include "extend.api"
#include "dos.h"

CLIPPER numlock()
/*
   Formato: numlock()

   Uso:     Devuelve .T. si la tecla [BloqNum] est activada.
*/
{
 union REGS regs;
 regs.h.ah = 2;
 int86(0x16,&regs,&regs);
 _retl(regs.h.al & 32);
}


CLIPPER scrlock()
/*
   Formato: scrlock()

   Uso:     Devuelve .T. si la tecla [BloqDespl] est activada.
*/
{
 union REGS regs;
 regs.h.ah = 2;
 int86(0x16,&regs,&regs);
 _retl(regs.h.al & 16);
}


CLIPPER capslock()
/*
   Formato: capslock()

   Uso:     Devuelve .T. si la tecla [BloqMays] est activada.
*/
{
 union REGS regs;
 regs.h.ah = 2;
 int86(0x16,&regs,&regs);
 _retl(regs.h.al & 64);
}


CLIPPER alt()
/*
   Formato: alt()

   Uso:     Devuelve .T. si la tecla [Alt] est activada.
*/
{
 union REGS regs;
 regs.h.ah = 0x12;
 int86(0x16,&regs,&regs);
 _retl(regs.h.ah & 2);
}


CLIPPER altgr()
/*
   Formato: altgr()

   Uso:     Devuelve .T. si la tecla [AltGr] est activada.
*/
{
 union REGS regs;
 regs.h.ah = 0x12;
 int86(0x16,&regs,&regs);
 _retl(regs.h.ah & 8);
}


CLIPPER ctrl()
/*
   Formato: ctrl()

   Uso:     Devuelve .T. si la tecla [Ctrl] est activada.
*/
{
 union REGS regs;
 regs.h.ah = 2;
 int86(0x16,&regs,&regs);
 _retl(regs.h.al & 4);
}


CLIPPER ctrlr()
/*
   Formato: ctrlr()

   Uso:     Devuelve .T. si la tecla [Ctrl] derecha est activada.
*/
{
 union REGS regs;
 regs.h.ah = 0x12;
 int86(0x16,&regs,&regs);
 _retl(regs.h.ah & 4);
}


CLIPPER ctrll()
/*
   Formato: ctrll()

   Uso:     Devuelve .T. si la tecla [Ctrl] izquierda est activada.
*/
{
 union REGS regs;
 regs.h.ah=0x12;
 int86(0x16,&regs,&regs);
 _retl(regs.h.ah & 1);
}


CLIPPER shiftl()
/*
   Formato: shiftl()

   Uso:     Devuelve .T. si la tecla [Mays] izquierda est activada.
*/
{
 union REGS regs;
 regs.h.ah = 2;
 int86(0x16,&regs,&regs);
 _retl(regs.h.al & 2);
}


CLIPPER shiftr()
/*
   Formato: shiftr()

   Uso:     Devuelve .T. si la tecla [Mays] derecha est activada.
*/
{
 union REGS regs;
 regs.h.ah = 2;
 int86(0x16,&regs,&regs);
 _retl(regs.h.al & 1);
}