#include "extend.api"
#include "dos.h"

CLIPPER hardcopy()
/*  
   Formato: hardcopy()             

   Uso:     Hace una copia de la pantalla a la impresora

*/
{
 union REGS regs;
 int86(0x5,&regs,&regs);
 _ret();
}


CLIPPER ram()
/*  
   Formato: ram()

   Uso:     Devuelve el tamao de memoria RAM instalado (en Kbytes)
*/  
{
 union REGS regs;
 int86(0x12,&regs,&regs);
 _retni(regs.x.ax);
}


CLIPPER extended()
/*
   Formato: extended()

   Uso:     Devuelve el tamao de memoria EXTENDIDA instalada (en
            Kbytes)
*/
{
 union REGS regs;
 regs.h.ah = 0x88;
 int86(0x15,&regs,&regs);
 _retni(regs.x.ax);
}


CLIPPER reboot()
/*
   Formato: reboot()

   Uso:     Reinicializa el ordenador
*/
{
 union REGS regs;
 int86(0x19,&regs,&regs);
 _ret();
}


CLIPPER curdrive()
/*
   Formato: curdrive()

   Uso:     Devuelve el nmero de unidad de disco actual.
            (A=1,B=2,...)
*/
{
 union REGS regs;
 regs.h.ah = 0x19;
 int86(0x21,&regs,&regs);
 _retni(++regs.h.al);
}
