#include "Raton.ch"
#include "Inkey.ch"

//
FUNCTION Main()
LOCAL nPulsacion, nNumBotones
CLS

// Saber si el controlador del ratn est instalado
@ 0,0 SAY IF( MsRaton(), 'RATON INSTALADO', ;
                         'EL RATON NO ESTA INSTALADO' )

// Conocer el nmero de botones del ratn
nNumBotones := MsBotones()
@ 1,0 SAY 'El nmero de botones es '+STR( nNumBotones, 1 )

// Activar el cursor del ratn
MsCursor(.T.)

@ 3,5 SAY 'Ŀ'
@ 4,5 SAY '      '
@ 5,5 SAY ''

MsDevPos(0,0)    // Posicionar el cursor del ratn en 0,0
MsMickeys(4,8)   // Aumentar la sensibilidad que el ratn
                 // tiene por defecto (8,16)

// Area de actuacin del ratn
@ 7, 2 TO 18, 77
MsArea( 8, 3, 17, 76 )

// Bucle proceso
WHILE .T.

 // Saber la coordenadas de las ltimas pulsaciones
 @ 20,0 SAY 'Coordenada donde se puls/solt el botn IZQUIERDO ' + ;
             STR( MsFilaPulso( MSE_IZQ ), 2 ) + ','         + ;
             STR( MsColPulso ( MSE_IZQ ), 2 ) + '/'         + ;
             STR( MsFilaSolto( MSE_IZQ ), 2 ) + ','         + ;
             STR( MsColSolto ( MSE_IZQ ), 2 )

 @ 21,0 SAY 'Coordenada donde se puls/solt el botn DERECHO   ' + ;
             STR( MsFilaPulso( MSE_DER ), 2 ) + ','         + ;
             STR( MsColPulso ( MSE_DER ), 2 ) + '/'         + ;
             STR( MsFilaSolto( MSE_DER ), 2 ) + ','         + ;
             STR( MsColSolto ( MSE_DER ), 2 )


 // Si tiene botn central
 IF nNumBotones == 3
  @ 22,0 SAY 'Coordenada donde se puls/solt el botn CENTRAL   ' + ;
              STR( MsFilaPulso( MSE_CEN ), 2 ) + ','         + ;
              STR( MsColPulso ( MSE_CEN ), 2 ) + '/'         + ;
              STR( MsFilaSolto( MSE_CEN ), 2 ) + ','         + ;
              STR( MsColSolto ( MSE_CEN ), 2 )


 END IF

 // Parar la ejecucin del programa
 // hasta que se pulse una tecla o un botn del ratn

 nPulsacion := MsInkey(0,{|| macrofunc()})

 // Dibujar en la casilla correspondiente la representacin
 // del botn del ratn pulsado
 DO CASE

    CASE nPulsacion=500+MSE_I
         @ 4, 6 SAY ''

    CASE nPulsacion=500+MSE_D
         @ 4,12 SAY ''

    CASE nPulsacion=500+MSE_ID
         @ 4, 6 say ''
         @ 4,12 say ''

    CASE nPulsacion=500+MSE_C
         @ 4, 9 SAY ''

    CASE nPulsacion=500+MSE_IC
         @ 4, 6 SAY ''
         @ 4, 9 SAY ''

    CASE nPulsacion=500+MSE_CD
         @ 4, 9 SAY ''
         @ 4,12 SAY ''

    CASE nPulsacion=500+MSE_ICD
         @ 4, 6 SAY ''
         @ 4, 9 SAY ''
         @ 4,12 SAY ''

    // Salida del programa con ESCAPE
    CASE nPulsacion=K_ESC
         EXIT

 END CASE

 // Pitido y borrar casillero
 TONE(500,2)
 @ 4, 6 SAY '  '
 @ 4, 9 SAY '  '
 @ 4,12 SAY '  '

END

// Ocultar el cursor del ratn
MsCursor(.f.)
RETURN NIL

STATIC FUNCTION MacroFunc()

  // Coordenadas actuales del cursor del ratn
  @ 24, 0 SAY ' Fila: ' + STR( MsFila(), 2, 0 ) + ;
              ' Col.: ' + STR( MsCol() , 2, 0 )

  // Reloj
  @  0,60 SAY TIME()

RETURN NIL

//
FUNCTION MsInkey( nSegundos, bBloque )
LOCAL nTecla, nBoton, bBloqueTecla, nTranscurrido := 0,;
      nTiempo := Seconds()

  MsCursor( .T. )
  WHILE .T.
    WHILE (nTecla:=INKEY()) == 0 .AND.( ( (nBoton:=MsEstado()) == 0  .AND.;
                                           MsSoltado(0) == 0         .AND.;
                                           MsSoltado(1) == 0         .AND.;
                                           MsSoltado(2) == 0              ;
                                        )                                 ;
                                      )


      IF (nTranscurrido := SECONDS()-nTiempo ) >= nSegundos .AND.;
          nSegundos <> 0
         RETURN 0
      END IF

      IF bBloque != NIL
         EVAL( bBloque )
      END IF
    END

    IF (bBloqueTecla := SETKEY( nTecla ) ) != NIL
       EVAL( bBloqueTecla )
       nTiempo := Seconds() - nTranscurrido
    ELSE
       EXIT
    END IF
  END
  MsCursor( .F. )

RETURN IF( nTecla == 0, 500 + nBoton, nTecla )