// Fichero: EjPrint.prg
// Compilar con Clipper EjPrint /n/w
// Enlazar con RtLink FI EjPrint, Print
//
#include "inkey.ch"
#include "box.ch"

STATIC lParado := .F.
FUNCTION Main()
LOCAL aSpool, nOpc, oTbSpool, nIndice := 1, nTecla, oTcFichero, n:=1
CLS
SetCursor( 0 )
IF PrnPrint()
   @  9, 9, 21, 75 BOX B_SINGLE
   @ 24, 0 SAY "<F2> Cancela Trabajo <F3> Cancela Todos " + ;
               "<F4> Parar/Reaundar  <ESC> Salir"
   oTbSpool := TBrowseNEW( 10, 10, 20, 74 )
   oTbSpool:goTopBlock    := { | | nIndice := 1 }
   oTbSpool:goBottomBlock := { | | nIndice := LEN( aSpool ) }
   oTbSpool:skipBlock     := { |n| PasArray(n, LEN( aSpool ),;
                                            @nIndice ) }
   oTcFichero := TbColumnNEW(, { || aSpool[ nIndice ] } )
   oTcFichero:Width := 64
   oTbSpool:addColumn( oTcFichero )

   AEval( Directory(), { |aFicheros| PrnEnviar(".\" + ;
                                               aFicheros[1])})
   @ 0,0 SAY "IMPRIMIENDO" COLOR "W+*/N"
   PrnCola( aSpool := Array( PrnCola() ) ) ; PrnSiga()
   WHILE aSpool # NIL

       nTecla := TbStd(oTbSpool, { || ChkSpool( @aSpool ) })
       DO CASE

       CASE nTecla == K_ENTER
            Tone(500,1.5)
            oTbSpool:refreshAll()

       CASE nTecla == K_F2
            PrnSacar( aSpool[ nIndice ] )
            PrnCola( aSpool := Array( PrnCola() ) )
            IF LEN( aSpool ) == 0
               EXIT
            ELSE
               IF !lParado
                  PrnSiga()
               ENDIF
            END IF
            oTbSpool:refreshAll()

       CASE nTecla == K_F3
            PrnLimpia()
            EXIT

       CASE nTecla == K_F4
            IF lParado
               @ 0,0 SAY "IMPRIMIENDO" COLOR "W+*/N"
               PrnSiga()
            ELSE
               @ 0,0 SAY "PARADO     " COLOR "W+/N"
               PrnCola()
            ENDIF
            lParado := !lParado

       CASE nTecla == K_ESC
            EXIT

       END CASE

   ENDDO
ELSE
   ? "PRINT no instalado" ; Inkey( 0 )

END IF
CLS
RETURN NIL

//
STATIC FUNCTION PasArray(nSalto, nLenArray, nIndice)
LOCAL nSaltado := 0
    IF  nSalto > 0 .AND. nIndice < nLenArray + 1
        WHILE  nSaltado < nSalto
               nIndice++
               IF  nIndice > nLenArray
                   nIndice := nLenArray
                   EXIT
               ENDIF
               nSaltado++
        ENDDO
     ELSEIF  nSalto < 0
        WHILE  nSaltado > nSalto
               nIndice--
               IF  nIndice = 0
                   nIndice := 1
                   EXIT
               ENDIF
               nSaltado--
        ENDDO
    ENDIF
RETURN nSaltado

//
STATIC FUNCTION TbStd( oTb, bAccion )
LOCAL    nTecla

 DispBegin()
 WHILE NextKey() == 0 .AND. !oTb:stabilize() ; END
 DispEnd()

 nTecla := xInkey( 0, bAccion )

 DO CASE
    CASE nTecla==K_RIGHT .OR. nTecla == K_TAB    ; oTb:right()
    CASE nTecla==K_LEFT  .OR. nTecla == K_SH_TAB ; oTb:left()
    CASE nTecla==K_DOWN                          ; oTb:down()
    CASE nTecla==K_UP                            ; oTb:up()
    CASE nTecla==K_PGDN                          ; oTb:pageDown()
    CASE nTecla==K_PGUP                          ; oTb:pageUp()
    CASE nTecla==K_HOME                          ; oTb:home()
    CASE nTecla==K_END                           ; oTb:end()
    CASE nTecla==K_CTRL_LEFT                     ; oTb:panLeft()
    CASE nTecla==K_CTRL_RIGHT                    ; oTb:panRight()
    CASE nTecla==K_CTRL_PGUP                     ; oTb:goTop()
    CASE nTecla==K_CTRL_HOME                     ; oTb:panHome()
    CASE nTecla==K_CTRL_END                      ; oTb:panEnd()
    CASE nTecla==K_CTRL_PGDN                     ; oTb:goBottom()
 END CASE
RETURN nTecla

//
STATIC FUNCTION xInkey( nSegundos, bBloque )
LOCAL nTecla, bBloqueTecla, nTranscurrido, nTiempo := Seconds( )
  WHILE .T.
    WHILE ( nTecla := Inkey() ) == 0
      IF (nTranscurrido:=Seconds()-nTiempo)>=nSegundos .AND.;
          nSegundos != 0
        RETURN 0
      ENDIF
      IF bBloque != NIL .AND. ValType( bBloque ) == 'B'
         Eval(bBloque)
      ENDIF
    END
    IF ( bBloqueTecla := SetKey( nTecla ) ) != NIL
       Eval(bBloqueTecla, ProcName( 1 ), ProcLine( 1 ), ReadVar() )
       nTiempo := Seconds( ) - nTranscurrido
    ELSE
       EXIT
    END IF
  END
RETURN nTecla

//
STATIC FUNCTION ChkSpool( aSpool )
IF PrnCola() < Len( aSpool )
   PrnCola( aSpool := Array( PrnCola() ) )
   KEYBOARD If( Len( aSpool ) == 0, Chr( K_ESC ), Chr( K_ENTER ) )
ENDIF
IF !lParado
   PrnSiga()
ENDIF
RETURN NIL