#include "Menus.ch"
#include "Inkey.ch"

STATIC lMarcar := .T., lOpIgnore := .T., lOpWord := .F., lOpBof:=.F.

FUNCTION Main()
LOCAL    nMenu
SetColor ( "N/W" )
SetBlink ( .F. )
SetCursor(  0  )
Set( _SET_WRAP,    .T. )
Set( _SET_MESSAGE, 23  )
Set( _SET_MCENTER, .T. )
// SetOkChar( "" )      // Esto es opcional, por defecto vale 
// SetMenuChar( ">" )    // Esto es opcional, por defecto vale 
// SetMenuDelim( "[]" )  // Esto es opcional, por defecto no hay
CLS

//
CREATE MENU nMenu COLOR "N/W*, W+/N, R/W*, R+/N, W/W*, N+/N"

@ 1, 1 ITEM " ^Indice "
  @ 3,  2 PROMPT  "^Indice  "                                             ;
          MESSAGE "Mostrar el ndice de artculos"                        ;
          ACTION { |nMenu| Pr11(nMenu) }                                  ;
          QUICK KEY K_CTRL_F1                                             ;
          LABEL KEY "<Ctrl-F1>"

  @ 4,  2 PROMPT  "^Filtrar "                                             ;
          MESSAGE "Filtrar la base de datos de artculos"                 ;
          ACTION { || SubFiltrar() } MENU

@ 1,  9  ITEM " B^loques "
  @ 3, 10 PROMPT  "^Marcar"                                               ;
          MESSAGE "Marcar o desmarcar un bloque de texto"                 ;
          ACTION    { |hMenu| Marca( hMenu ) }

  @ 5, 10 PROMPT  "^A texto"                                              ;
          MESSAGE "Copiar a un fichero ASCII un bloque de texto"          ;
          WHEN    !lMarcar

  @ 6, 10 PROMPT  "^Imprimir"                                             ;
          MESSAGE "Imprimir el contenido del bloque de texto"             ;
          WHEN    !lMarcar

@ 1, 18 ITEM " ^Bsquedas "
  @ 3, 19 PROMPT  "^Buscar   "                                            ;
          MESSAGE "Buscar una palabra dentro del texto del artculo"

  @ 4, 19 PROMPT  "^Siguiente"                                            ;
          MESSAGE "Continuar una bsqueda en el texto"                    ;
          WHEN .F.                                                        ;
          QUICK KEY K_CTRL_F2                                             ;
          LABEL KEY "<Ctrl-F2>"

  @ 6, 19 PROMPT  "^Opciones "                                            ;
          MESSAGE "Establecer las opciones que se utilizarn en bsquedas";
          ACTION  { || SubOpciones() } MENU                               ;
          QUICK KEY K_CTRL_F10                                            ;
          LABEL KEY "<Ctrl-F10>"

@ 1, 29 ITEM " Di^ccionario "
  @ 3, 30 PROMPT  "^Mantenimiento"                                        ;
          MESSAGE "Mantenimiento de palabras claves asociadas al artculo"

@ 1, 42 ITEM " ^Opciones "
  @ 3, 43 PROMPT  "^Monocromo"                                            ;
          MESSAGE "Configuracin de los colores para tipos de letra"      ;
          ACTION {|lValor| !lValor } CHECKED                            ;
          INITIAL IsColor()

  @ 4, 43 PROMPT  "^Teclas   "                                            ;
          MESSAGE "Configuracin de las acciones asociadas a las teclas"  ;
          QUICK KEY K_CTRL_F3                                             ;
          LABEL KEY "<Ctrl-F3>"


  @ 6, 43 PROMPT  "^A Texto  "                                            ;
          MESSAGE "Conversin a texto del contenido del artculo"

  @ 8, 43 PROMPT  "^Recuperar"                                            ;
          MESSAGE "Marcar para borrado o recuperar un artculo"


@ 1, 52 ITEM " I^mpresin "
  @ 3, 53 PROMPT  "^Artculo       "                                      ;
          MESSAGE "Impresin del artculo actual"

  @ 4, 53 PROMPT  "^Grupo Artculos"                                      ;
          MESSAGE "Impresin de todos los artculos del filtro actual"

@ 1, 63 ITEM " clippe^Rmana "
  @ 3, 64 PROMPT "^Crditos" ACTION { || Mania() }

END MENU

// . . . //

EXECUTE MENU nMenu

CLS
QOut( "OPCION ELEGIDA ", ItemGet( nMenu )                         )
QOut( "SUBOPCION ELEGIDA ", PROMPTGet( nMenu, ItemGet( nMenu )  ) )
QOut( "Item 1 Prompt ", PromptGet( nMenu, 1 )                     )
QOut( "Item 2 Prompt ", PromptGet( nMenu, 2 )                     )
QOut( "Item 3 Prompt ", PromptGet( nMenu, 3 )                     )
QOut( "Item 4 Prompt ", PromptGet( nMenu, 4 )                     )
QOut( "Item 5 Prompt ", PromptGet( nMenu, 5 )                     )
QOut( "Item 6 Prompt ", PromptGet( nMenu, 6 )                     )
QOut( "Item 7 Prompt ", PromptGet( nMenu, 7 )                     )
DESTROY MENU nMenu

RETURN NIL

//
FUNCTION Mania()
RETURN .T.

//
FUNCTION Pr11( nMenu )
@ 24, 0 SAY  "ESTOY EN LA OPCION 1.1, PULSAR UNA TECLA"
INKEY(0)
RETURN .T.

//
FUNCTION Marca( nMenu )
LOCAL  cSaveScr := SaveScreen()

IF lMarcar
   PromptText( nMenu,,, "^Desmarcar")
   @ 24, 0 SAY  "Estara marcando texto..."; Inkey(0)
ELSE
   PromptText( nMenu,,, "^Marcar")
   @ 24, 0 SAY  "Estara desmarcando texto..."; Inkey(0)
END IF
lMarcar := !lMarcar
PromptWhen( nMenu, 2, 2, !lMarcar )  // cuando no hay bloque no hay permiso
PromptWhen( nMenu, 2, 3, !lMarcar )  // cuando no hay bloque no hay permiso
RestScreen( ,,,,cSaveScr )

MenuDisplay( nMenu )
ItemRefresh( nMenu )
RETURN .F.


//
FUNCTION SubFiltrar()
LOCAL nOp, nSubMenu

CREATE MENU POPUP nSubMenu COLOR "N/W*, W+/N, R/W*, R+/N, W/W*, N+/N"

@  6, 6 PROMPT "^Ninguno"
@  8, 6 PROMPT "^Boletn"
@  9, 6 PROMPT "^Autor"
@ 10, 6 PROMPT "^Seccin"
@ 11, 6 PROMPT "^Clave"
END MENU
EXECUTE MENU nSubMenu
nOp := PromptGet( nSubMenu, ItemGet( nSubMenu ) )
DESTROY MENU nSubMenu
RETURN nOp

//
FUNCTION SubOpciones()
LOCAL nOp, nSubMenu

CREATE MENU POPUP nSubMenu COLOR "N/W*, W+/N, R/W*, R+/N, W/W*, N+/N"

@  6, 23 PROMPT  "^Ignorar Minsculas"                                    ;
         ACTION { |lValor| (lOpIgnore := !lValor) } CHECKED               ;
         INITIAL lOpIgnore                                                ;
         QUICK KEY K_ALT_F1                                               ;
         LABEL KEY "<K_ALT_F1>"

@  8, 23 PROMPT  "^Bsqueda de palabras"                                  ;
         ACTION { |lValor| (lOpWord := !lValor) }  CHECKED                       ;
         INITIAL lOpWord                                                  ;
         QUICK KEY K_ALT_F2                                               ;
         LABEL KEY "<K_ALT_F2>"

@  9, 23 PROMPT  "^Desde el principio"                                    ;
         ACTION { |lValor| (lOpBof := !lValor) }  CHECKED                        ;
         INITIAL lOpBof                                                   ;
         QUICK KEY K_ALT_F3                                               ;
         LABEL KEY "<K_ALT_F3>"

END MENU
EXECUTE MENU nSubMenu
nOp := PromptGet( nSubMenu, ItemGet( nSubMenu ) )
DESTROY MENU nSubMenu
RETURN nOp