#include "Inkey.ch"
#include "MenuSys.ch"

STATIC aMenu := {}, hMenu := 1, hItem := 0

// Funciones enfocadas al MENU ////////////////////////////////////////////
FUNCTION Menu( hMenu )
RETURN MENU

//
FUNCTION MenuNew( cColor, cBorder, nSeconds, bStatus, nIni, lForceStable )
LOCAL    aColor
DEFAULT  cColor       TO ( aColor := ColorToA() )[1] + aColor[2] +        ;
                           aColor[2] + aColor[2] + aColor[5] + aColor[2], ;
         cBorder      TO "Ŀ "                                    , ;
         nSeconds     TO 0                                              , ;
         bStatus      TO {|| NIL}                                       , ;
         nIni         TO 1                                              , ;
         lForceStable TO .F.

aColor := ColorToA( cColor )
hItem  := 0
aAdd( aMenu, { hMenu, aColor, cBorder, nSeconds, bStatus, nIni,           ;
               lForceStable, SaveScreen(), 0, {}                          ;
             }                                                            ;
    )
RETURN hMenu

//
FUNCTION MenuEnd()
RETURN   ++hMenu

//
FUNCTION MenuDestroy( hMenu )
ADel( MENU )
RETURN ASize( aMenu, Len( aMenu ) - 1 )

//
FUNCTION MenuExecute( hMenu, bReader )
LOCAL    nStatus
DEFAULT  bReader TO { |hMenu| MenuReader( hMenu ) }
MenuRefresh( hMenu )
WHILE (nStatus := Eval( bReader, hMenu) ) # ST_EXIT ; END WHILE
RestScreen( ,,,, MENU[ MN_SCREEN ] )
RETURN ItemGet( hMenu )

//
FUNCTION MenuRefresh( hMenu )
LOCAL    nOpItem
DispBegin()
MenuConfigure( hMenu )
FOR nOpItem := 1 TO ItemCount( hMenu )
  ItemConfigure( hMenu, nOpItem )
END FOR
MenuDisplay( hMenu )
ItemDisplay( hMenu, ItemGet( hMenu )  )
DispEnd()
RETURN hMenu

//
FUNCTION MenuDisplay( hMenu )
LOCAL    n
FOR n := 1 TO ItemCount( hMenu )
    @     ITEM[ n, IT_ROW  ], ITEM[ n, IT_COL ]                           ;
    SAY   ITEM[ n, IT_TEXT ]                                              ;
    COLOR MENU[ MN_COLOR, CL_NORMAL ]

    @     ITEM[ n, IT_ROW ],                                              ;
          ITEM[ n, IT_COL ] + ITEM[ n, IT_ATHOTKEY ] - 1                  ;
    SAY   ITEM[ n, IT_HOTKEY ]                                            ;
    COLOR MENU[ MN_COLOR, CL_NORMAL_KEY ]
END FOR
RETURN hMenu

//
FUNCTION MenuConfigure( hMenu )
MENU[ MN_SCREEN ] := SaveScreen( )
MENU[ MN_ROWMSG ] := If(Set(_SET_MESSAGE)==0, MaxRow(), Set(_SET_MESSAGE) )
RETURN hMenu

//
FUNCTION MenuMsgHide( hMenu )
RestScreen( MENU[ MN_ROWMSG ], 0, MENU[ MN_ROWMSG ], MaxCol(),            ;
            SubStr( MENU[ MN_SCREEN ],                                    ;
                    MENU[ MN_ROWMSG ] * (MaxCol()+1)*2 + 1, (MaxCol()+1)*2;
                  )                                                       ;
          )
RETURN hMenu

//
FUNCTION MenuGray( hMenu )
LOCAL    n
FOR n := 1 TO ItemCount( hMenu )
    @     ITEM[ n, IT_ROW  ], ITEM[ n, IT_COL ]                           ;
    SAY   ITEM[ n, IT_TEXT ]                                              ;
    COLOR MENU[ MN_COLOR, CL_NORMAL_GRAYED ]
END FOR
RETURN hMenu

//
FUNCTION MenuScanKey( hMenu, nKey )
LOCAL    nOpItem, nOpPrompt, bAction

FOR nOpItem := 1 TO ItemCount( hMenu )
 IF (nOpPrompt:=AScan(PROMPT, {|aPrompt| aPrompt[ PR_QKEY ] == nKey })) # 0
   EXIT
 END IF
END FOR

IF nOpPrompt # 0 .AND. nOpItem # ItemGet( hMenu )
   ItemGo( hMenu, nOpItem )
END IF

IF nOpPrompt # 0
   PromptGo( hMenu, nOpItem, nOpPrompt )
   bAction := PROMPT[ nOpPrompt, PR_BLOCK ]
END IF

RETURN bAction

// Funciones Set/Get. Cambian y/o informan de datos del MENU //////////////
FUNCTION MenuSetColor( hMenu, cSetColor )
LOCAL    cOldColor := MENU[ MN_COLOR ]
IF ValType(cSetColor) == "C"
   MENU[ MN_COLOR ] := cSetColor
END IF
RETURN cOldColor

//
FUNCTION MenuSetBorder( hMenu, cSetBorder )
LOCAL    cOldBorder := MENU[ MN_BORDER ]
IF ValType( cSetBorder ) == "C"
   MENU[ MN_BORDER ] := cSetBorder
END IF
RETURN cOldBorder

//
FUNCTION MenuTimeOut( hMenu, nSetTimeOut )
LOCAL    nOldTimeOut := MENU[ MN_TIMEOUT ]
IF ValType( nSetTimeOut ) == "N"
   MENU[ MN_TIMEOUT] := nSetTimeOut
END IF
RETURN nOldTimeOut

//
FUNCTION MenuBlock( hMenu, bSetBlock )
LOCAL    bOldBlock := MENU[ MN_BLOCK ]
IF ValType( bSetBlock ) == "B"
   MENU[ MN_BLOCK ] := bSetBlock
END IF
RETURN bOldBlock

//
FUNCTION MenuForceStable( hMenu, lSetForceStable )
LOCAL    lOldForceStable := MENU[ MN_FORCESTABLE ]
IF ValType( lSetForceStable ) == "L"
   MENU[ MN_FORCESTABLE ] := lSetForceStable
END IF
RETURN lOldForceStable

// Funcin sustituible por el usuario (parmetro de MenuExecute())
STATIC FUNCTION MenuReader( hMenu )
LOCAL  nStatus := ST_NONE, nKey, bKeyBlock, nElapTime := 0,               ;
       nTime   := Seconds(), nSeconds := MenuTimeOut( hMenu )

 WHILE ( nKey := Inkey() ) == 0 .AND. .NOT.                               ;
       ( ( nElapTime:=Seconds()-nTime ) >= nSeconds .AND. nSeconds # 0 )
   Eval( MenuBlock( hMenu ), hMenu )
 END WHILE

 DO CASE
   CASE nKey == K_DOWN                ; PromptDown( hMenu )
   CASE nKey == K_UP                  ; PromptUp( hMenu )
   CASE nKey == K_LEFT                ; ItemPrevious( hMenu )
   CASE nKey == K_RIGHT               ; ItemNext( hMenu )
   CASE nKey == K_ENTER               ; nStatus := PromptEval( hMenu )
   CASE nKey == K_ESC                 ; nStatus := ST_EXIT
   CASE nKey >= 32 .AND. nKey <= 255  ; PromptGoHotKey( hMenu, nKey )
   CASE nKey > 256 .AND. nKey < 310   ; ItemGoHotKey( hMenu, NoAlt(nKey) )
   CASE MenuScanKey(hMenu,nKey) # NIL ; nStatus := PromptEval( hMenu )
   CASE ( bKeyBlock := SetKey(nKey) ) # NIL
     Eval( bKeyBlock, ProcName( 1 ), ProcLine( 1 ) )
     nTime := Seconds() - nElapTime
 END CASE

RETURN nStatus

// Funciones enfocadas al ITEM ////////////////////////////////////////////
FUNCTION Item( hMenu )
RETURN ITEM

//
FUNCTION ItemNew( nRow, nCol, cText )
LOCAL    nAtHotKey := AT( "^", cText ), cHotKey, cOrigText := cText
cHotKey := SubStr( cText, nAtHotKey + 1, 1 )
cText   := Left( cText, nAtHotKey - 1 ) + SubStr( cText, nAtHotKey + 1 )
++hItem
RETURN aAdd( MENU[ MN_ITEMS ],                                            ;
             {nRow, nCol, cText, cOrigText, nAtHotKey, cHotKey,,1,{},{},0};
           )                                                              ;

//
FUNCTION ItemCount( hMenu )
RETURN   Len( ITEM )

FUNCTION ItemPut( hMenu, nOpItem )
RETURN   MENU[ MN_LASTITEM ] := nOpItem

FUNCTION ItemGet( hMenu )
RETURN   MENU[ MN_LASTITEM ]

//
FUNCTION ItemHilite( hMenu, nOpItem )
@     ITEM[ nOpItem, IT_ROW ], ITEM[ nOpItem, IT_COL]                     ;
SAY   ITEM[ nOpItem, IT_TEXT]                                             ;
COLOR MENU[ MN_COLOR, CL_HIGH ]

@     ITEM[ nOpItem, IT_ROW],                                             ;
      ITEM[ nOpItem, IT_COL] + ITEM[ nOpItem, IT_ATHOTKEY] - 1            ;
SAY   ITEM[ nOpItem, IT_HOTKEY]                                           ;
COLOR MENU[ MN_COLOR, CL_HIGH_KEY ]
RETURN nOpItem

//
FUNCTION ItemDeHilite( hMenu, nOpItem )
@     ITEM[ nOpItem, IT_ROW  ], ITEM[ nOpItem, IT_COL ]                   ;
SAY   ITEM[ nOpItem, IT_TEXT ]                                            ;
COLOR MENU[ MN_COLOR, CL_NORMAL ]

@     ITEM[ nOpItem, IT_ROW ],                                            ;
      ITEM[ nOpItem, IT_COL ] + ITEM[ nOpItem, IT_ATHOTKEY ] - 1          ;
SAY   ITEM[ nOpItem, IT_HOTKEY ]                                          ;
COLOR MENU[ MN_COLOR, CL_NORMAL_KEY ]
RETURN nOpItem

//
FUNCTION ItemDisplay( hMenu, nOpItem )
LOCAL    n := 0
DispBegin()
ItemHilite( hMenu, nOpItem )
//Pintar la caja y su sombra
@     PROMPT[ 1, PR_ROW ] - 1, PROMPT[ 1, PR_COL ] - 1 ,                  ;
      ATail( PROMPT )[ PR_ROW ] + 1,                                      ;
      ATail( PROMPT )[ PR_COL ] + ITEM[ nOpItem, IT_MAXLEN]               ;
BOX   MENU[ MN_BORDER ]                                                   ;
COLOR MENU[ MN_COLOR, CL_NORMAL ]

shadow(                                                                   ;
       PROMPT[ 1, PR_ROW ] - 1, PROMPT[ 1, PR_COL ] - 1,                  ;
       ATail( PROMPT )[ PR_ROW ] + 1,                                     ;
       ATail( PROMPT )[ PR_COL ] + ITEM[ nOpItem, IT_MAXLEN]              ;
      )
// Pintar los separadores
FOR n := 1 TO Len( ITEM[ nOpItem, IT_LINES ] )
      @ ITEM[ nOpItem, IT_LINES ][ n ], PROMPT[ 1, PR_COL ],              ;
        ITEM[ nOpItem, IT_LINES ][ n ],                                   ;
        PROMPT[ 1, PR_COL ] + ITEM[ nOpItem, IT_MAXLEN] - 1               ;
    BOX MENU[ MN_BORDER ]                                                 ;
  COLOR MENU[ MN_COLOR, CL_NORMAL ]
END FOR
//
n := 0
WHILE ( MENU[ MN_FORCESTABLE ] .OR. ( NextKey() # K_LEFT .AND.            ;
        NextKey() # K_RIGHT ) ) .AND. ++n <= PromptCount( hMenu, nOpItem )
    PromptDeHilite( hMenu, nOpItem, n )
END WHILE

PromptHilite( hMenu, nOpItem, PromptGet( hMenu, nOpItem )  )
DispEnd()
RETURN nOpItem

//
FUNCTION ItemHide( hMenu, nOpItem )
DispBegin()
ItemDeHilite( hMenu, nOpItem )
RestScreen( PROMPT[ 1, PR_ROW ] - 1, PROMPT[ 1, PR_COL ] - 1,             ;
            ATail( PROMPT )[ PR_ROW ] + 2,                                ;
            ATail( PROMPT )[ PR_COL ] + 1 + ITEM[ nOpItem, IT_MAXLEN],    ;
            ITEM[ nOpItem, IT_SCREEN ]                                    ;
          )
DispEnd()
RETURN nOpItem

//
FUNCTION ItemPrevious( hMenu )
LOCAL    nOpItem := ItemGet( hMenu )
ItemHide( hMenu, nOpItem )
IF nOpItem == 1
   IF Set( _SET_WRAP )
      nOpItem := ItemPut( hMenu, ItemCount( hMenu ) )
   END IF
ELSE
   nOpItem := ItemPut( hMenu, --nOpItem )
END IF
ItemDisplay( hMenu, nOpItem )
RETURN nOpItem

//
FUNCTION ItemNext( hMenu )
LOCAL    nOpItem := ItemGet( hMenu )
ItemHide( hMenu, nOpItem )
IF nOpItem == ItemCount( hMenu )
   IF Set( _SET_WRAP )
      nOpItem := ItemPut( hMenu, 1 )
   END IF
ELSE
   nOpItem := ItemPut( hMenu, ++nOpItem )
END IF
ItemDisplay( hMenu, nOpItem )
RETURN nOpItem

//
FUNCTION ItemGoHotKey( hMenu, nKey )
LOCAL    nAuxOpItem :=                                                    ;
         AScan( ITEM, { |aHotKeys| Upper( aHotKeys[ IT_HOTKEY ] ) ==      ;
                                        Upper( Chr( nKey ) ) }            ;
              )
IF nAuxOpItem > 0
   ItemGo( hMenu, nAuxOpItem )
END IF
RETURN  nAuxOpItem > 0

//
FUNCTION ItemGo( hMenu, nOpItem )
ItemHide( hMenu, ItemGet( hMenu ) )
RETURN ItemDisplay( hMenu, ItemPut( hMenu, nOpItem ) )

//
FUNCTION ItemRefresh( hMenu, nOpItem )
DEFAULT  nOpItem TO ItemGet( hMenu )
ItemConfigure( hMenu, nOpItem )
RETURN ItemDisplay( hMenu, ItemGet( hMenu ) )

//
FUNCTION ItemConfigure( hMenu, nOpItem )
LOCAL    nOpPrompt, aBuffer, nSpaces

ItemHide( hMenu, ItemGet( hMenu ) )
ITEM[ nOpItem, IT_ATHOTKEY ] := At( "^", ITEM[ nOpItem, IT_ORIGTEXT ] )
ITEM[ nOpItem, IT_HOTKEY   ] := SubStr( ITEM[ nOpItem, IT_ORIGTEXT ],     ;
                                        ITEM[ nOpItem, IT_ATHOTKEY ]+1, 1 )
ITEM[ nOpItem, IT_TEXT     ] := StrTran(ITEM[nOpItem, IT_ORIGTEXT],"^","" )

FOR nOpPrompt := 1 to PromptCount( hMenu, nOpItem ) - 1
   PromptConfigure( hMenu, nOpItem, nOpPrompt )
   IF PROMPT[ nOpPrompt, PR_ROW ] # PROMPT[ nOpPrompt + 1, PR_ROW ] - 1
      AAdd( ITEM[ nOpItem, IT_LINES],  PROMPT[ nOpPrompt, PR_ROW] + 1 )
   END IF
END FOR
PromptConfigure( hMenu, nOpItem, nOpPrompt )

nOpPrompt := 0
AEval( PROMPT, { | aPrompt |                                              ;
                  aBuffer := PromptSetText( hMenu, nOpItem, ++nOpPrompt ),;
                  nSpaces := ITEM[ nOpItem, IT_MAXLEN ] -                 ;
                             Len( aBuffer[1] + Space(1) + aBuffer[2] )+1, ;
                  aPrompt[ PR_TEXT ] := aBuffer[1] + Space( nSpaces )   + ;
                                        aBuffer[2]                        ;
               }                                                          ;
     )

ITEM[ nOpItem, IT_SCREEN ] := SaveScreen( PROMPT[ 1, PR_ROW ] - 1,        ;
                                          PROMPT[ 1, PR_COL ] - 1,        ;
                                          ATail( PROMPT )[ PR_ROW ] + 2,  ;
                                          ATail( PROMPT )[ PR_COL ] + 1 + ;
                                          ITEM[ nOpItem, IT_MAXLEN]       ;
                                        )
RETURN nOpItem

// Funciones Set/Get. Cambian y/o informan de datos del ITEM //////////////
FUNCTION ItemRow( hMenu, nOpItem, nSetRow )
LOCAL    nOldRow
DEFAULT  nOpItem TO ItemGet( hMenu )
nOldRow := ITEM[ nOpItem, IT_ROW ]
IF ValType( nSetRow ) == "N"
   ITEM[ nOpItem, IT_ROW ]  := nSetRow
END IF
RETURN nOldRow

//
FUNCTION ItemCol( hMenu, nOpItem, nSetCol )
LOCAL    nOldCol
DEFAULT  nOpItem TO ItemGet( hMenu )
nOldCol := ITEM[ nOpItem, IT_COL ]
IF ValType( nSetCol ) == "N"
   ITEM[ nOpItem, IT_COL ]  := nSetCol
END IF
RETURN nOldCol

//
FUNCTION ItemText( hMenu, nOpItem, cSetText )
LOCAL    cOldText
DEFAULT  nOpItem TO ItemGet( hMenu )
cOldText := ITEM[ nOpItem, IT_TEXT ]
IF ValType( cSetText ) == "C"
   ITEM[ nOpItem, IT_TEXT ]  := cSetText
END IF
RETURN cOldText

//
FUNCTION ItemHotKey( hMenu, nOpItem )
DEFAULT  nOpItem TO ItemGet( hMenu )
RETURN ITEM[ nOpItem, IT_HOTKEY ]

// Funciones enfocadas al PROMPT //////////////////////////////////////////
FUNCTION Prompt( hMenu, nOpItem )
RETURN PROMPT

//
FUNCTION PromptNew( nRow, nCol, cText, cMsg, bBlock, lActive, nQKey,      ;
                    cLabelKey, nBkType, lChecked )
DEFAULT  bBlock     TO {|| (Alert( "Actualmente sin utilidad..."),.T.) }, ;
         lActive    TO .T.                                              , ;
         cMsg       TO ""                                               , ;
         nQKey      TO  0                                               , ;
         cLabelKey  TO ""                                               , ;
         lChecked   TO .F.
RETURN   aAdd( ITEM[ hItem, IT_PROMPTS ],                                 ;
               { nRow, nCol, cText, cText, 0, "", cMsg, bBlock, lActive,  ;
                 nQKey, cLabelKey, nBkType, lChecked                      ;
               }                                                          ;
              )
//
FUNCTION PromptCount( hMenu, nOpItem )
RETURN   Len( PROMPT )

FUNCTION PromptPut( hMenu, nOpItem, nOpPrompt )
RETURN   ITEM[ nOpItem, IT_LASTPROMPT ] := nOpPrompt

FUNCTION PromptGet( hMenu, nOpItem )
RETURN ITEM[ nOpItem, IT_LASTPROMPT ]

//
FUNCTION PromptDeHilite( hMenu, nOpItem, nOpPrompt )
@     PROMPT[ nOpPrompt, PR_ROW  ], PROMPT[ nOpPrompt, PR_COL ]           ;
SAY   PROMPT[ nOpPrompt, PR_TEXT ]                                        ;
COLOR IF( PROMPT[ nOpPrompt, PR_WHEN ], MENU[ MN_COLOR, CL_NORMAL ],      ;
                                        MENU[ MN_COLOR, CL_NORMAL_GRAYED ];
        )

@     PROMPT[ nOpPrompt, PR_ROW  ], PROMPT[ nOpPrompt, PR_COL]            ;
SAY   Space( Len( DLM_LEFT ) )                                            ;
COLOR If( PROMPT[ nOpPrompt, PR_WHEN ], MENU[ MN_COLOR, CL_NORMAL],       ;
                                        MENU[ MN_COLOR, CL_NORMAL_GRAYED ];
        )

@     PROMPT[ nOpPrompt, PR_ROW ],                                        ;
      PROMPT[ nOpPrompt, PR_COL ] + Len( PROMPT[nOpPrompt,PR_TEXT] ) - 1  ;
SAY   Space( Len( DLM_RIGHT ) )                                           ;
COLOR If( PROMPT[ nOpPrompt, PR_WHEN ], MENU[ MN_COLOR, CL_NORMAL],       ;
                                        MENU[ MN_COLOR, CL_NORMAL_GRAYED ];
        )

@     PROMPT[ nOpPrompt, PR_ROW ],                                        ;
      PROMPT[ nOpPrompt, PR_COL ] + PROMPT[ nOpPrompt, PR_ATHOTKEY] - 1   ;
SAY   PROMPT[ nOpPrompt, PR_HOTKEY ]                                      ;
COLOR IF( PROMPT[ nOpPrompt, PR_WHEN ], MENU[ MN_COLOR, CL_NORMAL_KEY ],  ;
                                        MENU[ MN_COLOR, CL_NORMAL_GRAYED ];
        )
RETURN nOpPrompt

//
FUNCTION PromptHilite( hMenu, nOpItem, nOpPrompt )
@     PROMPT[ nOpPrompt, PR_ROW  ], PROMPT[ nOpPrompt, PR_COL]            ;
SAY   PROMPT[ nOpPrompt, PR_TEXT ]                                        ;
COLOR If( PROMPT[ nOpPrompt, PR_WHEN ], MENU[ MN_COLOR, CL_HIGH ],        ;
                                        MENU[ MN_COLOR, CL_HIGH_GRAYED ]  ;
        )

@     PROMPT[ nOpPrompt, PR_ROW  ], PROMPT[ nOpPrompt, PR_COL]            ;
SAY   DLM_LEFT                                                            ;
COLOR If( PROMPT[ nOpPrompt, PR_WHEN ], MENU[ MN_COLOR, CL_HIGH ],        ;
                                        MENU[ MN_COLOR, CL_HIGH_GRAYED ]  ;
        )

@     PROMPT[ nOpPrompt, PR_ROW ],                                        ;
      PROMPT[ nOpPrompt, PR_COL ] + Len( PROMPT[nOpPrompt,PR_TEXT] )-1    ;
SAY   DLM_RIGHT                                                           ;
COLOR If( PROMPT[ nOpPrompt, PR_WHEN ], MENU[ MN_COLOR, CL_HIGH ],        ;
                                        MENU[ MN_COLOR, CL_HIGH_GRAYED ]  ;
        )

@     PROMPT[ nOpPrompt, PR_ROW],                                         ;
      PROMPT[ nOpPrompt, PR_COL] + PROMPT[ nOpPrompt, PR_ATHOTKEY] - 1    ;
SAY   PROMPT[ nOpPrompt, PR_HOTKEY]                                       ;
COLOR If( PROMPT[ nOpPrompt, PR_WHEN ], MENU[ MN_COLOR, CL_HIGH_KEY ],    ;
                                        MENU[ MN_COLOR, CL_HIGH_GRAYED ]  ;
        )

@     MENU[ MN_ROWMSG ], 0 SAY PROMPT[ nOpPrompt, PR_MESSAGE ]            ;
COLOR MENU[ MN_COLOR, CL_NORMAL ]

RETURN nOpPrompt

//
FUNCTION PromptDown( hMenu )
LOCAL    nOpPrompt, nOpItem := ItemGet( hMenu )
nOpPrompt := PromptGet( hMenu, nOpItem )

PromptDeHilite( hMenu, nOpItem, nOpPrompt )
IF nOpPrompt == PromptCount( hMenu, nOpItem )
   IF Set( _SET_WRAP )
      nOpPrompt := PromptPut( hMenu, nOpItem, 1 )
   END IF
ELSE
   nOpPrompt := PromptPut( hMenu, nOpItem, ++nOpPrompt )
END IF

RETURN PromptHilite( hMenu, nOpItem, nOpPrompt )

//
FUNCTION PromptUp( hMenu )
LOCAL nOpPrompt, nOpItem := ItemGet( hMenu )
nOpPrompt := PromptGet( hMenu, nOpItem )

PromptDeHilite( hMenu, nOpItem, nOpPrompt )
IF nOpPrompt == 1
   IF Set( _SET_WRAP )
      nOpPrompt := PromptPut( hMenu, nOpItem, PromptCount( hMenu, nOpItem))
   END IF
ELSE
   nOpPrompt := PromptPut( hMenu, nOpItem, --nOpPrompt )
END IF
PromptHilite( hMenu, nOpItem, nOpPrompt )

RETURN nOpPrompt

//
FUNCTION PromptGoHotKey( hMenu, nKey )
LOCAL nAuxOpPrompt, nOpItem := ItemGet( hMenu )
nAuxOpPrompt := AScan( PROMPT, { |aHotKeys| Upper(aHotKeys[PR_HOTKEY]) == ;
                                            Upper( Chr( nKey) )           ;
                               }                                          ;
                     )
IF nAuxOpPrompt > 0 .AND. PromptWhen( hMenu, nOpItem, nAuxOpPrompt )
   PromptGo( hMenu, nOpItem, nAuxOpPrompt)
END IF
RETURN nAuxOpPrompt > 0

//
FUNCTION PromptGo( hMenu, nOpItem, nOpPrompt )
PromptDeHilite( hMenu, nOpItem, PromptGet( hMenu, nOpItem ) )
RETURN PromptHilite( hMenu, nOpItem, PromptPut(hMenu, nOpItem, nOpPrompt))

//
FUNCTION PromptRefresh( hMenu, nOpItem, nOpPrompt )
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
PromptConfigure( hMenu, nOpItem, nOpPrompt )
RETURN PromptHilite( hMenu, ItemGet( hMenu ),                             ;
                            PromptGet( hMenu, ItemGet( hMenu ) ) )

//
FUNCTION PromptConfigure( hMenu, nOpItem, nOpPrompt )
LOCAL    aBuffer := PromptSetText( hMenu, nOpItem, nOpPrompt )

PROMPT[ nOpPrompt, PR_TEXT ] := aBuffer[1] + Space(1) + aBuffer[2]
ITEM[ nOpItem, IT_MAXLEN ]   := Max( Len( PROMPT[ nOpPrompt, PR_TEXT ] ), ;
                                     ITEM[nOpItem, IT_MAXLEN]             ;
                                   )

PROMPT[ nOpPrompt, PR_MESSAGE ]:=If( Set( _SET_MCENTER),                  ;
                                     PadC( PROMPT[ nOpPrompt, PR_MESSAGE],;
                                           MaxCol() + 1 ),                ;
                                     PadR( PROMPT[ nOpPrompt, PR_MESSAGE],;
                                           MaxCol() + 1 )                 ;
                                   )
RETURN nOpPrompt

// Funciones Set/Get. Cambian y/o informan de datos del PROMPT
FUNCTION PromptWhen( hMenu, nOpItem, nOpPrompt, lSetWhen )
LOCAL    lOldWhen
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
lOldWhen := PROMPT[ nOpPrompt, PR_WHEN ]
IF ValType( lSetWhen ) == "L"
   PROMPT[ nOpPrompt, PR_WHEN ] := lSetWhen
END IF
RETURN lOldWhen

//
FUNCTION PromptBlock( hMenu, nOpItem, nOpPrompt, bSetBlock )
LOCAL    bOldBlock
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
bOldBlock := PROMPT[ nOpPrompt, PR_BLOCK ]
IF ValType( bSetBlock ) == "B"
   PROMPT[ nOpPrompt, PR_BLOCK ]  := bSetBlock
END IF
RETURN bOldBlock

//
FUNCTION PromptChecked( hMenu, nOpItem, nOpPrompt )
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
PROMPT[ nOpPrompt, PR_LCHECKED ] := Eval( PromptBlock( hMenu ), ;
                                          PROMPT[ nOpPrompt, PR_LCHECKED ])
PromptRefresh( hMenu, nOpItem, nOpPrompt )
RETURN PROMPT[ nOpPrompt, PR_LCHECKED ]

//
FUNCTION PromptMessage( hMenu, nOpItem, nOpPrompt, cSetMessage )
LOCAL    cOldMessage
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
cOldMessage := PROMPT[ nOpPrompt, PR_MESSAGE ]
IF ValType( cSetMessage ) == "C"
   PROMPT[ nOpPrompt, PR_MESSAGE ]  := cSetMessage
END IF
RETURN cOldMessage

//
FUNCTION PromptRow( hMenu, nOpItem, nOpPrompt, nSetRow )
LOCAL    nOldRow
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
nOldRow := PROMPT[ nOpPrompt, PR_ROW ]
IF ValType( nSetRow ) == "N"
   PROMPT[ nOpPrompt, PR_ROW ] := nSetRow
END IF
RETURN nOldRow

//
FUNCTION PromptCol( hMenu, nOpItem, nOpPrompt, nSetCol )
LOCAL    nOldCol
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
nOldCol := PROMPT[ nOpPrompt, PR_COL ]
IF ValType( nSetCol ) == "N"
   PROMPT[ nOpPrompt, PR_COL ] := nSetCol
END IF
RETURN nOldCol

//
FUNCTION PromptText( hMenu, nOpItem, nOpPrompt, cSetText )
LOCAL    cOldText
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
cOldText := PROMPT[ nOpPrompt, PR_TEXT ]
IF ValType( cSetText ) == "C"
   PROMPT[ nOpPrompt, PR_ORIGTEXT ] := cSetText
END IF
RETURN cOldText

//
FUNCTION PromptQuickKey( hMenu, nOpItem, nOpPrompt, nSetQuickKey )
LOCAL    nOldQuickKey
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
nOldQuickKey := PROMPT[ nOpPrompt, PR_QKEY ]
IF ValType( nSetQuickKey ) == "N"
   PROMPT[ nOpPrompt, PR_QKEY ] := nSetQuickKey
END IF
RETURN nOldQuickKey

//
FUNCTION PromptHotKey( hMenu, nOpItem, nOpPrompt )
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
RETURN   PROMPT[ nOpPrompt, PR_HOTKEY ]

//
FUNCTION PromptType( hMenu, nOpItem, nOpPrompt )
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
RETURN   PROMPT[ nOpPrompt, PR_BKTYPE]

// Se evalua el CodeBlock segn el tipo de PROMPT asignado en la creacin
FUNCTION PromptEval( hMenu, nOpItem, nOpPrompt )
LOCAL    nStatus := ST_NONE, cSaveScr
DEFAULT  nOpItem   TO ItemGet( hMenu)                                    ,;
         nOpPrompt TO PromptGet( hMenu, ItemGet( hMenu) )
IF PromptWhen( hMenu )
   DO CASE
      CASE PromptType( hMenu, nOpItem, nOpPrompt ) == BK_CHECKED
           PromptChecked( hMenu )
           nStatus := ST_CHECKED

      CASE PromptType( hMenu, nOpItem, nOpPrompt ) == BK_MENU
           Eval( PromptBlock( hMenu ), hMenu )
           nStatus := ST_MENU

      OTHERWISE
           cSaveScr := SaveScreen()
           ItemHide( hMenu, nOpItem, nOpPrompt )
           MenuGray( hMenu )
           MenuMsgHide( hMenu, nOpItem, nOpPrompt )
           IF Eval( PromptBlock( hMenu ), hMenu )
              RestScreen( ,,,, cSaveScr )
           END IF
           nStatus := ST_EVAL
   END CASE
END IF
RETURN nStatus

//
STATIC FUNCTION PromptSetText( hMenu, nOpItem, nOpPrompt )
LOCAL  cLeftBuffer  := Space( 2 ) + PROMPT[ nOpPrompt, PR_ORIGTEXT ],     ;
       cRightBuffer := PROMPT[ nOpPrompt, PR_LABELKEY ] + Space( 1 )

DO CASE
 CASE PROMPT[nOpPrompt, PR_BKTYPE] == BK_MENU
   cRightBuffer := Stuff( cRightBuffer, Len(cRightBuffer),1, SetMenuChar())

 CASE PROMPT[nOpPrompt, PR_BKTYPE] == BK_CHECKED
   cLeftBuffer  := If( PROMPT[ nOpPrompt, PR_LCHECKED ],                  ;
                       Stuff( cLeftBuffer, 1, 2, SetOkChar() + " " ),     ;
                       Stuff( cLeftBuffer, 1, 2, "  " )                   ;
                     )
END CASE

cRightBuffer := cRightBuffer + Space( Len( DLM_RIGHT ) )
cLeftBuffer  := Space( Len( DLM_LEFT ) ) + cLeftBuffer
cLeftBuffer  := cLeftBuffer + Space(                                      ;
                                     Len(PROMPT[ nOpPrompt, PR_TEXT ]) -  ;
                                     Len( cLeftBuffer + cRightBuffer )    ;
                                   )
PROMPT[ nOpPrompt, PR_ATHOTKEY ] := AT("^", cLeftBuffer )
PROMPT[ nOpPrompt, PR_HOTKEY ]   := SubStr( cLeftBuffer,                  ;
                                            PROMPT[nOpPrompt,PR_ATHOTKEY]+;
                                            1, 1 )

RETURN { StrTran( cLeftBuffer, "^", "" ), cRightbuffer }

// FUNCIONES SET/GET GENERALES ////////////////////////////////////////////
FUNCTION SetOkChar( cSetOkChar )
STATIC   cOkChar    := CHAR_OK
LOCAL    cOldOkChar := cOkChar
IF ValType( cSetOkChar ) == "C"
   cOkChar := cSetOkChar
END IF
RETURN cOldOkChar

//
FUNCTION SetMenuChar( cSetMenuChar )
STATIC   cMenuChar    := CHAR_MENU
LOCAL    cOldMenuChar := cMenuChar
IF ValType( cSetMenuChar ) == "C"
   cMenuChar := cSetMenuChar
END IF
RETURN cOldMenuChar

//
FUNCTION SetMenuDelim( cSetMenuDelim )
STATIC   cMenuDelim    := CHAR_DELIMITERS
LOCAL    cOldMenuDelim := cMenuDelim
IF ValType( cSetMenuDelim ) == "C"
   cMenuDelim := cSetMenuDelim
END IF
RETURN cOldMenuDelim

// FUNCIONES AUXILIARES ///////////////////////////////////////////////////
#define KEY      1
#define ALTKEY   2
//
FUNCTION NoAlt( nKey )
LOCAL aAltKeys :=                                                     ;
{                                                                     ;
 {65,286}, {66,304}, {67,302}, {68,288}, {69,274}, {70,289}, {71,290},;
 {72,291}, {73,279}, {74,292}, {75,293}, {76,294}, {77,306}, {78,305},;
 {79,280}, {80,281}, {81,272}, {82,275}, {83,287}, {84,276}, {85,278},;
 {86,303}, {87,273}, {88,301}, {89,277}, {90,300}                     ;
}
nKey := AScan( aAltKeys, { | aKeys | aKeys[ ALTKEY ] == nKey } )
RETURN If( nKey # 0, aAltKeys[ nKey, KEY ], 0 )

//
STATIC FUNCTION Shadow( nRowUp, nColLeft, nRowDn, nColRight )
LOCAL  cOldScrLeft:=SaveScreen(nRowUp+1,nColRight+1,nRowDn+1,nColRight+1),;
       cOldScrDown:=SaveScreen(nRowDn+1,nColLeft +1,nRowDn+1,nColRight  )
RestScreen( nRowUp + 1, nColRight+1, nRowDn+1, nColRight + 1,             ;
            Transform( cOldScrLeft,                                       ;
                       Replicate( "A", Len( cOldScrLeft ) / 2 ) ) )
RestScreen( nRowDn + 1, nColLeft + 1, nRowDn + 1, nColRight,              ;
            Transform( cOldScrDown,                                       ;
                       Replicate( "A", Len( cOldScrDown ) / 2 ) ) )
RETURN NIL

//
STATIC  FUNCTION ColorToA( cColor )
LOCAL   aColor := { '','','','','','' }, n, nPosPreComa
DEFAULT cColor TO SetColor()
FOR n := 1 TO 6
    nPosPreComa := At( ',', cColor ) - 1
    IF nPosPreComa > 0
       aColor[ n ] := Left( cColor, nPosPreComa )
       cColor      := SubStr( cColor, nPosPreComa + 2 )
    ELSE
       aColor[ n ] := cColor
       EXIT
    END IF
END FOR
RETURN aColor