/*
   HABLAR.PRG
   Permite dialogar entre dos ordenadores mediante
   funciones de acceso directo a ficheros y conectados
   ambos equipos con un supresor de mdem.

   (c) Grupo EIDOS
*/
#include "FILEIO.CH"
#include "INKEY.CH"

FUNCTION Hablar()
   LOCAL GetList := {}
   LOCAL nPuerto, cOrden, cVar
   LOCAL cLeido := '', lControl := .F.

   CLS

   // Visualizacin en pantalla
   @ 10,00 SAY Replicate( '',79 )
   @ 11,00 SAY 'Enviar '
   @ 12,00 SAY Replicate( '',79 )
   @ 13,00 SAY 'Recibido '
   @ 14,00 SAY Replicate( '',79 )

   // Apertura del puerto
   nPuerto := FOpen( 'COM1', FO_READWRITE )
   IF FError() != 0
      ? 'Se ha producido un error en COM1'
   END IF

   // Controlar quien comienza con el dialogo.
   // Ser el primero en leer el carcter en
   // cuestin
   FWrite( nPuerto, Chr(45) )
   IF FReadStr( nPuerto,1 ) == Chr(45)
      lControl := .T.
   END IF

   WHILE .T.
     // Si no fue el primero en recibir el
     // carcter, se queda a verlas venir
     IF !lControl
        cVar := ''
        WHILE InKey() != K_ESC
          // Lee un slo carcter
          cLeido := FReadStr( nPuerto,1 )
          IF cLeido != '@'
             cVar += cLeido
          ELSE
             EXIT
          END IF
        END WHILE
     END IF

     lControl := .F.

     @ 13,12 SAY Space( 60 )
     @ 13,12 SAY cVar

     @ 13,00 SAY 'Recibido ' COLOR 'W'
     @ 11,00 SAY 'Enviar '   COLOR 'W+*'

     // Mensaje a enviar
     cOrden := Space( 60 )
     @ 11,12 GET cOrden
     READ

     // Si alguno pulsa ESC, mandar un mensaje
     // al otro indicndolo
     IF LastKey() == K_ESC
        FWrite(nPuerto, 'Comunicacin Abortada@')
        // Tiempo que permite que el mensaje se
        // enve antes de cerrar el puerto
        InKey( 3 )
        EXIT
     END IF

     @ 11,00 SAY 'Enviar '   COLOR 'W'
     @ 13,00 SAY 'Recibido ' COLOR 'W+*'

     // Enviar Mensaje por el puerto
     FWrite( nPuerto, AllTrim( cOrden ) + '@' )

   END WHILE

   FClose( nPuerto )
   CLS

RETURN NIL
