/*
   HARDMENU.PRG

   Generacin de mens de discos duros.

   Utilizacin tcnicas Data-Driven y uso
   de ERRORLEVEL()

   (c) Grupo EIDOS
*/
#include "FileIO.ch"
#include "InKey.ch"
#include "Common.ch"

FUNCTION Main( cMasOpc )
   LOCAL GetList := {}
   LOCAL nHandle
   LOCAL cNombre
   LOCAL cDirec
   LOCAL cExe
   LOCAL nAux, nOpc
   LOCAL aLineas
   LOCAL cTodo
   LOCAL nLinea, nColum
   LOCAL cColor := SetColor( '/W,R/N+' )

   CLS

   Set( _SET_SCOREBOARD, .F. )
   Set( _SET_WRAP      , .T. )
   DEFAULT cMasOpc TO ''

   // Caja
   CajaConc( 00,00,24,79 )

   // Si se pasa el parmetro de nueva opcin o no
   // existe el fichero MENU.CFG
   IF Upper( cMasOpc ) == 'NEW' .OR. !File( 'MENU.CFG' )
      CajaConv( 01,03,09,71 )

      @ 02,04 SAY ' NUEVAS OPCIONES ' COLOR 'R/W'

      WHILE .T.
            // Nuevas opciones
            cNombre := Space( 15 )
            cDirec  := Space( 45 )
            cExe    := Space( 8 )

            // Ttulo de la opcin
            @ 04,05 SAY     'Nombre opcin     ' ;
                    GET     cNombre              ;
                    PICTURE '@!'

            // Ubicacin del ejecutable
            @ 06,05 SAY     'PATH              ' ;
                    GET     cDirec               ;
                    PICTURE '@!'

            // Nombre del ejecutable
            @ 08,05 SAY     'Nombre ejecutable ' ;
                    GET     cExe                 ;
                    PICTURE '@!'
            READ

            IF LastKey() == K_ESC
               CajaConc( 20,43,22,76 )
               @ 21,46 SAY   'Ahora debe ejecutar MENU.BAT' ;
                       COLOR 'R*/W'
               InKey( 2 )
               EXIT
            END IF

            cNombre := AllTrim( cNombre )
            cDirec  := AllTrim( cDirec )
            cExe    := AllTrim( cExe )

            // Validar ruta
            IF Right( cDirec, 1 ) != '\'
               cDirec += '\'
            END IF

            cNombre := cNombre + Space( 15 - Len( cNombre ) )
            cDirec  := cDirec  + Space( 45 - Len( cDirec ) )
            cExe    := cExe    + Space(  8 - Len( cExe ) )

             // Crear fichero .CFG con la informacin del men
            IF !File( "MENU.CFG" )
               // Si no existe se crea
               nHandle := FCreate( "MENU.CFG", FC_NORMAL )
            ELSE
               // Si existe se abre
               nHandle := FOpen( "MENU.CFG", FO_READWRITE )
            END IF

            // Nos posicionamos al final del fichero
            FSeek( nHandle, 0, FS_END )

            // Aadimos la informacin de la nueva opcin
            FWrite( nHandle, cNombre + cDirec + cExe +;
                    Chr( 13 ) + Chr( 10 ) )

            // Cerramos fichero
            FClose( nHandle )
      END WHILE

      // Al introducir nuevas opciones borramos fichero MENU.BAT
      FErase( 'MENU.BAT' )

      // Crear fichero .BAT con la informacin del men
      IF !File( "MENU.BAT" )
         // Leer lo que tenemos en MENU.CFG
         cTodo := MemoRead( "MENU.CFG" )

         // Array con la informacin de cada una de
         // las distintas opciones
         aLineas := Array( MlCount( cTodo, 68 ) )

         // Cargamos array con el contenido de todas las lneas
         FOR nAux := 1 TO MlCount( cTodo, 68 )
             aLineas[nAux] := MemoLine( cTodo, 68, nAux )
         NEXT

         // Crear fichero .BAT
         nHandle := FCreate( "MENU.BAT", FC_NORMAL )
         FWrite( nHandle, 'REM **** MENU DE DISCO DURO ****' +;
                          Chr(13) + Chr(10) )
         FWrite( nHandle, ':INICIO'  + Chr(13) + Chr(10) )
         FWrite( nHandle, 'HARDMENU' + Chr(13) + Chr(10) )
         FWrite( nHandle, 'CLS'      + Chr(13) + Chr(10) )

         // Espacio en blanco
         FWrite( nHandle, Chr( 13 ) + Chr( 10 ) )

         // Escribir lineas de ERRORLEVEL en fichero .BAT
         FOR nAux := 1 TO Len( aLineas )
             FWrite( nHandle, 'IF ERRORLEVEL '                + ;
                              AllTrim( Str( 100 - nAux, 3 ) ) + ;
                              ' GOTO OPC'                     + ;
                              AllTrim( Str( 100 - nAux, 3 ) ) + ;
                              Chr( 13 ) + Chr( 10 ) )
         END FOR

         // Fijar salida de men
         FWrite( nHandle, 'IF ERRORLEVEL 0 GOTO FIN'          + ;
                          Chr( 13 ) + Chr( 10 ) )

         // Escribir lineas de opciones
         FOR nAux := 1 TO Len( aLineas )
             FWrite( nHandle, Chr( 13 ) + Chr( 10 ) )

             // Escribir opcin
             FWrite( nHandle, ':OPC'                          + ;
                              AllTrim( Str( 100 - nAux, 3 ) ) + ;
                              Chr( 13 ) + Chr( 10 ) )

             cDirec := AllTrim( SubStr( aLineas[ nAux ], 16, 45 ) )
             cDirec := Left( cDirec, Len( cDirec ) - 1 )

             // Determinar ubicacin
             FWrite( nHandle, 'CD ' +;
                              cDirec + ;  // RUTA
                              Chr( 13 ) + Chr( 10 ) )

             // Nombre de ejecutable
             FWrite( nHandle, Left( aLineas[ nAux ], 15 )  + ;
                              Chr( 13 ) + Chr( 10 ) )

             // Vuelta al directorio principal
             FWrite( nHandle, 'CD \' + ;
                              Chr( 13 ) + Chr( 10 ) )

             // Ir de nuevo a HARDMENU.EXE
             FWrite( nHandle, 'GOTO INICIO' + ;
                              Chr( 13 ) + Chr( 10 ) )
         END FOR

         // Opcin salida
         FWrite( nHandle, ':FIN' + ;
                          Chr( 13 ) + Chr( 10 ) )
         FWrite( nHandle, 'CLS' + ;
                          Chr( 13 ) + Chr( 10 ) )
      END IF

      // Cerrar fichero MENU.BAT
      FClose( nHandle )
   ELSE
      // Leer lo que tenemos en MENU.CFG
      cTodo := MemoRead( "MENU.CFG" )

      aLineas := Array( MlCount( cTodo, 68 ) )

      // Cargamos array con el contenido de todas las lneas
      FOR nAux := 1 TO MlCount( cTodo, 68 )
          aLineas[nAux] := MemoLine( cTodo, 68, nAux )
      NEXT

      // Pintamos cajas
      CajaConc( 01,01,03,78 )

      @ 02,03 SAY 'HARDMENU v 1.0'  COLOR 'B/W'
      @ 02,60 SAY '(c) Grupo EIDOS' COLOR 'R/W'

      // Dibujar cajas de diferentes opciones
      nLinea := 5
      FOR nAux := 1 TO 6
          CajaConv( nLinea,02, nLinea + 2,19 )
          CajaConv( nLinea,21, nLinea + 2,38 )
          CajaConv( nLinea,40, nLinea + 2,57 )
          CajaConv( nLinea,59, nLinea + 2,76 )
          nLinea += 3
      END FOR

      // Cargamos array con las distintas opciones
      // formando el men
      nLinea := 6
      nColum := 3
      FOR nAux := 1 TO Len( aLineas )
          @ nLinea, nColum PROMPT PadC( Left( aLineas[nAux], 15 ), 15 )
          nColum += 19
          IF nColum > 70
             nLinea += 3
             nColum := 3
          END IF
      NEXT

      MENU TO nOpc

      // Salida con ERRORLEVEL dependiendo
      // de opcin elegida
      IF nOpc == 0 .OR. LastKey() == K_ESC
         ErrorLevel( 0 )
      ELSE
         ErrorLevel( 100 - nOpc )
      END IF
   END IF
   SetColor( cColor )
   CLS
RETURN NIL
//

/*
   CAJACONV()

   Caja tipo convexa

   (c) Grupo EIDOS
*/
FUNCTION CajaConv( nX,nY,nXX,nYY )
   LOCAL nAux
   @ nX    ,nY,nXX,nYY BOX "Ŀ "  COLOR "W+/W"
   @ nX    ,nYY        SAY ""          COLOR "N+/W"
   FOR nAux := nX + 1 TO nXX - 1
       @ nAux,nYY        SAY ""        COLOR "N+/W"
   END FOR
   @ nXX,nY + 1 SAY Replicate( "",nYY - nY - 1 ) +;
                               "" COLOR "N+/W"
RETURN NIL
//

/*
   CAJACONC()

   Caja tipo concava

   (c) Grupo EIDOS

*/
FUNCTION CajaConc( nX,nY,nXX,nYY )
   LOCAL nAux

   @ nX, nY  TO nXX,nYY  COLOR "N+/W"
   @ nX, nYY SAY ""     COLOR "W+/W"

   FOR nAux := nX + 1 TO nXX - 1
       @ nAux,nYY  SAY ""  COLOR "W+/W"
   END FOR

   @ nXX,nY + 1 SAY REPLICATE( "",nYY - nY - 1 ) + "" COLOR "W+/W"
RETURN NIL
