// Objects.ch ver 1.2

#ifndef _OBJECTS_CH
#define _OBJECTS_CH

#xcommand DEFAULT <uVar1> := <uVal1> ;
               [, <uVarN> := <uValN> ] => ;
                  <uVar1> := If( <uVar1> == nil, <uVal1>, <uVar1> ) ;;
                [ <uVarN> := If( <uVarN> == nil, <uValN>, <uVarN> ); ]

#xcommand CLASS <ClassName> [ FROM <Parent1>] [ ,<ParentN> ] => ;
          function <ClassName>() ;;
             static nClassHandle, abParents ;;
                if nClassHandle == nil ;;
                   ClsNew( <"ClassName"> ,;
                   abParents := { [ { || <Parent1>() } ] ;
                                  [,{ || <ParentN>() } ] } ) ;;
                   [#define PARENT <"Parent1">]

#xcommand DATA <cVar1> [,<cVarN>] => ;
            ClsAddData( <"cVar1">, 0 ) ;
         [; ClsAddData( <"cVarN">, 0 ) ]

// ASPEN Sintax
#xcommand DATA <Var> READONLY => ClsAddData( <"Var">, 1 )

// dBase for Windows Sintax (without 'DATA')
#xcommand DATA <Var> HIDDEN => ClsAddData( <"Var">, 1 )

#xcommand METHOD <MethodName>( [<uParms,...>] ) => ;
            ClsAddMethod( Upper( <"MethodName"> ), ;
            { | Self [, <uParms> ] | <MethodName>( Self [, <uParms> ] ) } )


#xcommand METHOD <MethodName>( [<uParms,...>] ) VIRTUAL => ;
            ClsAddMethod( Upper( <"MethodName"> ), { || nil } )

#xcommand ENDCLASS => ;
                nClassHandle = nClsMake() ;;
             end ;;
          return __ClassIns( nClassHandle )

#xtranslate :: => Self:


//------ METHODS Sintax -----------

// C++ sintax
#xtranslate METHOD <cClassName>::<cMethodName>( [<uParms,...>] ) => ;
         static function <cMethodName>( Self [, <uParms>] ) // CLASS <ClassName>

// ASPEN sintax
#xtranslate METHOD <MethodName>( [<uParms,...>] ) CLASS <ClassName> => ;
         static function <MethodName>( Self [, <uParms>] ) // CLASS <ClassName>

// dbase for Windows sintax
#xtranslate FUNCTION <ClassName>.<MethodName>( [<uParms,...>] ) => ;
         static function <MethodName>( Self [, <uParms>] ) // CLASS <ClassName>

//---------------------------------

#xtranslate ::Parent:<Method>([<uParms,...>])  => ;
            Eval( bClsMethod( Upper( PARENT ), Upper( <"Method"> ) ),;
            Self [,<uParms>] )

#endif