////////////////////////////////////////////////////////////////////////////
//
// Fichero:    TBFUN.PRG
// Fecha:      3-9-98
// Contenido:  Funciones control objeto TBrowse
// Notas:      Tomado de Grupo Eidos
//
//
////////////////////////////////////////////////////////////////////////////


#Include "Common.ch"
#Include "inkey.ch"



FUNCTION TbStd( oTb, bPie, bAlta, nSegundos )
  LOCAL    nTecla

  // Control de parmetros
  DEFAULT bAlta     TO { || NIL }
  DEFAULT bPie      TO { || NIL }
  DEFAULT nSegundos TO 0

  DispBegin()
  WHILE NextKey() == 0 .AND. !oTb:stabilize()
  END WHILE
  DispEnd()

  Eval(bPie, oTb)   // CodeBlock que se evala a cada 
                    // estabilizacin

  // CodeBlock que se evala a cuando estamos al final y
  // pulsamos flecha abajo o si pilsamos [Insert]
  IF (LastKey()==K_DOWN .AND. oTb:hitBottom) .OR.;
     LastKey() == K_INS 
     Eval(bAlta, oTb)
  END IF

  nTecla := InKey( nSegundos )

  DO CASE

     CASE nTecla == K_DOWN .AND. !oTb:hitBottom
          oTb:down()

     CASE nTecla == K_UP.AND. !oTb:hitTop
          oTb:up()

     CASE nTecla == K_RIGHT .OR. nTecla == K_TAB
          IF oTb:colPos == oTb:colCount
             oTb:down()
             oTb:panHome()
           ELSE
             oTb:right()
          END IF

     CASE nTecla == K_LEFT .OR. nTecla == K_SH_TAB
          IF oTb:colPos ==  1
             oTb:up()
             oTb:panEnd()
           ELSE
             oTb:left()
          END IF

     CASE nTecla == K_PGDN
          oTb:pageDown()

     CASE nTecla == K_PGUP
          oTb:pageUp()

     CASE nTecla == K_HOME
          oTb:home()

     CASE nTecla == K_END
          oTb:end()

     CASE nTecla == K_CTRL_LEFT
          oTb:panLeft()

     CASE nTecla == K_CTRL_RIGHT
          oTb:panRight()

     CASE nTecla == K_CTRL_PGUP
          oTb:goTop()

     CASE nTecla == K_CTRL_HOME
          oTb:panHome()

     CASE nTecla == K_CTRL_END
          oTb:panEnd()

     CASE nTecla == K_CTRL_PGDN
          oTb:goBottom()


  END CASE

RETURN nTecla



/***
*  FUNCIONES PARA EL MOVIMIENTO DE TBROWSE CON Y SIN FILTROS
*
*/

//
FUNCTION IrInicio( xExpr )
 DBSEEK( xExpr )
RETURN NIL

//
FUNCTION IrFin( xExpr )
LOCAL lSS := SET(_SET_SOFTSEEK, .T.)
 IF VALTYPE( xExpr ) = "C"
    DBSEEK( SUBSTR( xExpr, 1, LEN( xExpr ) - 1 ) +;
            CHR( ASC( SUBSTR( xExpr, LEN( xExpr ) ) ) + 1) )
 ELSE
    DBSEEK( xExpr + 1 )
 END IF
 DBSKIP(-1)

 SET(_SET_SOFTSEEK, lSS)
RETURN NIL

//
FUNCTION IrA( n, bWhile )
LOCAL nSkipped := 0, nDireccion := IF(n > 0, 1, -1)

 DO WHILE nSkipped != n .AND. EVAL( bWhile ) .AND. !EOF() .AND. !BOF()
    DBSKIP( nDireccion )
    nSkipped += nDireccion
 END DO

 DO CASE
    CASE EOF()
         DBSKIP(-1)
         nSkipped += -nDireccion

    CASE BOF()
         DBGOTO( RECNO() )
         nSkipped++

    CASE !EVAL( bWhile )
         DBSKIP(-nDireccion)
         nSkipped += -nDireccion

 END CASE

RETURN nSkipped


//
FUNCTION PasArray(nSalto, nLenArray, nIndice)
LOCAL nSaltado := 0

    IF  nSalto > 0 .AND. nIndice < nLenArray + 1
        WHILE  nSaltado < nSalto
               nIndice++
               IF  nIndice > nLenArray
                   nIndice := nLenArray
                   EXIT
               ENDIF
               nSaltado++
        ENDDO

     ELSEIF  nSalto < 0
        WHILE  nSaltado > nSalto
               nIndice--
               IF  nIndice = 0
                   nIndice := 1
                   EXIT
               ENDIF
               nSaltado--
        ENDDO
    ENDIF

RETURN nSaltado