////////////////////////////////////////////////////////////////////////////
//
// Fichero:    FACTURAS.PRG
// Fecha:      3-9-98
// Contenido:  Funciones facturacion
// Notas:
//
//
////////////////////////////////////////////////////////////////////////////


#INCLUDE "box.ch"
#INCLUDE "inkey.ch"
#INCLUDE "SetCurs.ch"
#INCLUDE "menus.ch"
#INCLUDE "Fileio.ch"
#INCLUDE "def.ch"
#INCLUDE "DbStruct.ch"
#INCLUDE "Miget.ch"


MEMVAR getList






/* Ŀ
    MUESTRA FACTURA         
                            
    */
FUNCTION MuestraFactura (aEdicion)

LOCAL nCursor := SetCursor (SC_NONE)
LOCAL i
LOCAL cCadena

dispBegin()

// Nmero de factura, Fecha, Nhc

@ 2, 15 SAY padr(aEdicion[FAC_NFACTURA],        L_NFACTURA) PICTURE maskNum5
@ 3, 15 SAY padr(aEdicion[FAC_FECHA],           L_FECHA)    PICTURE mascaraFecha
@ 4, 15 SAY padr(aEdicion[FAC_NHC, FAC_NHCNHC], L_NHC)      PICTURE maskNum5

// Paciente

muestraPaciente (aEdicion[FAC_NHC, FAC_NHCAPE], aEdicion[FAC_NHC, FAC_NHCNOM])

// Imprime cuotas de IVA

MuestraCuotas (aEdicion)

// Imprime totales de la factura

MuestraTotales (aEdicion)

// Imprime apuntes de la factura

ListaApuntes (aEdicion, FAC_VISUALIZA)

if Deleted()
   @ 1,0 SAY "Factura borrada!"
else
   @ 1,0 SAY "                 "
endif

dispEnd()

SetCursor (nCursor)

RETURN .t.







/* Ŀ
    ENTRADA FACTURAS        
                            
    */
FUNCTION InsertaFactura (aEdicion, nModo)

LOCAL nCursor := SetCursor (SC_NORMAL)
LOCAL cColor  := SetColor (COL_V1)
LOCAL GetList := {}
LOCAL nNhc    := aEdicion[FAC_NHC, FAC_NHCNHC]
LOCAL dFecha  := aEdicion[FAC_FECHA]
LOCAL cCadena
LOCAL lOk



// Tecla programada para la bsqueda de pacientes
SET KEY K_F2 TO BuscaPaciente

// Nmero de factura no editable
@ 2, 15 SAY padr(aEdicion[FAC_NFACTURA], L_NFACTURA) PICTURE maskNum5

// Borro la chuleta 'factura borrada'
@ 1,0 SAY "                 "

// Fecha
@ 3, 15 GET dFecha                                                           ;
	PICTURE mascaraFecha                                                 ;
	MESSAGE "Fecha de la factura"                                        ;
	COLORMSG COL_MSG

// Nhc
@ 4, 15 GET nNhc                                                             ;
  PICTURE maskNum5                                                  ;
	VALID valNhc(nNhc)                                                   ;
	MESSAGE "Nmero de historia clnica del paciente (F2 para buscar)"   ;
	COLORMSG COL_MSG

READ

if LastKey() = K_ESC
   RETURN .f.
endif

SET KEY K_F2 TO

lOk := ListaApuntes(aEdicion, nModo)

if !lOk
   RETURN .f.
endif

// Calculo de todos los datos referentes a las cuotas de Iva

CalCuotas (aEdicion)

// Calculo de los totales de la factura

CalTotales (aEdicion)

// Salvo los valores de Fecha y Nhc

aEdicion[FAC_NHC, FAC_NHCNHC] := nNhc
aEdicion[FAC_FECHA]           := dFecha

SetCursor (nCursor)
SetColor (cColor)

RETURN .t.









/* Ŀ
    INI FACTURAS            
                            
    */
FUNCTION IniFactura ()

LOCAL aEdicion := asize({}, FAC_LEN)

aEdicion[FAC_NFACTURA]               := facturas->nFactura + 1
aEdicion[FAC_FECHA]                  := CtoD ("  -  -  ")
aEdicion[FAC_TOTAL]                  := 0
aEdicion[FAC_TOTIMP]                 := 0
aEdicion[FAC_TOTCUOTA]               := 0

aEdicion[FAC_NHC]                    := iniPaciente()

aEdicion[FAC_AUX]                    := {iniApuntes()}

aEdicion[FAC_CUO]                    := {iniCuotas()}

RETURN aEdicion







/* Ŀ
    SALVAR FACTURA          
                            
    */
FUNCTION SalvarFactura (aEdicion)

LOCAL nTabla      := alias()
LOCAL nOrd        := indexOrd()


// Si no tiene la dimension adecuada lo redimensiono

if (len(aEdicion) != FAC_LEN, aEdicion := asize(aEdicion, FAC_LEN), nil)

// Guardo los valores generales de la factura

aEdicion[FAC_NFACTURA] := facturas->nFactura
aEdicion[FAC_FECHA]    := facturas->Fecha
aEdicion[FAC_TOTAL]    := facturas->Importe

// Valores del paciente

aEdicion[FAC_NHC]      := salvarPaciente(facturas->Nhc)

// Valores de los apuntes

aEdicion[FAC_AUX]      := salvarApuntes(aEdicion[FAC_NFACTURA])

// Calculo de todos los datos referentes a las cuotas de Iva

CalCuotas (aEdicion)

// Calculo de totales de la factura

CalTotales (aEdicion)

SELECT (nTabla)
ordenFacturas(nOrd)

RETURN .t.






/* Ŀ
    VOLCAR FACTURAS         
                            
    */
FUNCTION VolcarFactura (aEdicion)


// Vuelco los datos de factura

facturas->nFactura := aEdicion[FAC_NFACTURA]
facturas->Fecha    := aEdicion[FAC_FECHA]
facturas->Nhc      := aEdicion[FAC_NHC, FAC_NHCNHC]
facturas->Importe  := aEdicion[FAC_TOTAL]
DbCommit()

// Vuelco los apuntes de la factura

VolcarApuntes (aEdicion[FAC_AUX], aEdicion[FAC_NFACTURA])

RETURN .t.






/* Ŀ
    EDICION DE FACTURAS     
                            
    */
FUNCTION Facturas (nNhc, dFecha)

// dFecha y nNhc solo se utilizan para la introduccion automatica de facturas desde visitas

LOCAL aEdicion    := {}
LOCAL aOldEdicion := {}
LOCAL salir       := .f.
LOCAL nCursor     := SetCursor (SC_NONE)
LOCAL cColor      := SetColor (COL_V1LOW)
LOCAL graba       := savescreen (0,0,24,79)
LOCAL botones, aBotones, nBoton
LOCAL lFound
LOCAL lOk
LOCAL cAux


@ 0,0 clear to 24,79

xPonVentana (6, 3, 14, 76, COL_V1, SUB)
xPonVentana (15, 3, 20, 40, COL_V1, SUB)

cAux := xGetConfig("CN_EJERCICIO")
cAux := substr(cAux,1,1) + " " + substr(cAux,2,1)
if (len(cAux) <= 1, cAux := "", cAux := "    " + cAux)

xPonTitulo("F A C T U R A C I O N" + cAux, COL_TITULOESC)
@ 1, 0 SAY "                                                                                "
@ 2, 0 SAY "       FACTURA                                                                  "
@ 3, 0 SAY "         FECHA                                                                  "
@ 4, 0 SAY "           NHC                                                                  "
@ 5, 0 SAY "      PACIENTE                                                                  "
@ 16, 6 SAY "Base Imponible  IVA   Cuota IVA"
@ 17, 6 SAY ""

// Totales
if (xFaseConvivencia())
  xPonVentana (17, 44, 20, 76, COL_V1, SOBRE)
  @ 15,46 SAY "Total importe"
  @ 16,46 SAY "Total cuota IVA"
  @ 18,46 SAY "TOTAL FACTURA"
else
  xPonVentana (18, 44, 20, 76, COL_V1, SOBRE)
  @ 16,46 SAY "Total importe"
  @ 17,46 SAY "Total cuota IVA"
  @ 19,46 SAY "TOTAL FACTURA"
endif

// Ventana de ordenacion
@ 2,63 SAY "Ordenado por"

// Color para el resto
SetColor(COL_V1)

// Insercion automatica de factura
if (dFecha <> nil) .AND. (nNhc <> nil)
  SELECT FACTURAS
  ordenFacturas(I1FACTURAS)
  GO BOTTOM
  aEdicion := iniFactura ()
  aEdicion[FAC_FECHA] := dFecha
  aEdicion[FAC_NHC] := salvarPaciente(nNhc)
  MuestraFactura (aEdicion)
  lOk := InsertaFactura (aEdicion, FAC_INSERTA)
  if lOk
    DbAppend ()
    volcarFactura (aEdicion)
  endif
  setColor (cColor)
  SetCursor (nCursor)
  restscreen(0, 0, 24, 79, graba)
  return nil
endif

aBotones := { {"^Nue",K_INS, "Aade una nueva factura"},                  ;
	      {"^Mod",K_CTRL_ENTER,     ;
         "Modifica los datos actuales de la factura" },             ;
	      {"^Elim",K_DEL, "Elimina/Recupera la factura"},             ;
        {"N^um",K_F2, "Busca una factura por nmero"},              ;
	      {"^Fecha",K_CTRL_F2, asc("B"), asc("b"), ;
	       "Busca una factura por fecha"},                            ;
        {"^Ord",K_F3, "Cambia la ordenacion actual"},               ;
        {"^Lis",K_CTRL_F3, "Hojea las facturas en lista"},          ;
	      {"^Imp", K_F4, "Imprime la factura actual"},                ;
	      {"^Rang", K_F5, "Imprime un rango de facturas"},            ;
        {"^"+chr(29),K_UP,K_DOWN,K_PGDN, K_PGUP, K_HOME, K_END,      ;
        "Otros movimientos: (Arriba), (Abajo), (AvPg), (RePg), (Inicio), (Fin)" }    ;
	    }
botones := xPonBotones(aBotones,22,COL_V1,COL_V1R,COL_MSG,CENTRADOS)

SELECT FACTURAS
ordenFacturas(I1FACTURAS)
GO TOP

salvarFactura (@aEdicion)
salvarFactura (@aOldEdicion)

DO WHILE .NOT. salir
muestraFactura (aEdicion)
nBoton := xLeeBotones (botones)
do case

/* Ŀ
    Salida                  
                            
    */

	case nBoton = 0

		salir := .T.

/* Ŀ
    Aadir una factura      
                            
    */

	case nBoton = 1

    SELECT FACTURAS
    ordenFacturas(I1FACTURAS)
		GO BOTTOM
		salvarFactura (@aOldEdicion)
      aEdicion := iniFactura ()
      MuestraFactura (aEdicion)
      xQuitaBotones (botones)
		lOk := InsertaFactura (aEdicion, FAC_INSERTA)
      IF lOk
			DbAppend ()
			volcarFactura (aEdicion)
      ELSE
	 aEdicion := aOldEdicion
		ENDIF
      xRestauraBotones (botones)
      salvarFactura(@aEdicion)

/* Ŀ
    Modificar una factura   
                            
    */

	case nBoton = 2

		SalvarFactura (@aEdicion)
      SalvarFactura (@aOldEdicion)
      xQuitaBotones (botones)
		lOk := InsertaFactura (@aEdicion, FAC_MODIFICA)
		if lOk
        VolcarFactura (aEdicion)
      else
        aEdicion := aOldEdicion
      endif
      // Vacio el buffer de teclazos
      do while Inkey() != 0
      enddo
      xRestauraBotones (botones)

/* Ŀ
    Eliminar una factura    
                            
    */

	case nBoton = 3

		borrarFactura (aEdicion)

/* Ŀ
    Buscar nmero factura   
                            
    */

	case nBoton = 4

      ordenFacturas(I1FACTURAS)
      lFound := BuscarFactura (FAC_BUSCANUM)
      if lFound
        SalvarFactura (@aEdicion)
      endif

/* Ŀ
    Buscar fecha factura    
                            
    */

	case nBoton = 5

      ordenFacturas(I2FACTURAS)
      lFound := BuscarFactura (FAC_BUSCAFECHA)
      if lFound
        SalvarFactura (@aEdicion)
      endif

/* Ŀ
    Cambia ordenacion       
                            
    */

  case nBoton = 6

      ordenFacturas ()

/* Ŀ
    Lista facturas          
                            
    */

  case nBoton = 7

      listaFacturas()
      if lastKey() != K_ESC
       salvarFactura (@aEdicion)
      endif


/* Ŀ
    Imprime factura         
                            
    */

  case nBoton = 8

      IniInforme ("factura.txt",                          ;
		  {||InfFactura(aEdicion[FAC_NFACTURA])}, ;
		  .t. )

/* Ŀ
    Imprime rango facturas  
                            
    */

  case nBoton = 9

      ImpRangFacturas()

/* Ŀ
    Otros movimientos       
                            
    */

   case nBoton = 10

      do case
        case xUltimaTecla(botones) = K_UP
          subeFactura ()
        case xUltimaTecla(botones) = K_DOWN
          bajaFactura()
        case xUltimaTecla(botones) = K_PGUP
          RePagFactura (aEdicion[FAC_NFACTURA])
        case xUltimaTecla(botones) = K_PGDN
          AvPagFactura (aEdicion[FAC_NFACTURA])
        case xUltimaTecla(botones) = K_HOME
          GO TOP
        case xUltimaTecla(botones) = K_END
          GO BOTTOM
      endcase
      salvarFactura (@aEdicion)

endcase
enddo

setColor (cColor)
SetCursor (nCursor)
xQuitaBotones (Botones)

restscreen(0, 0, 24, 79, graba)

RETURN .t.



/* Ŀ
    RETROCEDER              
                            
    */
FUNCTION subeFactura ()
  IF ! bof ()                   // si no estamos en el primero
	skip -1                 // subimos uno
  ENDIF
RETURN nil



/* Ŀ
    AVANZAR                 
                            
    */
FUNCTION bajaFactura ()
  IF ! eof ()                   // si no estamos en el ultimo
	skip +1                 // bajamos uno
	IF eof()                // si nos hemos pasado
	    skip -1             // subimos al ultimo
	ENDIF
  ENDIF
RETURN nil


/* Ŀ
    AVANZAR PAGINA          
                            
    */
FUNCTION AvPagFactura  (nFactura)
  IF  lastRec () - nFactura > 4
	skip +4
  ENDIF
RETURN nil


/* Ŀ
    RETROCEDER PAGINA       
                            
    */
FUNCTION RePagFactura  (nFactura)
  IF  nFactura > 4
	skip -4
  ENDIF
RETURN nil




/* Ŀ
    BUSCAR FACTURA          
                            
    */
/*  nTipo = FAC_BUSCAFECHA --> Busqueda por fecha
    nTipo = FAC_BUSCANUM   --> Busqueda por numero */

FUNCTION BuscarFactura (nTipo, cColorAux)

LOCAL GetList  := {}
LOCAL nNum     := 0
LOCAL dFecha   := ctod ("  -  -  ")
LOCAL cColor
LOCAL nCursor  := SetCursor (SC_NORMAL)
LOCAL ventana
LOCAL lFound


if cColorAux = nil
  cColorAux := COL_V2
endif
cColor := SetColor(cColorAux)

SELECT FACTURAS
ventana := xPonVentana(8,20,16,61,cColorAux,SOBRE)

if nTipo = FAC_BUSCANUM

   @ 10, 28 SAY "BUSQUEDA FACTURA POR NUMERO"
   @ 12, 36 GET nNum PICTURE mascaraJustIzq ;
	    MESSAGE "Nmero de la factura a buscar" ;
	    COLORMSG COL_MSG
   READ
   lFound := dbSeek(nNum)

else

   @ 10, 28 SAY "BUSQUEDA FACTURA POR FECHA"
   @ 12, 36 GET dFecha PICTURE mascaraJustIzq ;
	    MESSAGE "Fecha de la factura a buscar" ;
	    COLORMSG COL_MSG
   READ
   lFound := dbSeek(dFecha)

endif

IF .NOT. lFound
	SetCursor (SC_NONE)
	@ 14,33 SAY "No encontrada!"
	xInkey (0,0)
ENDIF

xQuitaVentana (ventana)
SetColor (cColor)
SetCursor (nCursor)

RETURN lFound





/* Ŀ
    ORDEN  FACTURAS         
                            
    */
/* Cambia la ordenacion de las facturas entre los dos indices:
       Numero   -->  I1FACTURAS
       Fecha    -->  I2FACTURAS
   Si no se pasa parametro se activa el orden contrario
*/
FUNCTION ordenFacturas (nOrden)

LOCAL cColor := SetColor(COL_V1)
STATIC nOrdActivo := I1FACTURAS

if nOrden != nil
   set order to nOrden
   nOrdActivo := nOrden
else
   if nOrdActivo = I1FACTURAS
      set order to I2FACTURAS
      nOrdActivo := I2FACTURAS
   else
      set order to I1FACTURAS
      nOrdActivo := I1FACTURAS
   endif
endif
if nOrdActivo = I1FACTURAS
   @ 3, 63 SAY "> FACTURA"
   @ 4, 63 SAY "  FECHA"
else
   @ 3, 63 SAY "  FACTURA"
   @ 4, 63 SAY "> FECHA"
endif

SetColor(cColor)

RETURN .t.




/* Ŀ
    BORRAR FACTURA          
                            
    */
FUNCTION BorrarFactura (aEdicion)

LOCAL lBorrar
LOCAL i

if !Deleted()
   xMensaje ({"","La factura ser marcada como borrada", ""}, ;
	     COL_V2, COL_V2R, WARNING)
   DbDelete()
   lBorrar := .t.

else
   xMensaje ({"","La factura ser marcada como activa", ""}, ;
	     COL_V2, COL_V2R, WARNING)
   DbRecall()
   lBorrar := .f.

endif

for i := 1 to len(aEdicion[FAC_AUX])

   if lBorrar

      aEdicion[FAC_AUX, i, FAC_AUXBORRADO] := .t.

   else

      aEdicion[FAC_AUX, i, FAC_AUXBORRADO] := .f.

   endif

next

RETURN .t.





/* Ŀ
    IMPRESION RANGO FACTURAS 
                             
    */
FUNCTION ImpRangFacturas()

LOCAL ventana := xPonVentana(8,20,16,53,COL_V2,SOBRE)
LOCAL nDesde := 0
LOCAL nHasta := 0
LOCAL cColor   := SetColor (COL_V2)
LOCAL nCursor  := SetCursor (SC_NORMAL)
LOCAL nTabla   := alias()
LOCAL nOrd     := indexOrd()
LOCAL lFound   := .f.
LOCAL nAux


SELECT FACTURAS
ordenFacturas(I1FACTURAS)

@ 10, 26 SAY "IMPRESION DE FACTURAS"
@ 12, 30 SAY "Desde"
@ 13, 30 SAY "Hasta"

// Obtencion del rango
   @ 12, 36 GET nDesde PICTURE mascaraJustIzq ;
	    MESSAGE "Minimo numero de factura" ;
	    COLORMSG COL_MSG                   ;
	    VALID dbSeek(nDesde)
   @ 13, 36 GET nHasta PICTURE mascaraJustIzq ;
	    MESSAGE "Maximo numero de factura" ;
	    COLORMSG COL_MSG                   ;
	    VALID dbSeek(nHasta)
   READ
   xQuitaVentana (ventana)
   if Lastkey() = K_ESC
      // Terminacion
      SetColor (cColor)
      SetCursor (nCursor)
      SELECT (nTabla)
      ordenFacturas(nOrd)
      RETURN nil
   endif

// Rango correcto
if nDesde > nHasta
   nAux := nHasta
   nHasta := nDesde
   nDesde := nAux
endif

// Informes de todas menos de la ultima van al mismo archivo
FOR nAux := nDesde TO nHasta-1
   IniInforme ("rangfact.txt",{||InfFactura(nAux,.f.)},.f.,.t.)
NEXT

// Ultima factura ya se visualiza
IniInforme ("rangfact.txt",{||InfFactura(nHasta,.f.)},.t.,.t.)

// Terminacion
SetColor (cColor)
SetCursor (nCursor)
SELECT (nTabla)
ordenFacturas(nOrd)

RETURN nil




/* Ŀ
    LISTA DE FACTURAS       
                            
    */
FUNCTION ListaFactura()

LOCAL bCol1 := {|| padr(alltrim(str(facturas->nFactura)), L_NFACTURA)        + " " + ;
                   padr(facturas->Fecha,                  L_FECHA)           + " " + ;
                   substr(padr(pacienteListaFactura(facturas->Nhc),50),1,50) + " " + ;
                   padr(facturas->Importe,                xLongImporte()) }
LOCAL oCol1 := TBColumnNew(padr("NUM",       L_NFACTURA)       + " " + ;
                           padr("FECHA",     L_FECHA)          + " " + ;
                           padr("PACIENTE",  50)               + " " + ;
                           padr("IMPORTE",   xLongImporte()),         ;
                           bCol1)
LOCAL bMenu := {|| BotFactura(oBrw) }
LOCAL oBrw  := TBrowseDB(4,3,16,76) // Construye el TBrowse
LOCAL cColor  := SetColor (COL_V2)
LOCAL nCursor := SetCursor (SC_NONE)
LOCAL nRec    := 1
LOCAL ventana := xPonVentana(3,2,21,78,COL_V2,SOBRE)
LOCAL nTabla  := alias()
LOCAL nOrd    := indexOrd()
LOCAL nTecla
LOCAL botones, nboton, abotones
LOCAL lLeeBoton
LOCAL cMensaje
LOCAL nRow

   SELECT FACTURAS
   set order to I2FACTURAS

   // Guardo el mensaje que habia
   nRow     := Set(_SET_MESSAGE)
   cMensaje := SaveScreen(nRow,0,nRow,MaxCol())

   // Efectos especiales
   oBrw:colorSpec(COL_V2)
   oBrw:headSep  := ""

   // Carga las columnas al TBrowse
   oBrw:addColumn(oCol1)

   // Bucle de proceso
   WHILE .T.
      nTecla := TbStd(oBrw, bMenu)       // Teclas automatizadas
      DO CASE
      CASE nTecla == K_ESC .or. nTecla == K_SPACE
         // situo el puntero en el registro
         nRec := facturas->(RecNo())
         EXIT
      ENDCASE
   END WHILE

   facturas->(DbGoto(nRec))
   xQuitaVentana(ventana)
   SetColor(cColor)
   SetCursor(nCursor)
   SELECT (nTabla)
   set order to (nOrd)

   // pongo el mensaje que habia
   RestScreen(nRow,0,nRow,MaxCol(),cMensaje)

RETURN .t.




/* Ŀ
    BOTONES LISTA FACTURAS  
                            
    */
FUNCTION BotFactura(oBrw)

STATIC aBotFact := { {"^Seleccin",K_SPACE, "Selecciona la factura"},        ;
                     {"N^um",K_F2, "Bsqueda factura por numero"},           ;
                     {"^Fecha",K_CTRL_F2, "Bsqueda factura por fecha"},     ;
                     {"^"+chr(25), K_DOWN, "Baja una factura"},               ;
                     {"^"+chr(24), K_UP, "Sube una factura"},                 ;
                     {"^AvPg", K_PGDN, "Avanza una pgina"},                 ;
                     {"^RePg", K_PGUP, "Retrocede una pgina"}               ;
                   }
STATIC lBotFact := .f.
STATIC botFact
LOCAL nBoton

   if !lBotFact
      botFact := xPonBotones (aBotFact, 19, COL_V2, COL_V2R, COL_MSG, CENTRADOS, 1)
      lBotFact := .t.
   endif

   xRestauraBotones(botFact)
   nBoton := xLeeBotones(botFact)

   DO CASE
      case nBoton = 0
        KEYBOARD Chr(K_ESC)

      case nBoton = 1
        KEYBOARD Chr(K_SPACE)

      case nBoton = 2
         oBrw:GoTop()
         set order to I1FACTURAS
         buscarFactura(FAC_BUSCANUM, COL_V1)
         oBrw:refreshAll()
         oBrw:forceStable()

      case nBoton = 3
         oBrw:GoTop()
         set order to I2FACTURAS
         buscarFactura(FAC_BUSCAFECHA, COL_V1)
         oBrw:refreshAll()
         oBrw:forceStable()

      case nBoton = 4
        KEYBOARD Chr(K_DOWN)

      case nBoton = 5
        KEYBOARD Chr(K_UP)

      case nBoton = 6
        KEYBOARD Chr(K_PGDN)

      case nBoton = 7
        KEYBOARD Chr(K_PGUP)

   ENDCASE

RETURN NIL




/* Ŀ
    PACIENTE LISTA FACTURAS 
                            
    */
FUNCTION pacienteListaFactura(nNhc)

LOCAL cPaciente := space(30)
LOCAL nTabla  := alias()
LOCAL nOrd    := indexOrd()

  SELECT PACIENTE
  set order to I2PACIENTE
  if DbSeek(nNhc)
    cPaciente := alltrim(paciente->Apellidos) + ", " + alltrim(paciente->Nombre)
  endif

  SELECT (nTabla)
  set order to (nOrd)

RETURN cPaciente






/* ͻ
                                                  
      A P U N T E S   D E   L A   F A C T U R A   
                                                  
   ͼ */





/* Ŀ
    LISTA APUNTES FACTURA   
                            
    */
FUNCTION ListaApuntes (aEdicion, nModo)

/* Nota:

     nModo = FAC_VISUALIZA --> Modo visualizacion
     nModo = FAC_MODIFICA  --> Modo modificacion
     nModo = FAC_INSERTA   --> Modo insercion
*/

LOCAL bCol1 := {|| if (aEdicion[FAC_AUX, nIndice, FAC_AUXBORRADO],                   ;
		       "" + alltrim(str(aEdicion[FAC_AUX, nIndice, FAC_AUXCOD])),   ;
		       " " + alltrim(str(aEdicion[FAC_AUX, nIndice, FAC_AUXCOD]))) }

LOCAL oCol1 := TBColumnNew("COD", bCol1)

LOCAL oCol2 := TBColumnNew("CONCEPTO",                                     ;
			   {|| aEdicion[FAC_AUX, nIndice, FAC_AUXTRAT]})
LOCAL oCol3 := TBColumnNew("CNT",                                          ;
			   {|| aEdicion[FAC_AUX, nIndice, FAC_AUXCANT]})
LOCAL oCol4 := TBColumnNew("PRECIO",                                       ;
			   {|| aEdicion[FAC_AUX, nIndice, FAC_AUXBASE]})
LOCAL oCol5 := TBColumnNew("IVA",                                          ;
			   {|| aEdicion[FAC_AUX, nIndice, FAC_AUXIVA]})
LOCAL oCol6 := TBColumnNew("IMPORTE",                                      ;
			   {|| aEdicion[FAC_AUX, nIndice, FAC_AUXIMP]})

LOCAL oBrw    := TBrowseDB(7,4,13,75) // Construye el TBrowse

LOCAL bMenu   := {|| BotApuntes(oBrw) }

LOCAL nTabla  := alias()
LOCAl nOrd    := indexOrd()
LOCAL cColor  := SetColor(COL_V1)
LOCAL nCursor := SetCursor(SC_NONE)
LOCAL nIndice := 1
LOCAL lSalir  := .f.
LOCAL lOk     := .t.
LOCAL graba
LOCAL nTecla
LOCAL aApunte


// Efectos especiales
oBrw:colorSpec(COL_V1)
oBrw:colSep   := " "
oBrw:headSep  := ""

//CodeBlocks de movimiento
oBrw:goTopBlock    := { | | nIndice := 1 }
oBrw:goBottomBlock := { | | nIndice := LEN(aEdicion[FAC_AUX]) }
oBrw:skipBlock     := { |n| PasArray( n, LEN(aEdicion[FAC_AUX]), @nIndice ) }

// Efectos en las columnas
oCol1:picture := mascaraJustIzq
oCol1:width   := L_CODTRAT + 1

oCol2:width   := L_TRATAM

oCol3:picture := maskNum5
oCol3:width   := L_CANTIDAD

oCol4:picture := xMascaraImporte()
oCol4:width   := xLongImporte()

oCol5:picture := xMascaraIva()
oCol5:width   := xLongIVA() + 1

oCol6:picture := xMascaraImporte()
oCol6:width   := xLongImporte()

// Carga las columnas al TBrowse
oBrw:addColumn(oCol1)
oBrw:addColumn(oCol2)
oBrw:addColumn(oCol3)
oBrw:addColumn(oCol4)
oBrw:addColumn(oCol5)
oBrw:addColumn(oCol6)

DO WHILE !lSalir

   DO CASE

   /* Ŀ
       Visualizacion           
                               
       */
      CASE nModo = FAC_VISUALIZA

	// Fuerzo una visualizacion no destacada

	oBrw:deHilite()

	// Estabilizo el Tb y salgo

	DO WHILE !oBrw:stabilize()
	ENDDO
	lSalir := .t.

   /* Ŀ
       Modificacion            
                               
       */
      // Aqui podemos modificar e insertar nuevos apuntes

      CASE nModo = FAC_MODIFICA .or. nModo = FAC_INSERTA

	if nModo = FAC_MODIFICA

	   // No tenemos ningun apunte vacio por si queremos aadir
	   // Aado un apunte vacio

	   aApunte := nuevoApuntes(aEdicion[FAC_AUX])
	   InsertaApuntes (aEdicion, aApunte)

	endif

	// Estabilizo el Tb

	DO WHILE !oBrw:stabilize()
	ENDDO

	// Para evitar problemas con los botones y la barra

	graba := savescreen (21, 0, 24, 79)

	DO WHILE !lSalir

	   // Dejamos libertad de movimientos para seleccionar
	   // el apunte deseado

	   nTecla := TbStd (oBrw, bMenu)

	   IF nTecla = K_CTRL_ENTER .or. nTecla = K_INS

	      if nTecla = K_INS

		 // si queremos insertar nos colocamos en el apunte vacio

		 nIndice := PosVacio (aEdicion[FAC_AUX])

	      endif

	      // Queremos editar el apunte

	      if PosVacio(aEdicion[FAC_AUX]) = nIndice

		 // estamos editando el apunte vacio

		 aApunte := aEdicion[FAC_AUX, nIndice]
		 EntradaApunte (aApunte)

		 if LastKey() != K_ESC

		    // doy por buena la modificacion

		    aEdicion[FAC_AUX, nIndice] := aApunte

		    // creo otro apunte vacio

		    aApunte := nuevoApuntes(aEdicion[FAC_AUX])
		    InsertaApuntes (aEdicion, aApunte)

		 endif

	      else

		 // estamos editando un apunte normal

		 aApunte := aEdicion[FAC_AUX, nIndice]
		 EntradaApunte (aApunte)

		 if LastKey() != K_ESC

		    // doy por buena la modificacion

		    aEdicion[FAC_AUX, nIndice] := aApunte

		 endif

	      endif

	      // Refresco la visualizacion
	      oBrw:refreshAll()
	      oBrw:forceStable()

	   ELSEIF nTecla = K_DEL

	      // No dejo borrar el apunte vacio

	      if PosVacio(aEdicion[FAC_AUX]) != nIndice

		 if aEdicion[FAC_AUX, nIndice, FAC_AUXBORRADO]

		    if xMensaje ({"","El apunte ser marcado como activo",""}, ;
				 COL_V2, COL_V2R, WARNING)

		       aEdicion[FAC_AUX, nIndice, FAC_AUXBORRADO] := .f.

		    endif

		 else

		    if xMensaje ({"","El apunte ser marcado como borrado",""}, ;
				 COL_V2, COL_V2R, WARNING)

		       aEdicion[FAC_AUX, nIndice, FAC_AUXBORRADO] := .t.

		    endif

		 endif

		 // Refresco la visualizacion
		 oBrw:refreshAll()
		 oBrw:forceStable()

	      endif

	   ELSEIF nTecla = K_ESC

	      lSalir := .t.

	      // Quitamos el apunte vacio si no es el unico que hay

	      if len(aEdicion[FAC_AUX]) != 1 .or. ;
		 PosVacio(aEdicion[FAC_AUX]) != 1

		 BorraVacio (aEdicion[FAC_AUX])

	      endif

	   ENDIF

	ENDDO

	restscreen (21, 0, 24, 79, graba)

    ENDCASE

ENDDO

SetColor (cColor)
SetCursor (nCursor)

SELECT (nTabla)
set order to (nOrd)

RETURN lOk





/* Ŀ
    BOTONES DE APUNTES      
                            
    */
FUNCTION BotApuntes(oBrw)

STATIC aBotones := { {"^Terminar",K_ESC, "Termina la edicion de apuntes"},          ;
		     {"^Nue",K_INS, "Aade un nuevo apunte"},                       ;
		     {"^Mod",K_CTRL_ENTER, "Modifica los datos del apunte actual"}, ;
		       {"^Elim",K_DEL, "Elimina/Recupera el apunte actual"},          ;
		     {"^"+chr(25), K_DOWN, "Avanza un apunte"},                     ;
		     {"^"+chr(24), K_UP, "Retrocede un apunte"},                    ;
		     {"^AvPg", K_PGDN, "Avanza una pgina"},                       ;
		     {"^RePg", K_PGUP, "Retrocede una pgina"}                     ;
		   }
STATIC lBotonesOk := .f.
STATIC botones
LOCAL  nBoton



   if !lBotonesOk

      botones := xPonBotones (aBotones, 22, COL_V1, COL_V1R, COL_MSG, CENTRADOS, 2)
      lBotonesOk := .t.

   endif

   xRestauraBotones(botones)

   nBoton := xLeeBotones(botones)

   DO CASE

      case nBoton = 0 .or. nBoton = 1

	KEYBOARD Chr(K_ESC)

      case nBoton = 2

	KEYBOARD Chr(K_INS)

      case nBoton = 3

	KEYBOARD Chr(K_CTRL_ENTER)

      case nBoton = 4

	KEYBOARD Chr(K_DEL)

      case nBoton = 5

	KEYBOARD Chr(K_DOWN)

      case nBoton = 6

	KEYBOARD Chr(K_UP)

      case nBoton = 7

	KEYBOARD Chr(K_PGDN)

      case nBoton = 8

	KEYBOARD Chr(K_PGUP)

   ENDCASE

RETURN NIL



/* Ŀ
    INSERCION APUNTES       
                            
    */
FUNCTION InsertaApuntes (aEdicion, aApunte)

LOCAL nLong  := len(aEdicion[FAC_AUX])

aEdicion[FAC_AUX]        := asize(aEdicion[FAC_AUX], nLong + 1)
nLong++
aEdicion[FAC_AUX, nLong] := aApunte

RETURN .t.




/* Ŀ
    BUSCA POSICION APUNTE   
                            
    */
FUNCTION PosApunte (aApuntes, aApunteBuscar)

LOCAL nApunte   := 1
LOCAL lFound    := .f.


do while len(aApuntes) >= nApunte .and. !lFound
   if xaComp(aApuntes[nApunte], aApunteBuscar)
      lFound := .t.
   else
      nApunte++
   endif
enddo

if !lFound
   nApunte := 0
endif

RETURN nApunte



/* Ŀ
    BUSCA POSICION VACIO    
                            
    */
/* Nota:

   Vamos a buscar el apunte vacio  (CodTrat == 0)
*/
FUNCTION PosVacio (aApuntes)

LOCAL nApunte   := 1
LOCAL lFound    := .f.


do while len(aApuntes) >= nApunte .and. !lFound
   if aApuntes[nApunte, FAC_AUXCOD] = 0
      lFound := .t.
   else
      nApunte++
   endif
enddo

if !lFound
   nApunte := 0
endif

RETURN nApunte




/* Ŀ
    QUITA APUNTE            
                            
    */
FUNCTION BorraApunte (aApuntes, aApunteQuitar)

LOCAL nApunte

nApunte := PosApunte (aApuntes, aApunteQuitar)

if nApunte != 0
   aDel (aApuntes, nApunte)
   aApuntes := aSize (aApuntes, len(aApuntes) - 1)
endif

RETURN .t.



/* Ŀ
    QUITA VACIO             
                            
    */
FUNCTION BorraVacio (aApuntes)

LOCAL nApunte

nApunte := PosVacio (aApuntes)

if nApunte != 0
   aDel (aApuntes, nApunte)
   aApuntes := aSize (aApuntes, len(aApuntes) - 1)
endif

RETURN .t.




/* Ŀ
    NUEVO APUNTE INSERCION  
                            
    */
FUNCTION NuevoApuntes(aApuntes)

LOCAL aApunte  := iniApuntes()
LOCAL nLong    := len(aApuntes)
LOCAL nIndice  := 1
LOCAL nApunte  := 0
LOCAL nAux
LOCAL nPos


// Debo encontrar el apunte con NumeroApunte mas alto

do while nLong >= nIndice

   nPos := at (FAC_SEP, aApuntes[nIndice, FAC_AUXNAPUNTE])

   nAux := val(substr(aApuntes[nIndice, FAC_AUXNAPUNTE], nPos+1))

   if nAux > nAPunte

      nApunte := nAux

   endif

   nIndice++

enddo

// en <nApunte> esta el valor mas grande del numero de apunte

nApunte++

aApunte[FAC_AUXNAPUNTE] := FAC_SEP + alltrim(str(nApunte))


RETURN aApunte




/* Ŀ
    INI APUNTES             
                            
    */
FUNCTION iniApuntes()

LOCAL aApunte

aApunte                 := asize({}, FAC_AUXLEN)
aApunte[FAC_AUXCOD]     := 0
aApunte[FAC_AUXTRAT]    := ""
aApunte[FAC_AUXCANT]    := 0
aApunte[FAC_AUXBASE]    := 0
aApunte[FAC_AUXIVA]     := 0
aApunte[FAC_AUXIMP]     := 0
aApunte[FAC_AUXNAPUNTE] := FAC_SEP + "1"
aApunte[FAC_AUXBORRADO] := .f.

RETURN aApunte





/* Ŀ
    ENTRADA APUNTES         
                            
    */
FUNCTION EntradaApuntes (aApunte)

LOCAL cColor    := SetColor (COL_V2)
LOCAL nCursor   := SetCursor (SC_NORMAL)
LOCAL ventana   := xPonVentana (5, 11, 14, 67, COL_V2, SOBRE)
LOCAL nCod      := aApunte[FAC_AUXCOD]
LOCAL nCantidad := aApunte[FAC_AUXCANT]
LOCAL nTabla    := alias()
LOCAL nOrd      := indexOrd()


@ 7, 17 SAY "CODIGO"
@ 8, 15 SAY "CONCEPTO"
@ 9, 15 SAY "CANTIDAD"
@ 10, 17 SAY "PRECIO"
@ 11, 20 SAY "IVA"
@ 12, 16 SAY "IMPORTE"

SET KEY K_F2 TO BuscaApunte

@ 7, 24 GET nCod                                                        ;
  PICTURE maskNum5                                            ;
	VALID ValCodApunte(nCod)                                        ;
	MESSAGE "Cdigo del tratamiento aplicado (F2 para buscar)"      ;
	COLORMSG COL_MSG

@ 9, 24 GET nCantidad                                                   ;
  PICTURE maskNum5                                            ;
	VALID nCantidad > 0                                             ;
	MESSAGE "Cantidad de tratamientos"                              ;
	COLORMSG COL_MSG

READ

SET KEY K_F2 TO

// Almaceno los valores del apunte

SELECT TRATAM
set order to I1TRATAM
DbSeek (nCod)

aApunte[FAC_AUXCOD]  := nCod
aApunte[FAC_AUXTRAT] := tratam->tratam
aApunte[FAC_AUXCANT] := nCantidad
aApunte[FAC_AUXBASE] := tratam->BaseImp
aApunte[FAC_AUXIVA]  := tratam->TipoIva
aApunte[FAC_AUXIMP]  := round(aApunte[FAC_AUXBASE] * aApunte[FAC_AUXCANT], xNumeroDecimales())

@ 12,24 SAY aApunte[FAC_AUXIMP] //PICTURE xMascaraImporte()

SELECT (nTabla)
set order to (nOrd)

SetCursor (nCursor)
SetColor (cColor)
xQuitaVentana (ventana)

RETURN .t.





/* Ŀ
    BUSCA APUNTES           
                            
    */
FUNCTION BuscaApuntes (cProc, nLinea, cVar)

LOCAL nTabla := alias()
LOCAL nOrd   := indexOrd()


IF upper(cVar) = "NCOD"

   ListaTratam()
   SELECT TRATAM
   set order to I1TRATAM

   KEYBOARD chr(K_CTRL_Y) + str(tratam->Codtrat) + chr(K_HOME)

   @ 8, 24 SAY padr(tratam->tratam,  L_TRATAM)
   @ 10,24 SAY padr(tratam->BaseImp, xLongImporte()) //PICTURE xMascaraImporte()
   @ 11,24 SAY padr(tratam->TipoIVA, xLongIVA()) //PICTURE xMascaraIva()

   SELECT (nTabla)
   set order to (nOrd)

ENDIF

RETURN .t.



/* Ŀ
    VALIDA CODTRAT APUNTES  
                            
    */
FUNCTION ValCodApuntes (nCodigo)

LOCAL nTabla := alias()
LOCAL nOrd   := indexOrd()
LOCAL lOk


   SELECT TRATAM
   set order to I1TRATAM
   GO TOP

   lOk := DbSeek(nCodigo)

   @ 8, 24 SAY padr(tratam->tratam,  L_TRATAM)
   @ 10,24 SAY padr(tratam->BaseImp, xLongImporte()) //PICTURE xMascaraImporte()
   @ 11,24 SAY padr(tratam->TipoIVA, xLongIVA()) //PICTURE xMascaraIva()

   SELECT (nTabla)
   set order to (nOrd)

RETURN lOk




/* Ŀ
    VOLCAR APUNTES          
                            
    */
FUNCTION VolcarApuntes (aApunte, nFactura)

LOCAL nTabla := alias()
LOCAL nOrd   := indexOrd()
LOCAL nCont  := 1


SELECT FACTAUX
set order to I2FACTAUX

DO WHILE len (aApunte) >= nCont

   IF DbSeek (str(nFactura, L_NFACTURA, 0) + aApunte[nCont, FAC_AUXNAPUNTE])

      // estamos modificando
      // debo volcar las modificaciones de los datos de la factura

      factAux->nFactura := nFactura
      factAux->CodTrat  := aApunte[nCont, FAC_AUXCOD]
      factAux->BaseImp  := aApunte[nCont, FAC_AUXBASE]
      factAux->TipoIva  := aApunte[nCont, FAC_AUXIVA]
      factAux->Cantidad := aApunte[nCont, FAC_AUXCANT]

   ELSE

      // estamos insertando
      // vuelco los nuevos registros

      DbAppend()
      factAux->nFactura := nFactura
      factAux->CodTrat  := aApunte[nCont, FAC_AUXCOD]
      factAux->BaseImp  := aApunte[nCont, FAC_AUXBASE]
      factAux->TipoIva  := aApunte[nCont, FAC_AUXIVA]
      factAux->Cantidad := aApunte[nCont, FAC_AUXCANT]
      factAux->Apunte   := aApunte[nCont, FAC_AUXNAPUNTE]

   ENDIF

   if aApunte[nCont, FAC_AUXBORRADO]

      factAux->(DbDelete())

   else

      factAux->(DbRecall())

   endif

   nCont++

ENDDO

DbCommit()
SELECT (nTabla)
set order to (nOrd)

RETURN .t.




/* Ŀ
    SALVAR APUNTES          
                            
    */
FUNCTION SalvarApuntes (nFactura)

LOCAL aApuntes := {}
LOCAL nTabla   := alias()
LOCAL nOrd     := indexOrd()
LOCAL nCont
LOCAL lFound


SELECT FACTAUX
set order to I1FACTAUX

// Guardo apuntes de la factura

nCont := 1

// Miro si hay apuntes de la factura en FactAux

lFound := dbSeek(nFactura)

IF lFound

   // existen datos de la factura

   DO WHILE lFound

      aApuntes                         := asize (aApuntes, nCont)
      aApuntes[nCont]                  := asize ({}, FAC_AUXLEN)
      aApuntes[nCont, FAC_AUXCOD]      := factAux->CodTrat
      aApuntes[nCont, FAC_AUXNAPUNTE]  := factAux->Apunte
      aApuntes[nCont, FAC_AUXCANT]     := factAux->Cantidad
      aApuntes[nCont, FAC_AUXBASE]     := factAux->BaseImp
      aApuntes[nCont, FAC_AUXIVA]      := factAux->TipoIva
      aApuntes[nCont, FAC_AUXIMP]      := round(factAux->Cantidad * factAux->BaseImp, xNumeroDecimales())

      if Deleted()

	 aApuntes[nCont, FAC_AUXBORRADO] := .t.

      else

	 aApuntes[nCont, FAC_AUXBORRADO] := .f.

      endif

      SELECT TRATAM
      set order to I1TRATAM

      // Busco en tratam el nombre del tratamiento

      IF dbSeek (aApuntes[nCont, FAC_AUXCOD])
	 aApuntes[nCont, FAC_AUXTRAT] := alltrim(tratam->Tratam)
      ENDIF

      SELECT FACTAUX
      set order to I1FACTAUX

      factAux->(DbSkip(+1))
      lFound := factAux->nFactura = nFactura
      nCont++

   ENDDO

ELSE

   aApuntes := {iniApuntes()}

ENDIF

SELECT (nTabla)
set order to (nOrd)

RETURN aApuntes







/* ͻ
                                                  
      C U O T A S   D E   L A   F A C T U R A     
                                                  
   ͼ */





/* Ŀ
    MUESTRA CUOTA           
                            
    */
FUNCTION MuestraCuotas (aEdicion)

LOCAL i

// Para cada tipo de Iva: Base imponible, IVA, Cuota

i := 1
do while len(aEdicion[FAC_CUO]) >= i
    @ 17+i,6  SAY padr(aEdicion[FAC_CUO, i, FAC_CUOBASE],  xLongImporte()) //PICTURE xMascaraImporte()
    @ 17+i,22 SAY padr(aEdicion[FAC_CUO, i, FAC_CUOIVA],   xLongIVA()) //PICTURE xMascaraIva()
    @ 17+i,28 SAY padr(aEdicion[FAC_CUO, i, FAC_CUOCUOTA], xLongImporte()) //PICTURE xMascaraImporte()
    i++
enddo

// Borro el resto referencias de tipo de Iva antiguas

do while i <= FAC_MAXIVAS

    @ 17+i,6  SAY space(xLongImporte())
    @ 17+i,22 SAY space(xLongIVA())
    @ 17+i,28 SAY space(xLongImporte())
    i++

enddo

RETURN .t.






/* Ŀ
    INI CUOTAS              
                            
    */
FUNCTION IniCuotas ()

LOCAL aCuotas := asize({}, FAC_CUOLEN)

aCuotas[FAC_CUOBASE]    := 0
aCuotas[FAC_CUOIVA]     := 0
aCuotas[FAC_CUOCUOTA]   := 0

RETURN aCuotas





/* Ŀ
    CALCULO DE CUOTAS IVA   
                            
    */
FUNCTION CalCuotas (aEdicion)

LOCAL nCont1, nCont2
LOCAL nTipoIva
LOCAL lFound
LOCAL nLong
LOCAL nTotBase



aEdicion[FAC_CUO] := {}

// Caso trivial en que no exista ningun apunte

if len(aEdicion[FAC_AUX]) = 0

   aEdicion[FAC_CUO] := {iniCuotas()}
   RETURN .t.

endif

// Iteramos para todos los apuntes

nCont1 := 1
do while len (aEdicion[FAC_AUX]) >= nCont1

   // Guardo el tipo de Iva
   nTipoIva := aEdicion[FAC_AUX, nCont1, FAC_AUXIVA]

   // Busco en la matriz de cuotas si ya tengo ese tipo
   nCont2   := 1
   do while len (aEdicion[FAC_CUO]) >= nCont2 .and. ;
	    len (aEdicion[FAC_CUO]) != 0
      lFound := .f.
      if aEdicion[FAC_CUO, nCont2, FAC_CUOIVA] = nTipoIva
	 lFound := .t.
	 EXIT
      else
	 nCont2++
      endif
   enddo

   if (len (aEdicion[FAC_CUO]) = 0, lFound := .f., nil)

   // Si tenia el tipo, sumo el importe del apunte a la base de la cuota
   if lFound

      aEdicion[FAC_CUO, nCont2, FAC_CUOBASE] += ;
			aEdicion[FAC_AUX, nCont1, FAC_AUXIMP]

   // Sino creo el tipo
   else

      nLong                    := len(aEdicion[FAC_CUO]) + 1
      aEdicion[FAC_CUO]        := asize(aEdicion[FAC_CUO], nLong)

      nLong                    := len(aEdicion[FAC_CUO])
      aEdicion[FAC_CUO, nLong] := asize({}, FAC_CUOLEN)

      aEdicion[FAC_CUO, nLong, FAC_CUOBASE] := ;
			aEdicion[FAC_AUX, nCont1, FAC_AUXIMP]
      aEdicion[FAC_CUO, nLong, FAC_CUOIVA] := nTipoIva

   endif

   nCont1++

enddo

// Para cada tipo de Iva, calculo la cuota segun la base imponible

nCont1 := 1
do while len(aEdicion[FAC_CUO]) >= nCont1

   nTotBase := aEdicion[FAC_CUO, nCont1, FAC_CUOBASE]
   nTipoIva := aEdicion[FAC_CUO, nCont1, FAC_CUOIVA]

   aEdicion[FAC_CUO, nCont1, FAC_CUOCUOTA] := round(nTotBase * nTipoIva / 100, xNumeroDecimales())

   nCont1++

enddo

RETURN .t.








/* ͻ
                                                  
      T O T A L E S   D E   L A   F A C T U R A   
                                                  
   ͼ */







/* Ŀ
    MUESTRA TOTALES         
                            
    */
FUNCTION MuestraTotales (aEdicion)
local nConversion
// Total importe, total cuota IVA, total factura
if (xFaseConvivencia())
  @ 15,62 SAY padr(aEdicion[FAC_TOTIMP],   xLongImporte()) + " " + xDivisa()
  @ 16,62 SAY padr(aEdicion[FAC_TOTCUOTA], xLongImporte())
  @ 18,62 SAY padr(aEdicion[FAC_TOTAL],    xLongImporte()) + " " + xDivisa()
  nConversion := xConversion(aEdicion[FAC_TOTAL])
  @ 19,62 SAY padr(nConversion, xLongImporte()) + " " + xDivisa(nConversion)
else
  @ 16,62 SAY padr(aEdicion[FAC_TOTIMP],   xLongImporte()) + " " + xDivisa()
  @ 17,62 SAY padr(aEdicion[FAC_TOTCUOTA], xLongImporte())
  @ 19,62 SAY padr(aEdicion[FAC_TOTAL],    xLongImporte()) + " " + xDivisa()
endif

RETURN .t.




/* Ŀ
    CALCULA TOTALES         
                            
    */
FUNCTION CalTotales (aEdicion)

LOCAL nCont
LOCAL nTotImporte
LOCAL nTotCuota


// Ultimos datos generales de la factura

nCont       := 1
nTotImporte := 0
nTotCuota   := 0
do while len(aEdicion[FAC_CUO]) >= nCont

   nTotImporte += aEdicion[FAC_CUO, nCont, FAC_CUOBASE]
   nTotCuota   += aEdicion[FAC_CUO, nCont, FAC_CUOCUOTA]
   nCont++

enddo

aEdicion[FAC_TOTIMP]   := nTotImporte
aEdicion[FAC_TOTCUOTA] := nTotCuota
aEdicion[FAC_TOTAL]    := nTotImporte + nTotCuota

RETURN .t.




/* ͻ
                                                  
      P A C I E N T E S    F A C T U R A          
                                                  
   ͼ */






/* Ŀ
    BUSQUEDA DE PACIENTES   
                            
    */
PROCEDURE BuscaPaciente (cProc, nLinea, cVar)

LOCAL nTabla  := alias()
LOCAL nOrd    := indexOrd()
LOCAL cColor  := SetColor(COL_V2)
LOCAL nCursor := SetCursor(SC_NONE)
LOCAL ventana


IF upper(cVar) = "NNHC"

   SELECT PACIENTE
   set order to I2PACIENTE

   ListaPaciente()

   KEYBOARD chr(K_CTRL_Y) + str(paciente->Nhc) + chr(K_HOME)

   SetColor (COL_V1)

   // Nombre y apellidos del paciente

   MuestraPaciente (paciente->Apellidos, paciente->Nombre)


ENDIF

SELECT (nTabla)
set order to (nOrd)

SetColor (cColor)
SetCursor (nCursor)

RETURN





/* Ŀ
    MUESTRA PACIENTES       
                            
    */
FUNCTION MuestraPaciente (cApellidos, cNombre)

LOCAL cCadena

   if empty (cApellidos)
      cCadena := space(2)
   else
      cCadena := ", "
   endif

   @ 5, 15 SAY padr(alltrim(cApellidos)             +      ;
		    cCadena                         +      ;
		    alltrim(cNombre),                      ;
		    L_APELLIDOS + 2 + L_NOMBRE)

RETURN .t.





/* Ŀ
    VALIDACION DE PACIENTES 
                            
    */
FUNCTION valNhc(nNhc)

LOCAL nTabla := alias()
LOCAL nOrd   := indexOrd()
LOCAL lOk
LOCAL cCadena

SELECT PACIENTE
set order to I2PACIENTE

lOk := DbSeek(nNhc)

MuestraPaciente (paciente->Apellidos, paciente->Nombre)

SELECT (nTabla)
set order to (nOrd)

RETURN lOk





/* Ŀ
    INI PACIENTE            
                            
    */
FUNCTION IniPaciente ()

LOCAL aPaciente := asize({}, FAC_NHCLEN)

aPaciente[FAC_NHCNHC]        := 0
aPaciente[FAC_NHCAPE]        := ""
aPaciente[FAC_NHCNOM]        := ""

RETURN aPaciente






/* Ŀ
    SALVAR PACIENTE         
                            
    */
FUNCTION SalvarPaciente (nNhc)

LOCAL aPaciente := asize ({}, FAC_NHCLEN)
LOCAL nTabla    := alias()
LOCAL nOrd      := indexOrd()


SELECT PACIENTE
set order to I2PACIENTE

aPaciente[FAC_NHCNHC] := nNhc

// Apellidos y nombre del paciente

if DbSeek (nNhc)
   aPaciente[FAC_NHCAPE] := paciente->Apellidos
   aPaciente[FAC_NHCNOM] := paciente->Nombre
else
   aPaciente[FAC_NHCAPE] := ""
   aPaciente[FAC_NHCNOM] := ""
endif

SELECT (nTabla)
set order to (nOrd)

RETURN aPaciente
