////////////////////////////////////////////////////////////////////////////
//
// Fichero:    INFORMES.PRG
// Fecha:      3-9-98
// Contenido:  Funciones generacion de informes
// Notas:
//
//
////////////////////////////////////////////////////////////////////////////


#INCLUDE "box.ch"
#INCLUDE "inkey.ch"
#INCLUDE "SetCurs.ch"
#INCLUDE "menus.ch"
#INCLUDE "Fileio.ch"
#INCLUDE "def.ch"
#INCLUDE "DbStruct.ch"
#INCLUDE "Miget.ch"



MEMVAR getList
STATIC nHandle
STATIC cLine
STATIC nLong
STATIC nInforme



/* ͻ
                                                  
     I N F O R M E S                              
                                                  
   ͼ */




/* Ŀ
     PACIENTE               
                            
    */
FUNCTION InfPaciente(nNhc)

local nCursor    := SetCursor (SC_NONE)
local nTabla     := alias()
local nOrd       := indexord()
local nTotal     := 0


	SELECT PACIENTE
   SET ORDER TO I2PACIENTE
   GO TOP
   paciente->(DbSeek(nNhc))

   ?? I_TIPO + "+NEGRILLA" + I_TIPO
   Titulo("INFORME DE PACIENTE")
   ?? I_TIPO + "-NEGRILLA" + I_TIPO
   ?
   ?
   ?
   ?
   ?

   IF .not. eof()

      ? I_TIPO + "+GRUESA" + I_TIPO
      ? "Datos personales"
      ? I_TIPO + "-GRUESA" + I_TIPO
      ?


      ? "NHC:        " + alltrim(str(paciente->Nhc))
      ? "Nombre:     " + alltrim(paciente->Nombre) + " " + alltrim(paciente->Apellidos)
      ? "DNI:        " + alltrim(paciente->Dni)
      ? "Nacimiento: " + alltrim(dtoc(paciente->nacimiento))
		? "Direccion:  " +  alltrim(paciente->Direccion)
		? "CP:         " + alltrim(paciente->Cp)
      ? "Localidad:  " + alltrim(paciente->Localidad)
		? "Telefono:   " + alltrim(paciente->Telefono)
      ? "Actividad:  " + alltrim(paciente->actividad)
      ? "Otros:      " + alltrim(paciente->actividadc)
      ? "Diagnostico: "
      ? "   " + substr (paciente->diagnosis, 1, int(L_DIAGNOSIS/3))
      ? "   " + substr (paciente->diagnosis, int(L_DIAGNOSIS/3) + 1, int(L_DIAGNOSIS/3))
      ? "   " + substr (paciente->diagnosis, 2*int(L_DIAGNOSIS/3)+1, int(L_DIAGNOSIS/3))
      ? "Notas:      " + alltrim(paciente->Notas)
      ?
      ?
      ?


      ?? I_TIPO + "+GRUESA" + I_TIPO
      ?? "Visitas"
      ? I_TIPO + "-GRUESA" + I_TIPO
      ?

		SELECT VISITAS
      SET ORDER TO I1VISITAS
		IF DbSeek (nNhc)
         nTotal := 0
			DO WHILE visitas->Nhc=nNhc
				?  dtoc(visitas->Fecha) + ":"
            ?? "  [" + alltrim(str(visitas->Importe)) + " Pts, "
            IF visitas->Factura='N'
               ?? "Sin factura]"
            ELSE
               ?? "Factura]"
            ENDIF
            ? "   " + substr (visitas->tto, 1, int(L_TTO/3))
            ? "   " + substr (visitas->tto, int(L_TTO/3) + 1, int(L_TTO/3))
            ? "   " + substr (visitas->tto, 2*int(L_TTO/3)+1, int(L_TTO/3))
            nTotal := nTotal + visitas->Importe
				skip +1
			ENDDO
         ?
         ? "Total = " + alltrim(str(nTotal)) + " Pts"
		ELSE
			? "No tiene visitas"
		ENDIF

	ENDIF


   SELECT (nTabla)
   set order to (nOrd)
   SetCursor (nCursor)

RETURN .T.








/* Ŀ
     FACTURA                
                            
    */
FUNCTION InfFactura(nFactura, lAviso)

LOCAL nTabla := alias()
LOCAL nOrd   := indexOrd()
LOCAL lError := .f.
LOCAL aEdicion
LOCAL cCadena
LOCAL cAux
LOCAL nCont
LOCAL cNif
LOCAL nConversion

// Valores por defecto
if lAviso = nil
   lAviso := .t.
endif


// Salvar valores de la factura
// 
aEdicion := asize({}, FAC_LEN)

// Valores generales

aEdicion[FAC_NFACTURA] := nFactura
aEdicion[FAC_FECHA]    := facturas->Fecha
aEdicion[FAC_TOTAL]    := facturas->Importe

// Valores del paciente

aEdicion[FAC_NHC]      := salvarPaciente(facturas->Nhc)

// Valores de los apuntes

aEdicion[FAC_AUX]      := salvarApuntes(aEdicion[FAC_NFACTURA])

// Calculo de todos los datos referentes a las cuotas de Iva

CalCuotas (aEdicion)

// Calculo de totales de la factura

CalTotales (aEdicion)


// Comprobaciones minimas de correcion
// 

SELECT FACTURAS
set order to I1FACTURAS

if !DbSeek (nFactura)

   xMensaje ({"", "La factura " + str(nFactura) + " no existe", ""}, ;
             COL_V2, COL_V2R, WARNING)
   lError := .t.
endif

if empty(cNif := xGetConfig("C_NIF"))

   xMensaje ({"", "No se puede hacer una factura sin el N.I.F.",    ;
              "Escriba su N.I.F. en las opciones de consulta", ""}, ;
             COL_V2, COL_V2R, WARNING)
   lError := .t.
endif

SELECT PACIENTE
set order to I2PACIENTE

if !DbSeek (aEdicion[FAC_NHC, FAC_NHCNHC])

   xMensaje ({"", "El paciente a facturar no existe", ""}, ;
             COL_V2, COL_V2R, WARNING)
   lError := .t.
endif

if lError

   // Si hay un error no escribo nada en el fichero

   SELECT (nTabla)
   set order to (nOrd)
   RETURN .f.

endif

// Datos de la consulta
// 

// Lo quito para que los rangos de facturas se impriman bien
//?? I_TIPO + "+NEGRILLA" + I_TIPO
?? upper(xGetConfig("C_NOMCONSULTA"))
//?? I_TIPO + "-NEGRILLA" + I_TIPO
?
?  xGetConfig("C_NOMBRE") + " " + xGetConfig("C_APELLIDOS")
?  xGetConfig("C_DOMICILIO")
?  xGetConfig("C_CP") + " " +xGetConfig("C_MUNICIPIO")
?  xGetConfig("C_TELEFONO")

if xGetConfig("C_SEXO") = "M"
   cCadena := "Podloga"
else
   cCadena := "Podlogo"
endif

if !empty((cAux := xGetConfig("C_NUMCOLEGIADO")))
   cCadena += " - " + alltrim(cAux)
endif

?  cCadena
?  "N.I.F.: " + alltrim(cNif)

// Datos del paciente
// 

cCadena := space (34)

?  cCadena + alltrim(upper(paciente->Nombre)) + " " +  ;
   alltrim(upper(paciente->Apellidos))
?
?  cCadena + alltrim(paciente->Direccion)
?  cCadena + alltrim(paciente->Cp) + " " + alltrim(Paciente->Localidad)

if empty (cAux := paciente->Dni) .and. lAviso

   xMensaje ({"", "Falta el N.I.F. del paciente a facturar:", ;
              alltrim(upper(paciente->Nombre)) +" "+ ;
              alltrim(upper(paciente->Apellidos)),           ;
              "Recuerde que en una factura correcta es",     ;
              "imprescindible que conste claramente", ""},   ;
             COL_V2, COL_V2R, WARNING)
endif

?  cCadena + "N.I.F.: " + cAux
?
?

// Datos generales de la factura
// 

?  "FECHA      N FACTURA   NHC"
?  "------------------------------"
?  padr (dtoc (aEdicion[FAC_FECHA]), 11)          + ;
   padr (alltrim(str(nFactura)), 13) + ;
   padr (alltrim(str(aEdicion[FAC_NHC, FAC_NHCNHC])), 5)
?
?

// Apuntes
// 

SELECT FACTAUX
set order to I1FACTAUX

cCadena := padr("COD", max(4,L_CODTRAT)) + ;
           padr("CONCEPTO", L_TRATAM+1) + ;
           padr("CNT", max(4,L_CANTIDAD)) + ;
           padr("PRECIO", xLongImporte()+1) + ;
           padr("IVA", max(4,xLongIVA()+1)) + ;
           padr("IMPORTE", xLongImporte())
? cCadena
cCadena := replicate("-", len(cCadena))
? cCadena

//?  "COD  CONCEPTO                                  CNT  PRECIO   IVA  IMPORTE  "
//?  ""

for nCont := 1 to len(aEdicion[FAC_AUX])
  if (aEdicion[FAC_AUX, nCont, FAC_AUXCOD] <> 0)
   ? padr (aEdicion[FAC_AUX, nCont, FAC_AUXCOD], max(4,L_CODTRAT)) +       ;
     padr (aEdicion[FAC_AUX, nCont, FAC_AUXTRAT], L_TRATAM+1) +     ;
     padr (aEdicion[FAC_AUX, nCont, FAC_AUXCANT], max(4,L_CANTIDAD)) +     ;
     padr (aEdicion[FAC_AUX, nCont, FAC_AUXBASE], xLongImporte()+1) + ;
     padr (aEdicion[FAC_AUX, nCont, FAC_AUXIVA], max(4,xLongIVA()+1)) +     ;
     padr (aEdicion[FAC_AUX, nCont, FAC_AUXIMP], xLongImporte())
  endif
next

// Cuotas de IVA
// 

?
?
?
cCadena := padr("BASE IMP.", max(12,xLongImporte()+1)) + ;
           padr("IVA", max(4,xLongIVA()+1)) + ;
           padr("CUOTA IVA", max(12,xLongImporte()))
? cCadena
cCadena := replicate("-", len(cCadena))
? cCadena

//?  "BASE IMP.  IVA  CUOTA IVA"
//?  ""

for nCont := 1 to len(aEdicion[FAC_CUO])
   ? padr (aEdicion[FAC_CUO, nCont, FAC_CUOBASE], max(12,xLongImporte()+1))    + ;
     padr (aEdicion[FAC_CUO, nCont, FAC_CUOIVA], max(4,xLongIVA()+1))     + ;
     padr (aEdicion[FAC_CUO, nCont, FAC_CUOCUOTA], max(12,xLongImporte()))
next


// Totales de la factura
// 

?
?
?
?  "TOTAL IMPORTE   " + padl (aEdicion[FAC_TOTIMP], xLongImporte()) + " " + xDivisa()
?  "TOTAL CUOTA IVA " + padl (aEdicion[FAC_TOTCUOTA], xLongImporte())
cCadena := "                " + replicate("=", xLongImporte())
? cCadena
?  "TOTAL FACTURA   " + padl (aEdicion[FAC_TOTAL], xLongImporte()) + " " + xDivisa()
if (xFaseConvivencia())
  nConversion := xConversion(aEdicion[FAC_TOTAL])
  ?  "                " + padl (nConversion, xLongImporte()) + " " + xDivisa(nConversion)
endif
? cCadena
?

SELECT (nTabla)
set order to (nOrd)

RETURN .t.








/* Ŀ
     BALANCE GASTOS/INGRESOS HACIENDA  
                                       
    */
FUNCTION Balance()

LOCAL nTabla    := alias()
LOCAL nOrd      := indexOrd()
LOCAL dFechaIni := ctod("  -  -  ")
LOCAL dFechaFin := ctod("  -  -  ")
LOCAl lFinGastos   := .f.
LOCAL lFinIngresos := .f.
LOCAL lUltimaLinea := .f.
LOCAL nIngresos    := 0
LOCAL nGastos      := 0
LOCAL nTotGastos   := 0
LOCAL nTotIngresos := 0
LOCAL dFecha       := ctod("  -  -  ")
LOCAL dGastos      := ctod("  -  -  ")
LOCAL dIngresos    := ctod("  -  -  ")
LOCAL ventana
LOCAL nConversion
LOCAL cCadena


if !Intervalo(@dFechaIni, @dFechaFin, " B A L A N C E ")
   SELECT (nTabla)
   set order to (nOrd)
   RETURN .f.
endif


?? I_TIPO + "+NEGRILLA" + I_TIPO
Titulo("BALANCE DEL " + dtoc(dFechaIni)+ " AL " + dtoc(dFechaFin))
?? I_TIPO + "-NEGRILLA" + I_TIPO
?
?
cCadena := padr("FECHA", 10) + ;
           padl("INGRESOS", 14) + ;
           padl("GASTOS", 14) + ;
           padl("PARCIAL", 14)
? cCadena
cCadena := replicate("-", len(cCadena))
? cCadena
//?  "FECHA      INGRESOS      GASTOS       PARCIAL"
//?  ""



// Dejo los punteros en el primer registro con fecha
// mayor o igual que <dFecha>, mediante busqueda aproximada

dFecha := dFechaIni
SELECT FACTURAS
Set order to I2FACTURAS
Facturas->(DbSeek(dFecha, .t.))
lFinIngresos := Facturas->(eof())
dIngresos    := Facturas->Fecha

SELECT GASTOS
Set order to I3GASTOS
Gastos->(DbSeek(dFecha, .t.))
lFinGastos := gastos->(eof())
dGastos    := Gastos->Fecha

dFecha := min(dIngresos, dGastos)

DO WHILE !lFinGastos .or. !lFinIngresos

   // INGRESOS

   IF !lFinIngresos

      nIngresos := 0

      // Utilizo las facturas ordenadas por Fecha
      SELECT FACTURAS
      Set order to I2FACTURAS

      if DbSeek(dFecha, .t.)
         do while Facturas->Fecha = dFecha
            nIngresos := nIngresos + Facturas->Importe
            DbSkip(+1)
         enddo
      endif

      dIngresos    := facturas->Fecha
      if (dIngresos > dFechaFin) .or. Facturas->(eof())
         lFinIngresos := .t.
         if (lFinGastos, lUltimaLinea := .t., nil)
      endif

   ELSE

      nIngresos := 0

   ENDIF



   // GASTOS

   IF !lFinGastos

      // Utilizo los gastos ordenados por Fecha
      SELECT GASTOS
      Set order to I3GASTOS

      nGastos := 0

      if DbSeek(dFecha, .t.)
         do while Gastos->Fecha = dFecha
            nGastos := nGastos + Gastos->Importe
            DbSkip(+1)
         enddo
      endif

      dGastos    := gastos->Fecha
      if (dGastos > dFechaFin) .or. gastos->(eof())
         lFinGastos := .t.
         if (lFinIngresos, lUltimaLinea := .t., nil)
      endif

   ELSE

      nGastos := 0

   ENDIF

   nTotGastos   := nTotGastos + nGastos
   nTotIngresos := nTotIngresos + nIngresos


   // Escritura de la linea para <dFecha>
   if !lFinIngresos .or. !lFinGastos .or. lUltimaLinea
      ? padr(dFecha, 10) +       ;
        padl(nIngresos, 14) +     ;
        padl(nGastos, 14) +      ;
        padl(nIngresos-nGastos, 14)
   endif

   // Clculo de la siguiente fecha
   do case
      case !lFinGastos .and. !lFinIngresos
           dFecha := min(dGastos, dIngresos)
      case lFinGastos .and. !lFinIngresos
           dFecha := dIngresos
      case !lFinGastos .and. lFinIngresos
           dFecha := dGastos
   endcase

ENDDO

?
?  padr("TOTALES", 10)  +  ;
   padl(nTotIngresos, 14) +             ;
   padl(nTotGastos, 14)
?
cCadena := "           " + replicate("=", xLongImporte())
?  cCadena
?  "BALANCE    " + padl(nTotIngresos-nTotGastos,xLongImporte()) + " " + xDivisa()
if (xFaseConvicencia())
  nConversion := xConversion(nTotIngresos-nTotGastos)
  ?  "           " + padl(nConversion,xLongImporte()) + " " + xDivisa(nConversion)
endif
?  cCadena
?

SELECT (nTabla)
set order to (nOrd)

RETURN .T.







/* Ŀ
     BALANCE GASTOS/INGRESOS REAL  
                                   
    */
FUNCTION BalanceReal()

LOCAL nTabla    := alias()
LOCAL nOrd      := indexOrd()
LOCAL dFechaIni := ctod("  -  -  ")
LOCAL dFechaFin := ctod("  -  -  ")
LOCAL nIngresos        := 0
LOCAL nGastos          := 0
LOCAL nIngFicticios    := 0
LOCAL nTotGastos       := 0
LOCAL nTotIngresos     := 0
LOCAL nTotIngFicticios := 0
LOCAL dFecha       := ctod("  -  -  ")
LOCAL dGastos      := ctod("  -  -  ")
LOCAL dIngresos    := ctod("  -  -  ")
LOCAl lFinGastos   := .f.
LOCAL lFinIngresos := .f.
LOCAl lUltimaLinea := .f.
LOCAL ventana
LOCAL nNhc
LOCAL cCadena
LOCAL nConversion
LOCAL lFechaEuro



if !Intervalo(@dFechaIni, @dFechaFin, " B A L A N C E ")
   SELECT (nTabla)
   set order to (nOrd)
   RETURN .f.
endif

?? I_TIPO + "+NEGRILLA" + I_TIPO
Titulo("BALANCE REAL DEL " + dtoc(dFechaIni)+ " AL " + dtoc(dFechaFin))
?? I_TIPO + "-NEGRILLA" + I_TIPO
?
?
cCadena := padr("FECHA", 10) + ;
           padl("INGRESOS", 14) + ;
           padl("GASTOS", 14) + ;
           padl("PARCIAL", 14) + ;
           padl("FACTURAS", 14)
? cCadena
cCadena := replicate("-", len(cCadena))
? cCadena

//?  "FECHA      INGRESOS      GASTOS       PARCIAL       FACTURAS"
//?  ""

// Dejo los punteros en el primer registro con fecha
// mayor o igual que <dFecha>, mediante busqueda aproximada

dFecha := dFechaIni
SELECT VISITAS
Set order to I2VISITAS
Visitas->(DbSeek(dFecha, .t.))
lFinIngresos := Visitas->(eof())
dIngresos    := Visitas->Fecha

SELECT GASTOS
Set order to I3GASTOS
Gastos->(DbSeek(dFecha, .t.))
lFinGastos := gastos->(eof())
dGastos    := Gastos->Fecha

dFecha := min(dIngresos, dGastos)


DO WHILE !lFinGastos .or. !lFinIngresos


   // INGRESOS

   IF !lFinIngresos

      // Utilizo las Visitas ordenadas por Fecha
      SELECT VISITAS
      Set order to I2VISITAS

      // Los ingresos de las visitas estan en PTS hasta el 2000 (inclusive)
      // A partir del 2001 estan en EUR
      lFechaEuro := year(dFecha) >= 2001

      nIngresos     := 0
      nIngFicticios := 0

      if DbSeek(dFecha, .t.)
         do while Visitas->Fecha = dFecha
            nIngresos := nIngresos + xConversion(Visitas->Importe, lFechaEuro)

            // Ingresos Ficticios de las facturas

            if Visitas->Factura = "S"
               nNhc := Visitas->Nhc
               SELECT FACTURAS
               set order to I2FACTURAS
               GO TOP
               if DbSeek(dFecha)
                  do while (Facturas->Nhc != nNhc) .and. !eof()
                     DbSkip(+1)
                  enddo
                  if Facturas->Nhc = nNhc
                     nIngFicticios := nIngFicticios + xConversion(Facturas->Importe, lFechaEuro)
                  endif
               endif
               SELECT VISITAS
               Set order to I2VISITAS
            endif

            DbSkip(+1)
         enddo
      endif

      dIngresos    := Visitas->Fecha
      if (dIngresos > dFechaFin) .or. Visitas->(eof())
         lFinIngresos := .t.
         if (lFinGastos, lUltimaLinea := .t., nil)
      endif

   ELSE

      nIngresos     := 0
      nIngFicticios := 0

   ENDIF



   // GASTOS

   IF !lFinGastos

      // Utilizo los gastos ordenados por Fecha
      SELECT GASTOS
      Set order to I3GASTOS

      nGastos := 0

      if DbSeek(dFecha, .t.)
         do while Gastos->Fecha = dFecha
            nGastos := nGastos + Gastos->Importe
            DbSkip(+1)
         enddo
      endif

      dGastos    := gastos->Fecha
      if (dGastos > dFechaFin) .or. gastos->(eof())
         lFinGastos := .t.
         if (lFinIngresos, lUltimaLinea := .t., nil)
      endif

   ELSE

      nGastos := 0

   ENDIF

   nTotGastos       := nTotGastos + nGastos
   nTotIngresos     := nTotIngresos + nIngresos
   nTotIngFicticios := nTotIngFicticios + nIngFicticios


   // Escritura de la linea para <dFecha>

   if !lFinIngresos .or. !lFinGastos .or. lUltimaLinea

      ? padr(dFecha, 10) +                      ;
        padl(nIngresos, 14) +           ;
        padl(nGastos, 14) +             ;
        padl(nIngresos-nGastos, 14) +   ;
        padl(nIngFicticios, 14)


   endif

   // Clculo de la siguiente fecha

   do case
      case !lFinGastos .and. !lFinIngresos
           dFecha := min(dGastos, dIngresos)
      case lFinGastos .and. !lFinIngresos
           dFecha := dIngresos
      case !lFinGastos .and. lFinIngresos
           dFecha := dGastos
   endcase

ENDDO

?
?  "TOTALES    " +                                       ;
   padl(nTotIngresos, 14) +                ;
   padl(nTotGastos, 13) +                  ;
   padl(nTotIngresos-nTotGastos, 14) +     ;
   padl(nTotIngFicticios, 14)

?
cCadena := "           " + replicate("=", xLongImporte())
?  cCadena
?  "BALANCE    " + padl(nTotIngresos-nTotGastos,xLongImporte()) + " " + xDivisa()
if (xFaseConvicencia())
  nConversion := xConversion(nTotIngresos-nTotGastos)
  ?  "           " + padl(nConversion,xLongImporte()) + " " + xDivisa(nConversion)
endif
?  cCadena
?

SELECT (nTabla)
set order to (nOrd)

RETURN .T.







/* Ŀ
     INFORME DE GASTOS      
                            
    */
FUNCTION InfGastos()

LOCAL aConceptos     := GetConcepto()
LOCAL nLongConceptos := xaMaxLen(aConceptos)
LOCAL nLong
LOCAL nTabla    := alias()
LOCAL nOrd      := indexOrd()
LOCAL dFechaIni := ctod("  -  -  ")
LOCAL dFechaFin := ctod("  -  -  ")
LOCAL nEmpresa
LOCAL cAux
LOCAL nCuota
LOCAL nTotBase    := 0
LOCAL nTotCuota   := 0
LOCAL nTotImporte := 0
LOCAL nConversion
LOCAL cCadena

if !Intervalo (@dFechaIni, @dFechaFin, " G A S T O S ")
   SELECT (nTabla)
   set order to (nOrd)
   RETURN .f.
endif

SELECT GASTOS
set order to I3GASTOS
GO TOP

// Informe en tipo COMPRIMIDO

// ?? I_TIPO + "+COMPRIMIDA" + I_TIPO

Titulo("INFORME DE GASTOS DEL " + dtoc(dFechaIni) + " AL " + dtoc(dFechaFin))

?
?

?? I_TIPO + "+COMPRIMIDA" + I_TIPO

cAux := padr("NORD",      L_NORDEN+1) +                       ;
        padr("FECHA",     L_FECHA+1) +                        ;
        padr("FACTURA",   L_NUMFACTURA+1) +                   ;
        padr("CONCEPTO",  28) +                               ;
        padl("BASE IMP",  xLongImporte()+1) +                      ;
        padl("IVA",       max(4,xLongIVA()+1)) +                      ;
        padl("CUOTA",     xLongImporte()+1) +                      ;
        padl("IMPORTE",   xLongImporte()+1) +                      ;
        " " + ;
        padr("NIF",       L_NIF+1) +                          ;
        padr("PROVEEDOR", 45)

?  cAux
?  Replicate("-", len(cAux))

Gastos->(DbSeek(dFechaIni, .t.))

DO WHILE !Eof() .and. Gastos->Fecha <= dFechaFin

   nCuota := int(Gastos->BaseImp * Gastos->TipoIva / 100)
   ?   padr(Gastos->Norden,                    L_NORDEN+1)        + ;
       padr(dtoc(Gastos->Fecha),               L_FECHA+1)         + ;
       padr(Gastos->nFactura,                  L_NUMFACTURA+1)    + ;
       padr(aConceptos[Gastos->Concepto],      27) + " "          + ;
       padl(Gastos->BaseImp,                   xLongImporte()+1)       + ;
       padl(Gastos->TipoIva,                   max(4,xLongIVA()+1))       + ;
       padl(nCuota,                            xLongImporte()+1)       + ;
       padl(Gastos->Importe,                   xLongImporte()+1) + ;
       " "

   nTotBase := nTotBase + Gastos->BaseImp
   nTotCuota := nTotCuota + nCuota
   nTotImporte := nTotImporte + gastos->Importe

   nEmpresa := Gastos->nEmpresa
   SELECT EMPRESAS
   set order to I1EMPRESAS
   if DbSeek(nEmpresa)
       ??  padr(Empresas->Nif, L_NIF+1) + ;
           padr(Empresas->RSocial, 45)
   endif

   SELECT GASTOS
   set order to I3GASTOS

   DbSkip(+1)

ENDDO

// Quito tipo COMPRIMIDO

// ?? I_TIPO + "-COMPRIMIDA" + I_TIPO


?
?  "SUMAS TOTALES"
cCadena := "           " + replicate("=", xLongImporte())
? cCadena
?  "BASE IMP   " + padl(nTotBase, xLongImporte()) + " " + xDivisa()
if (xFaseConvivencia())
  nConversion := xConversion(nTotBase)
  ?  "           " + padl(nConversion, xLongImporte()) + " " + xDivisa(nConversion)
endif
?  "CUOTA IVA  " + padl(nTotCuota, xLongImporte())
?  "IMPORTE    " + padl(nTotImporte, xLongImporte()) + " " + xDivisa()
if (xFaseConvivencia())
  nConversion := xConversion(nTotImporte)
  ?  "           " + padl(nConversion, xLongImporte()) + " " + xDivisa(nConversion)
endif
? cCadena
?

SELECT (nTabla)
set order to (nOrd)

RETURN .T.








/* Ŀ
     INFORME DE INGRESOS    
                            
    */
FUNCTION InfIngresos()

LOCAL nTabla    := alias()
LOCAL nOrd      := indexOrd()
LOCAL dFechaIni := ctod("  -  -  ")
LOCAL dFechaFin := ctod("  -  -  ")
LOCAL aEdicion
LOCAL nTipoIva
LOCAL cAux
LOCAL i
LOCAL nTotBase    := 0
LOCAL nTotCuota   := 0
LOCAL nTotImporte := 0
LOCAL nConversion
LOCAL cCadena

if !Intervalo (@dFechaIni, @dFechaFin, " I N G R E S O S ")
   SELECT (nTabla)
   set order to (nOrd)
   RETURN .f.
endif

SELECT FACTURAS
set order to I2FACTURAS
GO TOP

// Informe en tipo COMPRIMIDO

// ?? I_TIPO + "+COMPRIMIDA" + I_TIPO

Titulo("INFORME DE INGRESOS DEL " + dtoc(dFechaIni) + " AL " + dtoc(dFechaFin))

?
?

?? I_TIPO + "+COMPRIMIDA" + I_TIPO

cAux := padr("NFAC",       L_NFACTURA+1)                       + ;
        padr("FECHA",      L_FECHA+1)                          + ;
        padr("TRATAMIENTO",30)                                 + ;
        padl("BASE IMP",   xLongImporte()+1)                        + ;
        padl("IVA",        max(4,xLongIVA()+1))                        + ;
        padl("CUOTA",      xLongImporte()+1)                        + ;
        padl("IMPORTE",    xLongImporte()+1)                        + ;
        " " + ;
        padr("NIF",        L_DNI+1)                            + ;
        padr("PACIENTE",   L_APELLIDOS+L_NOMBRE+1)

?  cAux
?  Replicate("-", len(cAux))

Facturas->(DbSeek(dFechaIni, .t.))

DO WHILE !Eof() .and. Facturas->Fecha <= dFechaFin

   // Salvar valores de la factura
   // 

   aEdicion := asize({}, FAC_LEN)

   // Valores generales

   aEdicion[FAC_NFACTURA] := facturas->nFactura
   aEdicion[FAC_FECHA]    := facturas->Fecha
   aEdicion[FAC_TOTAL]    := facturas->Importe

   // Valores del paciente

   aEdicion[FAC_NHC]      := salvarPaciente(facturas->Nhc)

   // Valores de los apuntes

   aEdicion[FAC_AUX]      := salvarApuntes(aEdicion[FAC_NFACTURA])

   // Calculo de todos los datos referentes a las cuotas de Iva

   CalCuotas (aEdicion)

   // Calculo de totales de la factura

   CalTotales (aEdicion)

   // Tipo de Iva aplicado

   nTipoIva := 0

   FOR i := 1 to len(aEdicion[FAC_CUO])
       nTipoIva := Max(aEdicion[FAC_CUO, i, FAC_CUOIVA], nTipoIva)
   NEXT

   // Totales

   nTotBase := nTotBase + aEdicion[FAC_TOTIMP]
   nTotCuota := nTotCuota + aEdicion[FAC_TOTCUOTA]
   nTotImporte := nTotImporte + aEdicion[FAC_TOTAL]



   ?   padr(aEdicion[FAC_NFACTURA],            L_NFACTURA+1)        + ;
       padr(dtoc(aEdicion[FAC_FECHA]),         L_FECHA+1)           + ;
       padr(aEdicion[FAC_AUX,1,FAC_AUXTRAT],   30)          + ;
       padl(aEdicion[FAC_TOTIMP],              xLongImporte()+1)         + ;
       padl(nTipoIva,                          max(4,xLongIVA()+1))         + ;
       padl(aEdicion[FAC_TOTCUOTA],            xLongImporte()+1)         + ;
       padl(aEdicion[FAC_TOTAL],               xLongImporte()+1) + ;
       " "

   SELECT PACIENTE
   set order to I2PACIENTE

   if DbSeek (aEdicion[FAC_NHC, FAC_NHCNHC])
       cAux := alltrim(aEdicion[FAC_NHC, FAC_NHCNOM]) + " "         + ;
               alltrim(aEdicion[FAC_NHC, FAC_NHCAPE])
       ?? padr(Paciente->Dni,                  L_DNI+1)             + ;
          padr(cAux,                           L_APELLIDOS+L_NOMBRE+1)
   endif

   SELECT FACTURAS
   set order to I2FACTURAS

   DbSkip(+1)

ENDDO

// Quito tipo COMPRIMIDO

// ?? I_TIPO + "-COMPRIMIDA" + I_TIPO

?
?  "SUMAS TOTALES"
cCadena := "           " + replicate("=", xLongImporte())
? cCadena
?  "BASE IMP   " + padl(nTotBase, xLongImporte()) + " " + xDivisa()
if (xFaseConvivencia())
  nConversion := xConversion(nTotBase)
  ?  "           " + padl(nConversion, xLongImporte()) + " " + xDivisa(nConversion)
endif
?  "CUOTA IVA  " + padl(nTotCuota, xLongImporte())
?  "IMPORTE    " + padl(nTotImporte, xLongImporte()) + " " + xDivisa()
if (xFaseConvivencia())
  nConversion := xConversion(nTotImporte)
  ?  "           " + padl(nConversion, xLongImporte()) + " " + xDivisa(nConversion)
endif
? cCadena
?

SELECT (nTabla)
set order to (nOrd)

RETURN .T.




/* Ŀ
      TARIFA DE PRECIOS     
                            
    */
FUNCTION InfTarifas()

LOCAL nTabla    := alias()
LOCAL nOrd      := indexOrd()
LOCAL cAux
LOCAL nAux

SELECT TRATAM
set order to I1TRATAM
GO TOP

Titulo("TARIFA PRECIOS " + xGetConfig("CN_EJERCICIO"))
?
?
cAux := padr("TRATAMIENTO", L_TRATAM+1)     + ;
        padl("BASE",        xLongImporte()+1)    + ;
        padl("IVA",         max(4,xLongIVA()+1))    + ;
        padl("IMPORTE", xLongImporte())
?  cAux
?  Replicate("-", len(cAux))

DO WHILE !Eof()
  nAux := round(tratam->baseimp * (1 + tratam->tipoiva/100), xNumeroDecimales())
  ? padr(tratam->tratam, L_TRATAM+1)      + ;
    padl(tratam->baseimp, xLongImporte()+1)    + ;
    padl(tratam->tipoiva, max(4,xLongIVA()+1))    + ;
    padl(nAux, xLongImporte())
  DbSkip(+1)
END DO

SELECT (nTabla)
set order to (nOrd)

RETURN .T.






/* ͻ
                                                  
     G E S T I O N   D E   I N F O R M E S        
                                                  
   ͼ */


/* Ŀ
     INICIALIZA INFORME     
                            
    */
/* Nota:

     IniInforme (cFichero, bInforme, [lVisualiza], [lAppend]) --> .t.

       <cFichero>: nombre del fichero a crear con extension ".rpt"
       <bInforme>: bloque para ejecutar el informe en si
     <lVisualiza>: indica si queremos ver en pantalla el informe
                   antes de imprirlo. Por defecto es .t.
        <lAppend>: indica si el informe generado se aade al fichero
                   en vez de truncarlo. Por defecto es .f.

*/
FUNCTION IniInforme (cFichero, bInforme, lVisualiza, lAppend)

LOCAL ventana
LOCAL cColor    := SetColor (COL_V2)
LOCAL nCursor   := SetCursor (SC_NONE)
LOCAL cPantalla := Savescreen()
LOCAL nError, cError
LOCAL lOk
LOCAL lImprime
LOCAL Operacion
LOCAL cFichExport
LOCAL cPrnFich
LOCAL cDir

LOCAL nTick
LOCAL aTicks := {0,0,0,0,0}


// Inicializacion de parametros
// 

if lVisualiza = nil
  lVisualiza := .t.
endif

if lAppend = nil
   lAppend := .f.
endif

if .not. lAppend
   filedelete (cFichero)
   filedelete (substr (cFichero, 1,at(".",cFichero)-1) + ".prn")
endif


SETTIC(.T.)


// Generacion del informe en <cFichero>
// 

cDir := DirName()
DirChange(xGetConfig("D_INFORMES"))

if .not. lAppend
   SET ALTERNATE TO (cFichero)
else
   SET ALTERNATE TO (cFichero) ADDITIVE
endif
SET CONSOLE OFF
SET ALTERNATE ON

lOk := eval (bInforme)

SET ALTERNATE OFF
CLOSE ALTERNATE
SET CONSOLE ON

if !lOk .or. !lVisualiza

   SetCursor (nCursor)
   SetColor (cColor)
   DirChange(cDir)
   RETURN .t.

endif

SETTIC(.F.)

aTicks[1] := GETTIC()

SETTIC(.T.)


// Exportacion del fichero
// 

cFichExport := ExportaFichero(cFichero)

if type(cFichExport) = "N"
   xMensaje ({"", "Error formateando informe", cError, ""},  ;
             COL_V2, COL_V2R, WARNING)
   cFichExport := cFichero
endif


SETTIC(.F.)

aTicks[2] := GETTIC()

SETTIC(.T.)



// Paginacion del fichero
// 

nError := paginar (cFichero)

if nError != I_OK

   do case

      case nError = I_FILE
        cError := "No es posible el acceso a ficheros"

   endcase

   xMensaje ({"", "Error paginando informe", cError, ""},  ;
             COL_V2, COL_V2R, WARNING)
   // vacio el buffer de teclazos
   do while Inkey() != 0
   enddo
   cPrnFich := cFichero

else

   cPrnFich := substr (cFichero, 1,at(".",cFichero)-1) + ".prn"

endif

SETTIC(.F.)

aTicks[3] := GETTIC()

/*

xMensaje({"", "Creacion: " + alltrim(str(aTicks[1])), ;
          "Exportacion: " + alltrim(str(aTicks[2])),  ;
          "Paginacion: " + alltrim(str(aTicks[3])), ""}, COL_V2, COL_V2R)
*/


// Visualizacin informe
// 

if lVisualiza

   // veo el fichero paginado para que quede bonito
   Operacion := view (cFichExport)

   do case

      case Operacion == IMPRIMIR   // Impresin de fichero

           lImprime := .t.

      case Operacion == SALIR      // ESC

           lImprime := .f.

      case Operacion == EXPORTAR   // Exportacin

           lImprime := .f.
           xMensaje ({"", "Informe exportado a " + upper(cFichExport), ;
                      "Guardado en el directorio INFORMES", ""},       ;
                    COL_V2, COL_V2R)

   endcase

else

   lImprime := !lAppend

endif


// Impresion del informe
// 

if lImprime

   nError := Imprimir (cPrnFich)

   do case

   case nError = I_NOINSTALADA

     cError := "Controlador de impresora no instalado"

   case nError = I_FILE

     cError := "No es posible el acceso a ficheros"

   case nError = I_MALCONFIG

     cError := "Impresora mal configurada"

   endcase

   if nError != I_OK

      xMensaje ({"", "Error imprimiendo informe", cError, ""},  ;
                COL_V2, COL_V2R, WARNING)

   endif

endif

DirChange(cDir)
SetCursor (nCursor)
SetColor (cColor)
RestScreen(,,,,cPantalla)

RETURN .t.






/* Ŀ
     PAGINADOR              
                            
    */
FUNCTION Paginar (cNomFuente, cNomDestino)

/* Sintaxis:

     Paginar (cNomFuente, [cNomDestino]) --> nError

   Descripcion:

      <cNomFuente>: Nombre del fichero fuente con extension

     [cNomDestino]: Tendra el mismo nombre que <cNomfuente>
                    pero con la extension 'prn'
*/

local nFuente, nDestino
local cBuffer, cAux
local nLineas, nAncho, nMargenSup, nMargenInf, nMargenDer, nMargenIzq
local nPagina
local nLongLinea, nTotalLineas, nMaxLineas
local lFinPagina, lFinBuffer
local i, nPos, cCad


// Inicializacion medidas de trabajo
// 

nLineas    := val(xGetConfig("I_LARGOPAGINA"))
nAncho     := val(xGetConfig("I_ANCHOPAGINA"))
nMargenSup := val(xGetConfig("I_MARGENSUP"))
nMargenInf := val(xGetConfig("I_MARGENINF"))
nMargenDer := val(xGetConfig("I_MARGENDER"))
nMargenIzq := val(xGetConfig("I_MARGENIZQ"))

if (empty(nLineas), nLineas := 66, nil)
if (empty(nAncho),  nAncho := 80, nil)
if (empty(nMargenSup), nMargenSup := 1, nil)
if (empty(nMargenInf), nMargenInf := 1, nil)
if (empty(nMargenIzq), nMargenIzq := 4, nil)
if (empty(nMargenDer), nMargenDer := 2, nil)

if ( nMargenSup + nMargenInf > nLineas .or. nMargenIzq + nMargenDer > nAncho)
   nLineas := 66
   nAncho := 80
   nMargenSup := 1
   nMargenInf := 1
   nMargenIzq := 4
   nMargenDer := 2
endif


// Apertura de ficheros
// 

if cNomDestino = nil
   cNomDestino := substr (cNomFuente, 1,at(".",cNomFuente)-1) + ".prn"
endif

nFuente := fopen (cNomFuente, FO_READ)
nDestino := fcreate (cNomDestino)

if nFuente = -1 .or. nDestino = -1
   RETURN (I_FILE)
endif

nLongLinea   := nAncho - (nMargenIzq + nMargenDer)
cBuffer      := space(L_BUFFER)
cAux         := ""
nTotalLineas := 0
nMaxLineas   := nLineas - (nMargenSup + nMargenInf)
lFinPagina   := .f.
lFinBuffer   := .f.
nPagina      := 0

fread(nFuente, @cBuffer, L_BUFFER)


// solo tengo en cuenta el caso de un informe en COMPRIMIDO
// 

nPos := at (I_TIPO, cBuffer)

if nPos != 0 .and. nPos <10

   cCad := substr(cBuffer, nPos + len(I_TIPO), ;
           at(I_TIPO, substr(cBuffer, nPos + len(I_TIPO))) - 1)

   if cCad = "+COMPRIMIDA"

      nLongLinea := int ( nLongLinea * 1.8 )

   endif

endif


do while !lFinBuffer .and. !empty(cBuffer)

   do while !lFinPagina .and. !lFinBuffer

      if nTotalLineas = 0
         for i := 1 to nMargenSup
             fwrite (nDestino, CRLF)
         next
      endif

      TrataLinea (@cBuffer, nLongLinea, @nPos)

      fwrite (nDestino, space(nMargenIzq) + substr (cBuffer, 1, nPos) + CRLF)

      cBuffer := substr (cBuffer, nPos + 1)

      nTotalLineas++

      if nTotalLineas = nMaxLineas
         lFinPagina := .t.
         nPagina++
      endif

      if (len(cBuffer) <= int(2 * nLongLinea)) .or. empty(cBuffer)
         lFinBuffer := .t.
      endif

   enddo // while !lFinPagina .and. !lFinBuffer

   if lFinPagina .and. !lFinBuffer
      // margen inferior
      for i := 1 to nMargenInf
         fwrite (nDestino, CRLF)
      next
      // escribo final de pagina
      fwrite (nDestino, FF + alltrim(str(nPagina)) + CRLF)
      lFinPagina := .f.
      nTotalLineas := 0
   endif

   if lFinBuffer
      cAux := cBuffer
      cBuffer := space(L_BUFFER)
      fread(nFuente, @cBuffer, L_BUFFER)
       cBuffer := cAux + cBuffer
      // para no escribir paginas vacias
      if empty(cBuffer)
         lFinBuffer := .t.
      else
         lFinBuffer := .f.
      endif
   endif

enddo  // while !lFinBuffer


// se ha acabado el fichero
// Formateo la ultima pagina completa con CRLF
// 

for i := nTotalLineas to nMaxLineas + nMargenInf - 2
    fwrite (nDestino, CRLF)
next
nPagina++


// escribo final de informe
// 

fwrite (nDestino, I_FIN + CRLF)


// escribo final de pagina
// 

fwrite (nDestino, FF + alltrim(str(nPagina)) + CRLF)

// escribo estructura de control
fwrite (nDestino, I_CTRL + CRLF)
fwrite (nDestino, str(nLineas) + CRLF)
fwrite (nDestino, str(nAncho) + CRLF)
fwrite (nDestino, str(nMargenSup) + CRLF)
fwrite (nDestino, str(nMargenInf) + CRLF)
fwrite (nDestino, str(nMargenIzq) + CRLF)
fwrite (nDestino, str(nMargenDer) + CRLF)
fwrite (nDestino, alltrim(str(nPagina)) + CRLF)
fwrite (nDestino, I_CTRL)

if fclose (nFuente) = .f. .or. fclose(nDestino) = .f.
   RETURN I_FILE
endif


RETURN I_OK





/* Ŀ
     TRATAR LINEA           
                            
    */
PROCEDURE trataLinea (cBuffer, nLongLinea, nPos)

/* Sintaxis:

     trataLinea (@cBuffer, @nLongLinea, @nPos)

   Notas:

   - Devuelvo la posicin donde se debe acabar la linea
   - Devuelvo <cBuffer> sin los CRLF (se colocan en paginar())
*/

nPos := at (CRLF, cBuffer)

if nPos = 0 .or. nPos > nLongLinea

   nPos := nLongLinea

else

   cBuffer := substr (cBuffer, 1, nPos-1) + substr (cBuffer, nPos + len(CRLF))

   nPos--

endif


RETURN




/* Ŀ
     VISUALIZADOR           
                            
    */
/*
  Tb14.prg .... Ejemplo de un TBrowse para visualizar ficheros

  Original:    (c) Grupo EIDOS, abril 1993

  Modificada:  Nacho Lafuente, Octubre 1996
*/

FUNCTION View (cFile)

LOCAL oTxt, oTxtCol, oTxtCol1, oMenu
LOCAL nTecla
LOCAL cColor    := SetColor(COL_V1)
LOCAL nCursor   := SetCursor(SC_NONE)
LOCAL cPantalla := saveScreen()
LOCAL ventana
LOCAL nIzq, nDer, nSup, nInf
LOCAL Operacion


// Inicializacion de ficheros
// 

IF !File(cFile)
   xMensaje ({"","El fichero no existe",""},COL_V2,COL_V2R,WARNING)
   RETURN .f.
END IF

if (nHandle := fopen (cFile, FO_READ)) = -1
   xMensaje ({"","Imposible abrir fichero " + cFile,""},COL_V2,COL_V2R,WARNING)
   RETURN .f.
endif


FSeek(nHandle, 0, FS_END)
nLong := FSeek(nHandle,0,FS_RELATIVE)
FirstTxt()


// Formateado de pantalla
// 

   nSup := 0
   nIzq := 0
   nInf := 24
   nDer := 79


@ 0,0 CLEAR TO maxrow(), maxcol()

xPonTitulo("I N F O R M E S", COL_TITULOESC)

// Inicializacion del TBrowse
// 

oTxt    := TBrowseNew(nSup+1, nIzq+1, nInf-4, nDer-1)
oTxtCol := TBColumnNew(, {|| cLine })
oMenu   := {|| BotVisualizador(oTxt, nInf-2)}
oTxt:colorSpec := COL_V1

oTxtCol1       := TbColumnNew(, {|| SubStr(cLine, nDer) })
oTxtCol1:width := nDer
oTxtCol:width  := nDer

oTxt:addColumn(oTxtCol)
oTxt:addColumn(oTxtCol1)
oTxt:goTopBlock         := {| | FirstTxt() }
oTxt:goBottomBlock      := {| | LastTxt()  }
oTxt:skipBlock          := {|n| SkipTxt(n) }


// Bucle de proceso
// 

WHILE .T.

   nTecla := TbStd(oTxt, oMenu)       // Teclas automatizadas

   DO CASE

      case nTecla == K_ESC

           Operacion := SALIR
           EXIT

      case nTecla == K_SPACE

           Operacion := IMPRIMIR
           EXIT

      case nTecla == K_CTRL_BS

           Operacion := EXPORTAR
           EXIT

   END IF

END WHILE

FClose(cFile)
SetColor(cColor)
SetCursor(nCursor)

RETURN Operacion




/* Ŀ
     MOVIMIENTO VISUALIZADOR
                            
    */

// Funcin para el CodeBlock que posiciona en la primera lnea
// 
FUNCTION FirstTxt()
   FSeek(nHandle, 0, FS_SET)
   FLine(nHandle, @cLine)
   FSeek(nHandle, 0, FS_SET)
RETURN NIL




//Funcin que lee cada lnea
// 
FUNCTION FLine(nHandle, cBuffer)
   LOCAL nEol, nRead, nPos, nPos2
   LOCAL cAux

   cBuffer := Space(LINEA)

   nPos := FSeek(nHandle,0,FS_RELATIVE)
   nRead = FRead(nHandle, @cBuffer, LINEA)

   IF (nEol := At(CRLF, SubStr(cBuffer, 1, nRead))) # 0
      cBuffer := SubStr(cBuffer, 1, nEol - 1)
      FSeek(nHandle, nPos + nEol + 1, FS_SET)
/*
      DO WHILE (nPos := At(I_TIPO, cBuffer)) != 0
         nPos2 := At(I_TIPO, substr(cBuffer, nPos + len(I_TIPO)))
         IF nPos2 != 0
            cAux := substr (cBuffer, 1, nPos - 1) + ;
                    substr (cBuffer, nPos + nPos2 + 2 * len(I_TIPO) - 1)
         ELSE
            cAux := substr (cBuffer, nPos + len(I_TIPO))
         ENDIF
         cBuffer := cAux
      ENDDO
*/
   END IF

RETURN nRead != 0




// Funcin para el CodeBlock que posiciona en la ltima lnea
// 
FUNCTION LastTxt()
   FSeek(nHandle, 0, FS_END)
   GoPrevLn()
RETURN NIL



// Funcin para el CodeBlock que salta lneas
// 
FUNCTION SkipTxt(n)
   LOCAL nSaltados := 0

   IF n > 0

      WHILE nSaltados != n .AND. GoNextLn()
            nSaltados++
      END WHILE

    ELSE
      WHILE nSaltados != n .AND. GoPrevLn()
            nSaltados--
      END WHILE

   ENDIF

RETURN nSaltados




// Mueve a la siguiente lnea
// 
FUNCTION GoNextLn()
   LOCAL nPos := FSeek(nHandle,0,FS_RELATIVE), ;
         cBuff := "", lMoved, nNewPos

   FSeek(nHandle, Len(cLine) + 2, FS_RELATIVE)
   nNewPos := FSeek(nHandle,0,FS_RELATIVE)

   IF FLine(nHandle, @cBuff)
      lMoved := .T.
      cLine := cBuff
      FSeek(nHandle, nNewPos, FS_SET)
    ELSE
      lMoved := .F.
      FSeek(nHandle, nPos, FS_SET)
   END IF

RETURN lMoved



// Mueve a la lnea anterior
// 
FUNCTION GoPrevLn()
   LOCAL nPos := FSeek(nHandle,0,FS_RELATIVE), nMaxRead, nNewPos, ;
         lMoved, cBuff, nWhereCrLf, nPrev

   IF nPos == 0
      lMoved := .F.
    ELSE
      lMoved := .T.
      FSeek(nHandle, -2, FS_RELATIVE)

      IF nLong >= nPos                        //Controla finales de
         IF FReadStr(nHandle,2) == CRLF       //fichero con CRLF,
            FSeek(nHandle, -2, FS_RELATIVE)   //Chr(26) o sin nada
         END IF
      END IF

      nMaxRead := Min(LINEA, FSeek(nHandle,0,FS_RELATIVE))
      cBuff := Space(nMaxRead)
      nNewPos := FSeek(nHandle, -nMaxRead, FS_RELATIVE)
      FRead(nHandle, @cBuff, nMaxRead)
      nWhereCrLf := Rat(CRLF, cBuff)
      IF nWhereCrLf == 0
         nPrev := nNewPos
         cLine := cBuff
       ELSE
         nPrev := nNewPos + nWhereCrLf + 1
         cLine := SubStr(cBuff, nWhereCrLf + 2)
      END IF

      FSeek(nHandle, nPrev, FS_SET)
   END IF

RETURN lMoved






/* Ŀ
     BOTONES VISUALIZADOR   
                            
    */
FUNCTION BotVisualizador(oBrw, nFila)

STATIC aBotones := { {"^Salir",   K_ESC,       "Terminar de hojear el informe"},  ;
                     {"^Imprimir",K_F4,        "Imprimir el informe"},            ;
                     {"^Fichero", K_CTRL_BS,   "Imprimir el informe en un fichero de texto"},;
                     {"^"+chr(25),K_DOWN,      "Baja una linea"},                 ;
                     {"^"+chr(24),K_UP,        "Sube una linea"},                 ;
	                  {"^"+chr(29),K_PGDN, K_PGUP, K_HOME, K_END,                  ;
         	          "Otros movimientos: (AvPg), (RePg), (Inicio), (Fin)" }    ;
                   }
STATIC lBotonesOk := .f.
STATIC botones
LOCAL nBoton
LOCAL nTecla
LOCAL lSalir := .f.



if !lBotonesOk

   botones := xPonBotones (aBotones, nFila, COL_V1, COL_V1R, COL_MSG, CENTRADOS, 1)
   lBotonesOk := .t.

endif

xRestauraBotones(botones)

DO WHILE !lSalir

   nBoton := xLeeBotones(botones)

   DO CASE

      case nBoton = 0 .or. nBoton = 1

        KEYBOARD Chr(K_ESC)
        lSalir := .t.

      case nBoton = 2

        // Solamente mando el espacio porque parece ignorar
        // las teclas de funcion (tienen codigo negativo)

        KEYBOARD Chr(K_SPACE)
        lSalir := .t.

      case nBoton = 3

        KEYBOARD Chr(K_CTRL_BS)
        lSalir := .t.

      case nBoton = 4

        KEYBOARD Chr(K_DOWN)
        lSalir := .t.

      case nBoton = 5

        KEYBOARD Chr(K_UP)
        lSalir := .t.

      case nBoton = 6

        nTecla := LastKey()
        IF nTecla = K_PGDN
           KEYBOARD Chr(K_PGDN)
           lSalir := .t.
        elseif nTecla = K_PGUP
           KEYBOARD Chr(K_PGUP)
           lSalir := .t.
        elseif nTecla = K_HOME
           KEYBOARD Chr(K_CTRL_PGUP)
           lSalir := .t.
        elseif nTecla = K_END
           KEYBOARD Chr(K_CTRL_PGDN)
           lSalir := .t.
        ENDIF

   ENDCASE

ENDDO

RETURN NIL







/* Ŀ
     IMPRIMIR               
                            
    */
FUNCTION Imprimir (cFichero)

local nHandle
local cBuffer, cAux, nPos, cLinea
local nMargenSup, nMargenInf, nMargenDer, nMargenIzq
local nMaxPagina, nMaxLineas, nAncho, nLongLinea
local nPuerto, nImp
local lFinBuffer, lFinPagina, lOk, lFinInforme



if xGetConfig("I_FICHEROS") = "N"
   RETURN I_NOINSTALADA
endif

if (nHandle := fopen (cFichero, FO_READ)) = -1
   RETURN (I_FILE)
endif

// Estructura de control
// 
fseek (nHandle, -200, FS_END)
cBuffer := space(200)
if fread (nHandle, @cBuffer, 200) != 200
   RETURN I_FILE
endif

cBuffer    := substr (cBuffer, at (I_CTRL + CRLF, cBuffer) + len(I_CTRL + CRLF))
nMaxLineas := val(substr (cBuffer, 1, nPos := at (CRLF, cBuffer)))
cBuffer    := substr (cBuffer, nPos + len(CRLF))
nAncho     := val(substr (cBuffer, 1, nPos := at (CRLF, cBuffer)))
cBuffer    := substr (cBuffer, nPos + len(CRLF))
nMargenSup := val(substr (cBuffer, 1, nPos := at (CRLF, cBuffer)))
cBuffer    := substr (cBuffer, nPos + len(CRLF))
nMargenInf := val(substr (cBuffer, 1, nPos := at (CRLF, cBuffer)))
cBuffer    := substr (cBuffer, nPos + len(CRLF))
nMargenIzq := val(substr (cBuffer, 1, nPos := at (CRLF, cBuffer)))
cBuffer    := substr (cBuffer, nPos + len(CRLF))
nMargenDer := val(substr (cBuffer, 1, nPos := at (CRLF, cBuffer)))
cBuffer    := substr (cBuffer, nPos + len(CRLF))
nMaxPaginas := val(substr (cBuffer, 1, nPos := at (CRLF, cBuffer)))


// Situo el puntero al principio del fichero
fseek (nHandle, 0, FS_SET)

// Inicializo la impresora
// 
nPuerto := val(xGetConfig ("I_PUERTO"))
nImp    := val(xGetConfig ("I_NIMP"))
if nPuerto != 1 .and. nPuerto != 2 .and. nPuerto != 3
   RETURN I_MALCONFIG
endif

do while !printReady(nPuerto)
   lOk := xPregunta ({"", "   La impresora no est ON-LINE   ", ""}, ;
                     COL_V2, COL_V2R, WARNING)
   if !lOk
      // vacio el buffer de teclazos
      do while inkey() != 0
      enddo
      RETURN I_PRINTER
   endif
enddo

SET PRINTER TO ("LPT" + alltrim(str(nPuerto)))
SET CONSOLE OFF
SET PRINTER ON

?? Tipo(nImp, "INICIO")

// Impresion del fichero
// 
cBuffer := space(L_BUFFER)
cAux := ""
lFinPagina := .f.
lFinBuffer := .f.
lFinInforme := .f.
nLongLinea := nAncho - (nMargenIzq + nMargenDer)

fread(nHandle, @cBuffer, L_BUFFER)

do while !lFinBuffer .and. !lFinInforme

   do while !lFinPagina .and. !lFinBuffer .and. !lFinInforme

      nPos := at (CRLF, cBuffer)

      cLinea := substr(cBuffer, 1, nPos + len(CRLF))
      cBuffer := substr(cBuffer, nPos + len(CRLF))

      if at (FF, cLinea) != 0
         lFinPagina := .t.
         cLinea := ""
      elseif (at (I_CTRL, cLinea) != 0 .or. at (I_FIN, cLinea) != 0)
         lFinInforme := .t.
         cLinea := ""
      endif

      do while len(cLinea) != 0

         nPos := at(I_TIPO, cLinea)
         if nPos != 0
            // hay codigo de escape
            ?? substr(cLinea, 1, nPos-1)
            cLinea := substr(cLinea, nPos + len(I_TIPO))
            nPos := at(I_TIPO, cLinea)
            ?? tipo(nImp, substr(cLinea, 1, nPos - 1))
            cLinea := substr(cLinea, nPos + len(I_TIPO))
         else
            // no hay codigo de escape
            ?? cLinea
            cLinea := ""
         endif

      enddo

      if len(cBuffer) <= 2 * nLongLinea
         lFinBuffer := .t.
      endif

   enddo // while !lFinPagina .and. !lFinBuffer

   if lFinPagina
      // cambio de pagina
      lFinPagina := .f.
   endif

   if lFinBuffer
      cAux := cBuffer
      cBuffer := space(L_BUFFER)
      if fread(nHandle, @cBuffer, L_BUFFER) != 0
         cBuffer := cAux + cBuffer
         lFinBuffer := .f.
      else
         lFinBuffer := .t.
      endif
   endif

enddo  // while !lFinBuffer .and. !lFinInforme

?? CRLF
?? CRLF

SET PRINTER OFF
SET CONSOLE ON

RETURN I_OK




/* Ŀ
     CODIGOS DE ESCAPE      
                            
    */
FUNCTION Tipo(nImpresora, cLetra)

/* Nota:

     Busca el codigo de escape de la impresora <nImpresora> para
   obtener el estilo <cLetra>
*/


LOCAL Start := 1           // Escapes->Valor se analiza desde Start
LOCAL End   := 0           // Hasta End
LOCAL Pos   := 0           // Posiciones para cada cdigo
LOCAL cCad  := ""          // Recoge la secuencia completa a imprimir
local nOrd  := indexOrd()
local nTabla := alias()


SELECT ESCAPES
set order to I1ESCAPES

Escapes->(DbSeek(Str(nImpresora,3)+cLetra))
End := At(" ", Escapes->Valor)
Pos := End

// Se recorre Escapes->Valor para construir la secuencia de escape
WHILE Pos != 0
  cCad  += Chr(Val(SubStr(Escapes->Valor, Start, Pos)))
  Start := End + 1
  End   += At(" ",SubsTr(Escapes->Valor, Start))
  Pos   := End - Start
END WHILE

SELECT (nTabla)
set order to (nOrd)

RETURN cCad





/* Ŀ
     % INFORME COMPLETADO   
                            
    */
/* Notas:

     nPorCiento == 0   --> Inicializo la ventana y la barra

     nPorCiento != 0   --> Solamente actualizo la barra

     nPorCiento == nil --> Quito la barra y la ventana
*/

FUNCTION InfEnCurso(nPorCiento)

STATIC barra
STATIC ventana

if nPorCiento == nil

   xQuitaMenBarra(ventana)
   RETURN .t.

endif

if nPorCiento == 0

   // inicializacion del mensaje con barra

   ventana := xPonMenBarra("CREACION DE INFORME",COL_V2,COL_V2B,COL_V2INV)

endif

xActMenBarra (ventana, nPorCiento)

RETURN .T.







/* Ŀ
     EXPORTADOR DE FICHEROS 
                            
    */
/* Nota:

      Se supone que solamente se colocan caracteres de control en:

      - Primer bloque del fichero
      - Ultimo bloque del fichero

      donde cada bloque es de tamao L_BUFFER (1024 caracteres)
*/
FUNCTION ExportaFichero (cFuente)

LOCAL nFuente, nDestino
LOCAL cDestino
LOCAL cBuffer
LOCAL nBytes
LOCAL nPos
LOCAL nResta


if (nFuente := fopen (cFuente, FO_READ)) = -1
   RETURN (I_FILE)
endif

// A cada fichero exportado se le aade un nmero que
// indica el orden en que se ha exportado

if nInforme == nil   // todavia no hemos hecho ninguna exportacion
   nInforme := 0
else                 // una exportacion ms
   nInforme++
endif

if nInforme >= 10        // nmero de caracteres a quitar del nombre
   nResta := 2           // de fichero para poner <nInforme>
elseif nInforme >= 100
   nResta := 3
else
   nResta := 1
endif

nPos := at(".", cFuente)
if nPos = 0

   cDestino := substr(cFuente, 1, 8-nResta) + ;
               alltrim(str(nInforme)) +       ;
               ".txt"

else

   if (nPos = 9, nResta++, nil)
   cDestino := substr(cFuente, 1, nPos-nResta) +  ;
               alltrim(str(nInforme)) +      ;
               ".txt"

endif

if (nDestino := fcreate (cDestino, FC_NORMAL)) = -1
   RETURN (I_FILE)
endif

// Leo el principio y lo escribo limpio

cBuffer := space(L_BUFFER)
fSeek(nFuente, 0, FS_SET)
fRead(nFuente, @cBuffer, L_BUFFER)
cBuffer := Limpia(cBuffer)
fWrite(nDestino, cBuffer, len(cBuffer))

// Leo el resto y lo copio tal cual

cBuffer := space(4*L_BUFFER)

do while (nBytes  := fRead(nFuente, @cBuffer, 4*L_BUFFER)) > 0
   fWrite(nDestino, cBuffer, nBytes)
enddo

// Leo el ultimo bloque, lo limpio y sobreescribo el destino

fSeek(nFuente, -int(L_BUFFER/2), FS_END)
cBuffer := space(L_BUFFER)
fread(nFuente, @cBuffer, L_BUFFER)
cBuffer := Limpia(cBuffer)
padr(cBuffer, int(L_BUFFER/2))
fSeek(nDestino, -int(L_BUFFER/2), FS_END)
fWrite(nDestino, cBuffer, len(cBuffer))

// Cierro los ficheros

if !fclose(nFuente)
   RETURN(I_FILE)
endif
if !fclose(nDestino)
   RETURN(I_FILE)
endif

RETURN (cDestino)



FUNCTION Limpia(cBuffer)

LOCAL nPos
LOCAL cAux := ""

   do while (nPos := at(I_TIPO, cBuffer)) != 0
      cAux    := cAux + substr(cBuffer, 1, nPos-1)
      cBuffer := substr(cBuffer, nPos + len(I_TIPO))
      nPos    := at(I_TIPO, cBuffer)
      cBuffer := substr(cBuffer, nPos + len(I_TIPO))
   enddo

RETURN cAux + cBuffer














/* ͻ
                                                  
     FUNCIONES AUXILIARES DE INFORMES             
                                                  
   ͼ */




/* Ŀ
     INTERVALO DE FECHAS    
                            
    */
FUNCTION Intervalo(dFechaIni, dFechaFin, cTitulo)

LOCAL cColor     := SetColor(COL_V2)
LOCAL nCursor    := SetCursor(SC_NORMAL)
LOCAL ventana    := xPonVentana (5,18,18,62,COL_V2,SOBRE, cTitulo)
LOCAL lCorrecto  := .f.
LOCAL cEjercicio := space(4)
LOCAL cTrimestre := space(1)



dFechaIni := ctod("01-01-" + xGetConfig("CN_EJERCICIO"))
dFechaFin := ctod("31-12-" + xGetConfig("CN_EJERCICIO"))

@ 8, 26 SAY "Seleccin del periodo fiscal"
@ 10, 34 SAY "EJERCICIO " + xGetConfig("CN_EJERCICIO")
@ 11, 34 SAY "TRIMESTRE"
@ 13, 23 SAY "Intervalo de fechas para el informe"
@ 15, 33 SAY "DESDE"
@ 16, 33 SAY "HASTA"

DO WHILE !lCorrecto

 /*  @ 10,44 GET cEjercicio                                                    ;
           PICTURE mascaraYearL                                              ;
           MESSAGE "Ao del ejercicio contable que se desea seleccionar"     ;
           COLORMSG COL_MSG                                                  ;
           VALID ValEjercicio(cEjercicio, @GetList)                           */

   @ 11,44 GET cTrimestre                                                    ;
           PICTURE mascaraTrimestre                                          ;
           MESSAGE "Trimestre del ejercicio contable que se desea utilizar"  ;
           COLORMSG COL_MSG                                                  ;
           VALID ValTrimestre(cTrimestre, @GetList)
   @ 15,40 GET dFechaIni ;
	        MESSAGE "Fecha inicial en el formato dd-mm-aa" ;
	        COLORMSG COL_MSG
   @ 16,40 GET dFechaFin ;
	        MESSAGE "Fecha final en el formato dd-mm-aa" ;
	        COLORMSG COL_MSG
   READ

   if lastKey() = K_ESC
      xQuitaVentana (ventana)
      RETURN .F.
   endif

   if (dFechaIni <= dFechaFin)
      lCorrecto := .T.
   else
      xMensaje({"", "La fecha inicial debe ser", ;
                    "menor que la fecha final", ""}, COL_V2, COL_V2R, WARNING)
   endif

ENDDO

IF dFechaIni = ctod("  -  -  ") .AND. dFechaFin = ctod("  -  -  ")
   dFechaIni := ctod("01-01-00")
   dFechaFin := ctod("31-12-99")
ENDIF

xQuitaVentana (ventana)
SetColor (cColor)
SetCursor (nCursor)

RETURN .t.



// Validacion del Ejercicio
// 
/*

FUNCTION ValEjercicio(cEjercicio, GetList)

LOCAL dFecha


if val(cEjercicio) > 1000

   // El ejercicio es correcto
   // Coloco el ao en el intervalo de fechas

   // Fecha inicial
   dFecha := GetList[2]:varGet()
   dFecha := ctod(substr(dtoc(dFecha), 1, 6) + cEjercicio)
   GetList[2]:varput(dFecha)
   GetList[2]:upDateBuffer()
   GetList[2]:display()

   // Fecha final
   dFecha := GetList[3]:varGet()
   if empty(GetList[2]:varGet())
      dFecha := ctod("31-12-" + cEjercicio)          // No hay trimestre
   else
      dFecha := ctod(substr(dtoc(dFecha), 1, 6) + ;  // Si hay trimestre
                cEjercicio)
   endif
   GetList[3]:varput(dFecha)
   GetList[3]:upDateBuffer()
   GetList[3]:display()


   RETURN .t.

elseif empty(cEjercicio)

   // El ejercicio es vacio
   // Inicializo el intervalo de fechas

   // Fecha inicial
   dFecha := ctod(I_FECHAINI)
   GetList[2]:varput(dFecha)
   GetList[2]:upDateBuffer()
   GetList[2]:display()

   // Fecha final
   dFecha := ctod(I_FECHAFIN)
   GetList[3]:varput(dFecha)
   GetList[3]:upDateBuffer()
   GetList[3]:display()

   RETURN .t.

else

   RETURN .f.

endif

RETURN nil
*/

// Validacion del Trimestre
// 

FUNCTION ValTrimestre(cTrimestre, GetList)

LOCAL nAux
LOCAL dFecha
LOCAl nTrimestre := val(cTrimestre)



if (nTrimestre >= 1) .and. (nTrimestre <= 4)

   // Trimestre correcto
   // Coloco el mes en el intervalo de fechas

   // Fecha inicial
   dFecha := GetList[2]:varGet()
   dFecha := ctod(substr(dtoc(dFecha), 1, 3) + ;
                  xIniTrimestre(nTrimestre)  + ;
                  substr(dtoc(dFecha), 6)      ;
                 )
   GetList[2]:varput(dFecha)
   GetList[2]:upDateBuffer()
   GetList[2]:display()

   // Fecha final
   dFecha := GetList[3]:varGet()
   dFecha := ctod("01-"                      + ;    // Coloco el nuevo mes
                  xFinTrimestre(nTrimestre)  + ;
                  substr(dtoc(dFecha), 6)      ;
                 )
   dFecha := eom(dFecha)                            // Calculo ultimo dia mes
   GetList[3]:varput(dFecha)
   GetList[3]:upDateBuffer()
   GetList[3]:display()

   RETURN .t.

elseif empty(cTrimestre)

   RETURN .t.

else

   RETURN .f.

endif

RETURN nil






/* Ŀ
     TITULO DE INFORME      
                            
    */
FUNCTION Titulo(cTitulo)

LOCAL nAncho
LOCAL cAncho
LOCAL cAux1
LOCAL cAux2
LOCAL cAux3


cAncho := xGetConfig("I_ANCHOPAGINA")
if (!empty(cAncho), nAncho := val(cAncho), nAncho := 80)

if len(cTitulo) > nAncho - 2*I_MARGEN
   cAux1 := substr(cTitulo, 1, nAncho - 2*I_MARGEN)
else
   cAux1 := cTitulo
endif

cAux2 := replicate("*", I_MARGEN)
cAux3 := replicate("*", len(cAux1))

?  "*" + cAux2 + cAux3 + cAux2 + "*"
?  "*" + space(I_MARGEN) + cAux1 + space(I_MARGEN) + "*"
?  "*" + cAux2 + cAux3 + cAux2 + "*"

RETURN nil
