////////////////////////////////////////////////////////////////////////////
//
// Fichero:    XFUNCION.PRG
// Fecha:      3-9-98
// Contenido:  Biblioteca de funciones de todas clases
// Notas:
//
//
////////////////////////////////////////////////////////////////////////////



#include "def.ch"
#include "inkey.ch"
#include "miget.ch"
#include "setcurs.ch"
#Include "GetExit.ch"
#Include "Box.ch"
#include "nt2disk.ch"
#include "nt2kbd.ch"
#include "nt2misc.ch"
#include "nt2print.ch"
#include "nt2sys.ch"
#include "nt2video.ch"





/* ͻ
                                                  
     S I S T E M A   D E   B O T O N E S          
                                                  
   ͼ */

/* Ŀ
    xPONBOTONES                  
                                 
    */

FUNCTION xPonBotones(aBotones, nFila, cColBoton, cColRes, cColMsg, ;
                     nModo, nPredet)

/* Sintaxis

      xPonBotones(aBotones, nFila, cColBoton,
                  cColRes, nModo, [nPredet]) --> uBoton

   Descripcion:

      aBotones:
       [i][1]: Texto del boton con ^ para indicar hot-key
       [i][2]..[i][n-1]: teclas automatizadas
       [i][n]: Texto del mensaje
      nFila: fila en la que se situar el texto del boton
      cColBoton: Color del boton
      cColRes: Color de la letra resaltada para hot-key
      cColMsg: Color del mensaje
      nModo: CENTRADOS o IZQUIERDA
      [nPredet]: Numero de boton que consigue el control
                 Valor por defecto es el 1

   Devuelve:
      Devuelve un objeto de tipo boton:
       [i][1]: Texto del boton con ^ para indicar hot-key
       [i][2]..[i][n-6]: teclas automatizadas
       [i][n-5]: Texto del mensaje
       [i][n-4]..[i][n-1]: Coordenadas del recuadro del boton
       [i][n]: modo en el que se encuentra B_NORMAL,B_RESALT,B_SELECC

       [m][1]: Color del boton
       [m][2]: Color de la letra resaltada del boton
       [m][3]: Nmero de botones
       [m][4]: Nmero de boton activo
       [m][5]: Pantalla salvaguardada
       [m][6]..[m][9]: Coordenadas de salvaguardado
       [m][10]: cdigo ASCI ultima tecla pulsada
       [m][11]: color del mensaje
       [m][12]..[m][15]: coordenadas de salvaguarda de la fila del mensaje
       [m][16]: Salvaguarda fila de los mensajes
*/

LOCAL nNumB := len(aBotones), nTotLong := 0
LOCAL i, j, n, nIzq, nDer
LOCAL botones := {}, nSep
LOCAL cElColor := SetColor(), cElCursor := SetCursor (SC_NONE)

if nModo = CENTRADOS
   for i := 1 to nNumB
       nTotLong := nTotLong + len(aBotones[i][1]) + 4 - 1
   next
   nTotLong := int ((maxCol() - nTotLong) / 2) - 1
endif
if (nPredet = NIL, nPredet := 1, nil)
asize (botones, nNumB + 1)
for i := 1 to nNumB
    botones[i] := {}
    n := len (aBotones[i])
    asize (botones[i], n)
    botones[i][1] := aBotones[i][1]
    for j := 2 to n-1
        botones[i][j] := asc(upper(chr(abotones[i][j])))
    next
    nSep := at("^",Botones[i][1])
    botones[i][n] := asc(upper(substr(botones[i][1],nSep+1,1)))
    aadd(botones[i], abotones[i][n])
    nIzq := nTotLong + 1
    nTotLong := nTotLong + len(aBotones[i][1]) + 4 - 1
    nDer := nTotLong
    aadd (botones[i], nFila-1)
    aadd (botones[i], nIzq)
    aadd (botones[i], nFila+1)
    aadd (botones[i], nDer)
    aadd (botones[i], if(i=nPredet,B_RESALT,B_NORMAL))
next
n := Set(_SET_MESSAGE)
botones[nNumB+1] := {cColBoton, cColRes, nNumB, nPredet, ;
                     savescreen(nFila-1, 0, nFila+1, maxCol()), ;
                     nFila-1, 0, nFila+1, maxCol(), , cColMsg,  ;
                     n, 0, n, maxcol(), ;
                     SaveScreen(n,0,n,MaxCol()) }
xRestauraBotones (botones)
SetColor(cElColor)
SetCursor (cElCursor)

RETURN botones



/* Ŀ
    xQUITABOTONES                
                                 
    */
/* Nota:
     Restaura el contenido de la pantalla salvaguardada correspondiente
   a los botones y la barra de los mensajes
*/
FUNCTION xQuitaBotones (botones)


LOCAL m := len(botones)

restscreen (botones[m][6],botones[m][7],botones[m][8],botones[m][9],;
            botones[m][5])
restscreen (botones[m][12],botones[m][13],botones[m][14],botones[m][15],;
            botones[m][16])

RETURN .T.



/* Ŀ
    xRESTAURABOTONES             
                                 
    */
/* Nota:
     Pinta todos los botones con sus mensajes. El ultimo que pinta es
   el activo para que el mensaje asociado sea concordante
*/
FUNCTION xRestauraBotones (botones)

LOCAL i, m := len(botones)

DispBegin()
for i := 1 to (len(botones) - 1)
   // pinta el boton si no es el activo
   if (botones[m][4] != i, xPintaBoton(botones, i), nil)
next
xPintaBoton (botones, botones[m][4])
DispEnd()

RETURN .T.



/* Ŀ
    xPINTABOTON                  
                                 
    */

FUNCTION xPintaBoton (Botones, i)

LOCAL n := len(botones[i]), nSep, cCadena, m := len(botones)
LOCAL cElColor := SetColor(), cElCursor := SetCursor (SC_NONE)

nSep := at("^",Botones[i][1])
if nSep = 1
     cCadena := substr(Botones[i][1],2)
else
     cCadena := left(Botones[i][1],nSep-1) + substr(Botones[i][1],nSep+1)
endif
dispBegin()
@ botones[m][12],0 say padc(botones[i][n-5],MaxCol()+1) ;
                      color botones[m][11]
do case
case botones[i][n] = B_SELECC
   xPonVentana (botones[i][n-4], botones[i][n-3], ;
                botones[i][n-2],botones[i][n-1], botones[m][1], SUB)
   @ botones[i][n-4]+1,botones[i][n-3]+1 say ;
     chr(16)+cCadena+chr(17) color botones[m][1]
case botones[i][n] = B_NORMAL
   xPonVentana (botones[i][n-4], botones[i][n-3],;
                botones[i][n-2],botones[i][n-1], botones[m][1], SOBRE)
   @ botones[i][n-4]+1,botones[i][n-3]+2 say ;
     cCadena color botones[m][1]
   @ botones[i][n-4]+1,botones[i][n-3]+1+nSep say ;
     substr(cCadena,nSep,1) color botones[m][2]
case botones[i][n] = B_RESALT
   xPonVentana (botones[i][n-4], botones[i][n-3], ;
                botones[i][n-2], botones[i][n-1], botones[m][1], SOBRE)
   @ botones[i][n-4]+1,botones[i][n-3]+1 say ;
     chr(16)+cCadena+chr(17) color botones[m][1]
   @ botones[i][n-4]+1,botones[i][n-3]+1+nSep say ;
     substr(cCadena,nSep,1) color botones[m][2]
endcase
dispEnd()
SetColor(cElColor)
SetCursor (cElCursor)

RETURN .T.



/* Ŀ
    xLEEBOTONES                  
                                 
    */

FUNCTION xLeeBotones (botones)

/* Sintaxis:

       xLeeBotones (botones) --> nBoton

   Descripcion:

       botones: Objeto botones creado con xPonBotones

   Devuelve:

       nBoton es el numero de boton seleccionado
       Si se ha pulsado ESC devuelve 0
*/

LOCAL nTecla, i, n, m, nBViejo
LOCAL cElColor := SetColor(), cElCursor := SetCursor (SC_NONE)

m := len (botones)
do while .t.
nTecla := xInkey (0,0)
botones[m][10] := nTecla
do case
   case nTecla = K_ESC
        return 0
   case (nTecla = K_LEFT) .or. (nTecla = K_RIGHT) .or. (nTecla = K_TAB)
        nBViejo := botones[m][4]
        n := len (botones[nBViejo])
        botones[nBViejo][n] := B_NORMAL
        xPintaBoton(botones, nBViejo)
        if nTecla = K_LEFT
           botones[m][4] := botones[m][4] - 1
           if (botones[m][4] = 0, botones[m][4] := botones[m][3], nil)
        else
           botones[m][4] := botones[m][4] + 1
           if (botones[m][4] > botones[m][3], botones[m][4] := 1, nil)
        endif
        i := botones[m][4]
        n := len (botones[i])
        botones[i][n] := B_RESALT
        xPintaBoton(botones, i)
   case nTecla = K_ENTER
        i := botones[m][4]
        n := len(botones[i])
        botones[i][n] := B_SELECC
        xPintaBoton (botones, i)
        //botones[i][n] := B_RESALT
        //xPintaBoton (botones, i)
        SetColor(cElColor)
        SetCursor (cElCursor)
        return i
   otherwise
        i := xBuscaTecla (botones, asc(upper(chr(nTecla))))
        if i != 0
           n := len(botones[botones[m][4]])
           botones[botones[m][4]][n] := B_NORMAL
           xPintaBoton (botones, botones[m][4])
           botones[m][4] := i
           n := len(botones[i])
           botones[i][n] := B_SELECC
           xPintaBoton (botones, i)
           //botones[i][n] := B_RESALT
           //xPintaBoton (botones, i)
           SetColor(cElColor)
           SetCursor (cElCursor)
           return i
        endif
endcase
enddo

RETURN nil



/* Ŀ
    xBUSCATECLA                  
                                 
    */

FUNCTION xBuscaTecla (botones, nTecla)

LOCAL lExito := .f., nMax := len(botones)-1, i := 1
LOCAL n, nPos

do while (i <= nMax) .and. !lExito
   n := len (botones[i])
   nPos := ascan (botones[i], nTecla, 2, n-5)
   if ((nPos >= 2) .and. (nPos <= n-5), lExito := .t., i++)
enddo
if lExito
   return i
else
   return 0
endif

return nil




/* Ŀ
    xULTIMATECLA                 
                                 
    */

/* Sintaxis:

        xUltimaTecla (botones) --> nCodAscii

   Devuelve:
     Cdigo Ascii de la ultima tecla pulsada
*/

FUNCTION xUltimaTecla (botones)

RETURN botones[len(botones)][10]





/* ͻ
                                                  
     O T R A S   F U N C I O N E S                
                                                  
   ͼ */



/* Ŀ
    xINKEY                       
                                 
    */

FUNCTION xInkey( nSegundos, bBloque )

LOCAL nTecla, bBloqueTecla, nTranscurrido:=0, ;
      nTiempo:=Seconds()

  IF ValType( bBloque ) != "B"
     bBloque := {|| NIL}
  END IF

  WHILE .T.
    WHILE ( nTecla:=InKey() ) == 0
      IF (nTranscurrido:=Seconds()-nTiempo) >= nSegundos .AND.;
         nSegundos != 0
         nTiempo := Seconds()
      END IF
      Eval(bBloque)
    END

    IF ( bBloqueTecla := SetKey( nTecla ) ) != NIL
       EVAL(bBloqueTecla, ProcName(1), ProcLine(1), ReadVar())
       nTiempo := Seconds() - nTranscurrido
    ELSE
       EXIT
    END IF
  END

RETURN nTecla



/* Ŀ
    xHORAOK                      
                                 
    */
FUNCTION xHoraOk (cHora)

/* Sintaxis:

     xHoraOk --> lCorrecta

   Descripcion:

     cHora: cadena horaria de la forma 99:99:99

   Devuelve:

     .t. <--> cHora representa una hora correcta
*/

LOCAL nH := val(substr (cHora, 1, 2))
LOCAL nM := val(substr (cHora, 4, 2))
LOCAL nS := val(substr (cHora, 7, 2))

if (23 >= nH) .and. (nH >= 0) .and. (59 >= nM) .and. (nM >= 0) ;
   .and. (59 >= nS) .and. (nS >= 0)
   return .t.
else
   return .f.
endif

RETURN nil



// ****FUNCTION Clipper501 *****
// Por compatibilidad con libreria Nanforum
// NO BORRAR!!
FUNCTION Clipper501 ()
RETURN .T.




/* Ŀ
    xACOMP                       
                                 
    */
/* Nota:

   La funcion compara dos arrays examinando solamente un nivel
   Con ms de un nivel de comparacion se debe hacer recursiva

       xaComp (a1, a2) --> lIguales

*/
FUNCTION xaComp (a1, a2)

LOCAL nIndice    := 1
LOCAL nLong      := len(a1)
LOCAL lDistintas := .f.
LOCAL cTipo1
LOCAL cTipo2


if nLong != len(a2)
   RETURN .f.
endif

cTipo1 := valtype(a1[nIndice])
cTipo2 := valtype(a2[nIndice])

do while cTipo1 = cTipo2 .and. nLong >= nIndice .and. !lDistintas

   if cTipo1 = "C" .or. cTipo1 = "N" .or. cTipo1 = "D" .or. cTipo1 = "L"

      lDistintas := a1[nIndice] != a2[nIndice]

   endif

   nIndice++

   if nLong >= nIndice
      cTipo1 := valtype(a1[nIndice])
      cTipo2 := valtype(a2[nIndice])
   endif

enddo

RETURN !lDistintas




/* Ŀ
    xAMAXLEN                     
                                 
    */
/* Nota:

   La funcion devuelve la longitud de la cadena mas larga del array

       xaMaxLen (aArray) --> nMaxLongitud

*/
FUNCTION xaMaxLen (aArray)

LOCAL nMaxLongitud := 0
LOCAL i


   for i := 1 to len(aArray)
      nMaxLongitud := max(nMaxLongitud, len(aArray[i]))
   next

RETURN nMaxLongitud





/* Ŀ
    xDIA                         
                                 
    */
FUNCTION xDia (xElDia)

STATIC aDias := {"Lunes",        ;
                 "Martes",       ;
                 "Miercoles",    ;
                 "Jueves",       ;
                 "Viernes",      ;
                 "Sabado",       ;
                 "Domingo"}
LOCAL  cTipo

if (cTipo := valType(xElDia) == "N")

   // Nos pasan el numero de dia, devuelvo la cadena de dia

   if (xElDia >= 1 .and. xElDia <= 7)
      RETURN aDias[xElDia]
   endif

elseif cTipo == "C"

   // Nos pasan la cadena, busco en el array
   // Si lo encuentro devuelvo el nmero de dia
   // Sino devuelvo cero

   RETURN aScan (aDias, upper(substr(xEldia,1,1)) + lower(substr(xElDia,2)))

endif

RETURN nil



/* Ŀ
    xMES                         
                                 
    */
FUNCTION xMes (xElMes)

STATIC aMeses := {"Enero",       ;
                  "Febrero",     ;
                  "Marzo",       ;
                  "Abril",       ;
                  "Mayo",        ;
                  "Junio",       ;
                  "Julio",       ;
                  "Agosto",      ;
                  "Septiembre",  ;
                  "Octubre",     ;
                  "Noviembre",   ;
                  "Diciembre" }
LOCAL cTipo

if (cTipo := valType(xElMes) == "N")

   // Nos pasan el numero de mes, devuelvo la cadena de mes

   if (xElMes >= 1 .and. xElMes <= 12)
      RETURN aMeses[xElMes]
   endif

elseif cTipo == "C"

   // Nos pasan la cadena de mes, busco en el array
   // Si lo encuentro devuelvo el nmero de mes
   // Sino devuelvo cero

   RETURN aScan (aMeses, upper(substr(xElmes,1,1)) + lower(substr(xElmes,2)))

endif

RETURN nil





/* Ŀ
    xTRIMESTRE                   
                                 
    */
FUNCTION xTrimestre (dFecha)

LOCAL nMes


   nMes := val(substr(dtoc(dFecha), 4, 2))

   do case

      case nMes >= 1 .and. nMes <= 3

           RETURN "1"

      case nMes >= 4 .and. nMes <= 6

           RETURN "2"

      case nMes >= 7 .and. nMes <= 9

           RETURN "3"

      case nMes >= 10 .and. nMes <= 12

           RETURN "4"

      otherwise

           RETURN "0"

   endcase

RETURN nil




/* Ŀ
    xINITRIMESTRE                
                                 
    */
FUNCTION xIniTrimestre (nTrimestre)

LOCAL cMes

  do case

     case nTrimestre = 1
        cMes := "01"

     case nTrimestre = 2
        cMes := "04"

     case nTrimestre = 3
        cMes := "07"

     case nTrimestre = 4
        cMes := "10"

     otherwise
        cMes := "00"

  endcase

RETURN cMes





/* Ŀ
    xFINTRIMESTRE                
                                 
    */
FUNCTION xFinTrimestre (nTrimestre)

LOCAL cMes

  do case

     case nTrimestre = 1
        cMes := "03"

     case nTrimestre = 2
        cMes := "06"

     case nTrimestre = 3
        cMes := "09"

     case nTrimestre = 4
        cMes := "12"

     otherwise
        cMes := "00"

  endcase

RETURN cMes







/* ͻ
                                                  
     S I S T E M A   D E   V E N T A N A S        
                                                  
   ͼ */





/* Ŀ
    xPONVENTANA                  
                                 
    */

FUNCTION xPonVentana (nSup, nIzq, nInf, nDer, cColor, modo, cMensaje)

/* Sintaxis:

      xPonVentana (nSup, nIzq, nInf, nDer, cColor, modo) --> uVentana

   Descripcion:
      nSup, nIzq, nInf, nDer: coordenadas de situacion de la ventana
      cColor: Color de la ventana
      modo: Hacia afuera (SOBRE), hacia adentro (SUB)
      [cMensaje]: Mensaje que aparecera en la parte superior de la
                  ventana. Valor por defecto nulo

   Devuelve:
      Devuelve un objeto de tipo ventana de la siguiente forma:
      [1]: Coordenadas
      [2][1]: Color para marco en lado izq y superior
      [2][2]: Color para marco en lado derecho e inferior
      [3]: grabacion de pantalla
*/
LOCAL ventana := {}
LOCAL cColorAux, i
LOCAL cElColor, cElCursor


if (nSup > nInf ) .or. (nIzq > nDer)
   return .f.
endif
if (modo = nil)
   modo := SOBRE
endif
cElColor  := SetColor ()
cElCursor := SetCursor (SC_NONE)
ventana   := asize (ventana, 3)
ventana[1] := {nSup, nIzq, nInf, nDer}
cColorAux  := substr (cColor, at ("/", cColor))
ventana[3] := savescreen (nSup, nIzq, nInf, nDer)

if (modo = SOBRE)
   ventana[2] := {"w+" + cColorAux, "n" + cColorAux}
else
   ventana[2] := {"n" + cColorAux, "w+" + cColorAux}
endif

IF (modo != NADA)
   dispBegin()
   @ nSup, nIzq say "" + replicate("", nDer-nIzq-1) color ventana[2][1]
   @ nSup, nDer say "" color ventana[2][2]
   @ nInf, nIzq+1 say replicate("", nDer-nIzq-1) + "" color ventana[2][2]
   @ nInf, nIzq say "" color ventana[2][1]
   for i := nSup + 1 to nInf - 1
       @ i, nIzq say "" + space (nDer-nIzq-1) color ventana[2][1]
       @ i, nDer say "" color ventana[2][2]
   next
   dispEnd ()
ELSE
   dispBegin()
   for i := nSup to nInf
       @ i, nIzq SAY space(nDer-nIzq+1)
   next
   dispEnd()
ENDIF

IF cMensaje != nil
   @ nSup, int((nDer + nIzq - len(cMensaje))/2) + 1 SAY cMensaje
ENDIF

SetColor (cElColor)
SetCursor (cElCursor)

RETURN ventana



/* Ŀ
    xQUITAVENTANA                
                                 
    */

FUNCTION xQuitaVentana (ventana)

restscreen (ventana[1][1],ventana[1][2],ventana[1][3],ventana[1][4],ventana[3])

RETURN .T.



/* Ŀ
    xMENSAJE                     
                                 
    */

FUNCTION xMensaje (aMensaje, cColorV, cColorRes, nSimbolo)

/* Sintaxis:

     xMensaje (aMensaje, cColorV, [cColorRes], [nSimbolo]) --> lOk

   Descripcion:

      aMensaje: array unidimensional de cadenas de caracteres.
                Para dejar una linea en blanco dejar un hueco o ""
       cColorV: Color de la ventana
     cColorRes: Color de la hot-key del boton; igual a cColorV predet.
      nSimbolo: Simbolo que aparece en la caja

   Devuelve:

     Valor lgico que vale falso si la tecla pulsada fue ESC
*/

LOCAL nNumLineas := len(aMensaje)
LOCAL nMaxLong := 0, i, nFila, nColumna, nPos
LOCAL cColor := SetColor(cColorV), nCursor := SetCursor (SC_NONE)
LOCAL boton, ventana, cCRes
LOCAL nIcono


if (cColorRes = nil, cCRes := cColorV, cCRes := cColorRes)
if (nSimbolo = nil, nIcono := NONE, nIcono := nSimbolo)

for i := 1 to nNumLineas
   if (aMensaje[i] = nil, aMensaje[i] := "", nil)
next

for i := 1 to nNumLineas
	if aMensaje[i] != nil
      nMaxLong := max(nMaxLong,len(aMensaje[i]))
   endif
next

if nIcono != NONE
   nMaxLong := nMaxLong + 9
endif

nFila := int((maxrow() - nNumLineas - 5)/2)
nColumna := int((maxcol() - nMaxLong - 4)/2)

ventana := xPonVentana (nFila, nColumna, nFila+nNumLineas+4, nColumna+nMaxlong+3, ;
	                     cColorV, SOBRE)

DibujaIcono (nIcono, nFila + 1, nColumna + 2, COL_V2, COL_V2R)

for i := 1 to nNumLineas
   if nIcono != NONE
	   nPos := int((maxcol() - len(aMensaje[i]) - 4)/2) + 6
   else
      nPos := int((maxcol() - len(aMensaje[i]) - 4)/2) + 2
   endif
	@ nFila+i, nPos SAY aMensaje[i]
next

Boton := xPonBotones ({{"^Aceptar", K_ENTER , "Pulse Enter para continuar"}}, ;
                      nFila+nNumLineas+2, cColorV, cCRes, COL_MSG, CENTRADOS)
xLeeBotones (boton)
xQuitaBotones (boton)
xQuitaVentana (ventana)
SetColor(cColor)
SetCursor(nCursor)

RETURN lastkey() != K_ESC




/* Ŀ
    xPREGUNTA                    
                                 
    */

FUNCTION xPregunta(aMensaje, cColorV, cColorRes, nSimbolo, nPredet)

/* Sintaxis:

     xPregunta (aMensaje, cColorV, [cColorRes],
                [nSimbolo], [nPredet]) --> lAceptar

   Descripcion:

      aMensaje: array unidimensional de cadenas de caracteres.
                Para dejar una linea en blanco dejar un hueco o ""
       cColorV: Color de la ventana
     cColorRes: Color de la hot-key del boton; igual a cColorV predet.
      nSimbolo: Simbolo que aparece en la caja
       nPredet: Numero de boton predeterminado (ACEPTAR o CANCELAR)
                Valor por defecto es ACEPTAR
                (Definicion en el fichero def.ch)


   Devuelve:

     Valor logico que solamente vale cierto si se ha seleccionado Aceptar
*/

LOCAL nNumLineas := len(aMensaje)
LOCAL nMaxLong := 0, i, nFila, nColumna, nPos
LOCAL cColor := SetColor(cColorV), nCursor := SetCursor (SC_NONE)
LOCAL boton, aboton, nBoton, lAceptar := .f., ventana, cCRes
LOCAL nIcono


if (cColorRes = nil, cCRes := cColorV, cCRes := cColorRes)
if (nSimbolo = nil, nIcono := NONE, nIcono := nSimbolo)
if (nPredet = nil, nPredet := ACEPTAR, nil)

for i := 1 to nNumLineas
    if (aMensaje[i] = nil, aMensaje[i] := "", nil)
next

for i := 1 to nNumLineas
	if aMensaje[i] != nil
      nMaxLong := max(nMaxLong,len(aMensaje[i]))
   endif

next

if nIcono != NONE
   nMaxLong := nMaxLong + 9
endif

nFila := int((maxrow() - nNumLineas - 5)/2)
nColumna := int((maxcol() - nMaxLong - 4)/2)
ventana := xPonVentana (nFila, nColumna, nFila+nNumLineas+4, nColumna+nMaxlong+3, ;
	                     cColorV, SOBRE)

DibujaIcono (nIcono, nFila + 1, nColumna + 2, COL_V2, COL_V2R)

for i := 1 to nNumLineas
   if nIcono != NONE
	   nPos := int((maxcol() - len(aMensaje[i]) - 4)/2) + 6
   else
      nPos := int((maxcol() - len(aMensaje[i]) - 4)/2) + 2
   endif
	@ nFila+i, nPos SAY aMensaje[i]
next

aboton := { {"^Aceptar", K_ENTER, "Aceptar la seleccin"}, ;
            {"^Cancelar", K_ESC, "Cancelar y volver atrs" } ;
          }
Boton := xPonBotones (aBoton, nFila+nNumLineas+2, cColorV, ;
                      cCRes, COL_MSG, CENTRADOS, nPredet)
nBoton := xLeeBotones (boton)
if (nBoton = 1, lAceptar := .t., lAceptar := .f.)
xQuitaBotones (boton)
xQuitaVentana (Ventana)
SetColor(cColor)
SetCursor(nCursor)

RETURN lAceptar






/* Ŀ
    xPONMENBARRA                 
                                 
    */

FUNCTION xPonMenBarra (cMensaje, cColorV, cColorBarra, cColorInv)

LOCAL ventana
LOCAL nLongitud
LOCAL nIzq
LOCAL nDer
LOCAL nMargen
LOCAL barra


   nLongitud := len(cMensaje)

   if (nLongitud < 25, nMargen := 12, nMargen := 6)

   nIzq := int((maxcol() - nLongitud - 2*nMargen)/2)
   nDer := int((maxcol() + nLongitud + 2*nMargen)/2)

   ventana := xPonVentana (9, nIzq, 16, nDer, cColorV, SOBRE)
   xPonVentana(13, nIzq+1, 15, nDer-1, COL_V2, SUB)

   @ 11,nIzq+nMargen SAY alltrim(cMensaje) COLOR COL_V2

   barra := xCreaBarra (14, nIzq+2, nDer-2, COL_V2B, COL_V2INV)

RETURN {ventana, barra}





/* Ŀ
    xACTMENBARRA                 
                                 
    */

FUNCTION xActMenBarra (aMensaBarra, nPorCiento)

   xPintaBarra (aMensaBarra[BARRA], nPorCiento)

RETURN .t.




/* Ŀ
    xQUITAMENBARRA               
                                 
    */

FUNCTION xQuitaMenBarra (aMensaBarra)

   xQuitaVentana (aMensaBarra[VENTANA])

RETURN .t.




/* Ŀ
    DIBUJO DE ICONOS             
                                 
    */

FUNCTION DibujaIcono (nIcono, nFila, nColumna, cColorV, cColorIco)

LOCAL cColor := SetColor(cColorIco)

IF nIcono = WARNING

xPonVentana (nFila, nColumna, nFila + 3, nColumna + 6, cColorV, SUB)

@ nFila + 1, nColumna + 3 SAY ""
@ nFila + 2, nColumna + 3 SAY chr(22)

ELSEIF nIcono = QUESTION

xPonVentana (nFila, nColumna, nFila + 4, nColumna + 6, cColorV, SUB)

@ nFila + 1, nColumna + 2 SAY "ͻ"
@ nFila + 2, nColumna + 2 SAY " ɼ"
@ nFila + 3, nColumna + 2 SAY " o "

ELSEIF nIcono = INFO

xPonVentana (nFila, nColumna, nFila + 4, nColumna + 6, cColorV, SUB)

@ nFila + 1, nColumna + 3 SAY ""
@ nFila + 2, nColumna + 3 SAY ""
@ nFila + 3, nColumna + 3 SAY ""


ENDIF

SetColor (cColor)

RETURN .t.





/* ͻ
                                                  
     S I S T E M A   G E T   E X T E N D I D O    
                                                  
   ͼ */





/* Ŀ
    SISTEMA DE GET EXTENDIDO     
                                 
    */
/* Notas:

     Sacado del fichero \source\cap16\milector.prg
     Curso de programacion con CA-Cliper 5 (Grupo Eidos)

     #include "miget.ch"
     #include "inkey.ch"

   Uso:

     @ 12,10 SAY "Tercer Get  -> ";
             GET cVar3;
             POS 9;
             TIMEOUT 5;
             POSTIMEOUT {|oGet| Descanso(oGet)};
             MESSAGE "Este Get lo tiene casi todo";
             COLORMSG "r/bg"

   Descripcion:

     Pos: posicion del cursor dentro del campocuando el get
          consigue el enfoque
     Timeout: tiempo de expiracion del get
     Postimeout: codeblock que se evalua cuando expira el tiempo
     Message: Mensaje mostrado cuando el get consigue el enfoque
     ClrMessage: Color del mensaje
*/


/***
*       MiLector()
*       Lector Personalizado de GETs
*/
FUNCTION MiLector( get, cMensaje, cColMsg, pos, nTimeOut, bTimeOut, bLista )

  /// Control para los nuevos parmetros que se le envan  ////
  //                                                         //
   LOCAL nPos                                                //
   LOCAL nKey := 0                                           //
   LOCAL cSaveMsg
   LOCAL nRow
                                                             //
   IF ValType( pos ) # "N"                                   //
      pos := 0                                               //
   END IF                                                    //
                                                             //
   IF ValType( nTimeOut ) # "N"                              //
      nTimeOut := 0                                          //
   END IF                                                    //
                                                             //
   IF ValType( bTimeOut ) # "B"                              //
      bTimeOut := {|| .T.}                                   //
   END IF                                                    //
  /////////////////////////////////////////////////////////////

   // edita el GET si se cumple la condicin WHEN
   IF ( GetPreValidate(get) )

      // Pinta lo determinado por la clusula MESSAGE
      IF cMensaje # NIL
         nRow     := Set(_SET_MESSAGE)
         cSaveMsg := SaveScreen(nRow,0,nRow,MaxCol())
         @ nRow, 0 SAY PADC(cMensaje,MaxCol()+1) COLOR cColMsg
      END IF

      // Activa el foco
      get:SetFocus()

      WHILE ( get:exitState == GE_NOEXIT )

        // controla la salida de la edicin
        IF ( get:typeOut )
           get:exitState := GE_ENTER
        END IF

        //////////////////////////////////////////////////////
        // Cambiado para GET con POSICION                   //
        FOR nPos := get:pos TO pos-1                        //
            get:right()                                     //
        END FOR                                             //
        //////////////////////////////////////////////////////

        // procesa las pulsaciones
        WHILE ( get:exitState == GE_NOEXIT )
          //// Este proceso controla la temporizacin ///////////////
          CogeTecla( get, nKey := InKey( nTimeOut ), bLista )      //
          If( nKey == 0 .AND. Eval(bTimeOut, get ),   ;            //
               __keyboard( Chr( K_ESC ) ), NIL )                   //
           // Vase como aadimos EVAL() del CodeBlock pasado      //
           // como POSTIMEOUT. ojo! tenga en cuenta que su        //
           // programa puede pasar al CodeBlock como parmetro el  //
           // objeto GET en cuestin.                              //
           // Si no se pulsa ninguna tecla, sale como [Esc]        //
          ///////////////////////////////////////////////////////////
        END WHILE

        // Si no se cumple el VALID, no salimos
        IF ( !GetPostValidate(get) )
           get:exitState := GE_NOEXIT
        END IF

      END WHILE

      // mata el foco
      get:KillFocus()

      // Borra lo determinado por la clusula MESSAGE
      IF cMensaje # NIL
         RestScreen(nRow,0,nRow,MaxCol(),cSaveMsg)
      END IF

   END IF

RETURN NIL



/***
*       CogeTecla()
*       Procesa los teclazos de un GET
*
*       NOTA: El GET debe tener el foco
*/
FUNCTION CogeTecla(get, key, bLista)

   LOCAL cKey
   LOCAL bKeyBlock
   LOCAL nValor            //Modificado para nmeros incrementales

   // controla SET KEYs
   IF ( (bKeyBlock := SetKey(key)) <> NIL )
       GetDoSetKey(bKeyBlock, get)
       RETURN NIL                                                                  // NOTE
   END IF

   DO CASE
      CASE ( key == K_UP )
           get:exitState := GE_UP

      CASE ( key == K_SH_TAB )
           get:exitState := GE_UP

      CASE ( key == K_DOWN )
           get:exitState := GE_DOWN

      CASE ( key == K_TAB )
           get:exitState := GE_DOWN

      CASE ( key == K_ENTER )
           get:exitState := GE_ENTER

      CASE ( key == K_ESC )
           IF ( Set(_SET_ESCAPE) )
              get:undo()
              get:exitState := GE_ESCAPE
           END IF

      CASE ( key == K_PGUP )
           get:exitState := GE_WRITE

      CASE ( key == K_PGDN )
           get:exitState := GE_WRITE

      CASE ( key == K_CTRL_HOME )
           get:exitState := GE_TOP

      CASE (key == K_CTRL_W)
           get:exitState := GE_WRITE

      CASE (key == K_INS)
           Set( _SET_INSERT, !Set(_SET_INSERT) )
           if (ReadInsert(), SetCursor(SC_NORMAL), SetCursor(SC_SPECIAL1))

      CASE (key == K_CTRL_U)
           get:Undo()

      CASE (key == K_HOME)
           get:Home()

      CASE (key == K_END)
           get:End()

      CASE (key == K_RIGHT)
           get:Right()

      CASE (key == K_LEFT)
           get:Left()

      CASE (key == K_CTRL_RIGHT)
           get:WordRight()

      CASE (key == K_CTRL_LEFT)
           get:WordLeft()

      CASE (key == K_BS)
           get:BackSpace()

      CASE (key == K_DEL)
           get:Delete()

      CASE (key == K_CTRL_T)
           get:DelWordRight()

      CASE (key == K_CTRL_Y)
           get:DelEnd()

      CASE (key == K_CTRL_BS)
           get:DelWordLeft()

      // Modificado para que [F1] alterne un carcter entre maysculas
      // y minsculas
      CASE (key == K_ALT_F1)
           IF IsLower(SubStr(get:buffer,get:pos,1))
              get:overStrike(Upper(SubStr(get:buffer,get:pos,1)))
            ELSE
              get:overStrike(Lower(SubStr(get:buffer,get:pos,1)))
           END IF

      // Modificado para nmeros incrementales
      CASE (get:type == "N" .OR.get:type == "D")  .and.;
           ( key == 330 .or. key == 334 )
           nValor := get:varGet()
           get:varPut( IIF( key == 334, ++nValor, --nValor ) )
           get:updateBuffer()

      // Modificado para Listas de Valores
      CASE ( key == K_F2 )
           IF ValType( bLista ) == "B"
              get:varPut( EVAL( bLista ) )
              get:UpdateBuffer()
              IF LASTKEY() == K_ESC
                 get:undo()
              END IF
           END IF

      OTHERWISE

           IF (key >= 32 .AND. key <= 255)
              cKey := Chr(key)

              IF (get:type == "N" .AND. (cKey == "." .OR. cKey == ","))
                 get:ToDecPos()
               ELSE
                 IF ( Set(_SET_INSERT) )
                    get:Insert(cKey)
                  ELSE
                    get:Overstrike(cKey)
                 END IF

                 IF (get:typeOut .AND. !Set(_SET_CONFIRM) )
                    IF ( Set(_SET_BELL) )
                       ?? Chr(7)
                    END IF

                    get:exitState := GE_ENTER
                 END IF
              END IF
           END IF
   ENDCASE

RETURN NIL



// Funcin auxiliar para la gestin de las listas de valores
// Parmetros:
// -----------
// bCampo --> CodeBlock que contiene el campo (con alias) a devolver
// oTbCol --> objeto columna para construir la lista de valores
// cColor --> Color para la caja y el TBrowse de la lista
FUNCTION LisVal(bCampo,oTbCol,cColor)
   LOCAL oTbLis,nCol,nTecla
   LOCAL cPantalla := SaveScreen(0,0,MaxRow(),MaxCol())

   oTbCol:width := LEN(EVAL(oTbCol:block))

   nCol   := (MaxCol() - oTbCol:width) / 2
   oTbLis := TBrowseDB(10,nCol,20,MaxCol()-nCol)
   oTbLis:addColumn(oTbCol)
   oTbLis:colorSpec := cColor
   oTbLis:headSep   := ""

   @ 9,nCol-1,21,(MaxCol()-nCol+1) BOX B_SINGLE COLOR cColor

   WHILE .T.
     nTecla := TbStd2(oTbLis)
     DO CASE
        CASE nTecla == K_ENTER
             KEYBOARD CHR( K_ENTER )
             EXIT
        CASE nTecla == K_ESC
             EXIT
     END CASE
   END WHILE
   RestScreen(,,,,cPantalla)
RETURN EVAL(bCampo)


// Funcin para obtener la tecla de salida de un TBrowse
FUNCTION TbStd2(oTb)
   LOCAL nTecla

   WHILE .T.
     DispBegin()
     WHILE  NextKey() == 0 .AND. !oTb:stabilize();  END WHILE
     DispEnd()

     nTecla := Inkey(0)

     DO CASE
        CASE nTecla == K_DOWN;                       oTb:down()
        CASE nTecla == K_UP;                         oTb:up()
        CASE nTecla == K_PGDN ;                      oTb:pageDown()
        CASE nTecla == K_PGUP ;                      oTb:pageUp()
        CASE nTecla == K_CTRL_PGUP ;                 oTb:goTop()
        CASE nTecla == K_CTRL_PGDN ;                 oTb:goBottom()
        OTHERWISE;                                   EXIT
     END CASE
   END WHILE

RETURN nTecla







/* ͻ
                                                  
     S I S T E M A   B A R R A S   E S T A D O    
                                                  
   ͼ */



/* Ŀ
    xCREABARRA                   
                                 
    */
FUNCTION xCreaBarra ( nFila, nIzq, nDer, cColBarra, cColInv, cCharBarra )

LOCAL aHandle[B_LEN]     // Array de informacion de la barra

aHandle[ B_TOP ]        := nFila
aHandle[ B_LEFT ]       := nIzq
aHandle[ B_RIGHT ]      := nDer
aHandle[ B_BARCOLOR ]   := "W+/N"
aHandle[ B_INVCOLOR ]   := "N/W+"
aHandle[ B_DISPLAYNUM ] := .T.
aHandle[ B_BARCHAR ]    := CHR(219)
aHandle[ B_PERCENT ]    := 0
aHandle[ B_POSICION ]   := 0


IF cColBarra <> NIL
   aHandle[B_BARCOLOR] := cColBarra
ENDIF

IF cColInv <> NIL
   aHandle[B_INVCOLOR] := cColInv
ENDIF

IF cCharBarra <> NIL
   aHandle[ B_BARCHAR ] := cCharBarra
ENDIF

IF aHandle[ B_RIGHT ] < aHandle[ B_LEFT ] + 4
   aHandle[ B_RIGHT ] := aHandle[ B_LEFT ] + 4
ENDIF

IF aHandle[B_TOP] > MaxRow() .or. aHandle[B_TOP] < 0
   aHandle[B_TOP] := 10
ENDIF

IF aHandle[ B_RIGHT ] < aHandle[ B_LEFT ] + 9
   aHandle[ B_DISPLAYNUM ] := .F.
ENDIF

aHandle[B_CENTRO] := int((aHandle[B_RIGHT] + aHandle[B_LEFT] - 3)/2) + 2

aHandle[B_RATIO] := aHandle[B_RIGHT] - aHandle[B_LEFT] + 1


RETURN (aHandle)




/* Ŀ
    xPINTABARRA                  
                                 
    */
FUNCTION xPintaBarra (aHandle, nPorCiento)

LOCAL cColor := SetColor()
LOCAL nCursor := SetCursor (SC_NONE)
LOCAL nCols := 0


if nPorCiento < 0
   nPorCiento := 0
elseif nPorCiento > 100
   nPorCiento := 100
endif

aHandle[B_PERCENT] := nPorCiento
nCols := int(aHandle[B_RATIO] * nPorCiento / 100)

DispBegin()

// Borro la barra actual
SetColor (aHandle[B_BARCOLOR])
@ aHandle[B_TOP], aHandle[B_LEFT] CLEAR TO aHandle[B_TOP], aHandle[B_RIGHT]

// Pinto la nueva Barra
SetColor (aHandle[B_BARCOLOR])
@ aHandle[B_TOP], aHandle[B_LEFT] SAY replicate(aHandle[B_BARCHAR], nCols)
aHandle [B_POSICION] := aHandle[B_LEFT] + nCols

// Decido el estado de los nmeros de %
do case

   case aHandle[B_POSICION] < aHandle[B_CENTRO]

     SetColor (aHandle[B_BARCOLOR])
     @ aHandle[B_TOP],aHandle[B_CENTRO] SAY alltrim(str(nPorCiento)) + "%"

   case aHandle[B_POSICION] = aHandle[B_CENTRO]

     SetColor (aHandle[B_INVCOLOR])
     @ aHandle[B_TOP], aHandle[B_CENTRO] SAY ;
          substr(alltrim(str(nPorCiento)), 1, 1)
     SetColor (aHandle[B_BARCOLOR])
     @ aHandle[B_TOP], aHandle[B_CENTRO] + 1 SAY ;
          substr(alltrim(str(nPorCiento)),2,1) + "%"

   case aHandle[B_POSICION] = aHandle[B_CENTRO] + 1

     SetColor (aHandle[B_INVCOLOR])
     @ aHandle[B_TOP], aHandle[B_CENTRO] SAY ;
          substr(alltrim(str(nPorCiento)), 1, 2)
     SetColor (aHandle[B_BARCOLOR])
     @ aHandle[B_TOP], aHandle[B_CENTRO] + 2 SAY "%"

   case aHandle[B_POSICION] > aHandle[B_CENTRO] + 1

     SetColor (aHandle[B_INVCOLOR])
     @ aHandle[B_TOP],aHandle[B_CENTRO] SAY alltrim(str(nPorCiento)) + "%"

endcase

dispEnd()

SetColor (cColor)
SetCursor (nCursor)

RETURN (aHandle)







/* ͻ
                                                  
        S I S T E M A    D E   M E N S A J E S    
                                                  
   ͼ */



/* Ŀ
    xPONMENSAJE                  
                                 
    */
FUNCTION xPonMensaje (cMensaje, cColMsg)

LOCAL nFila    := Set(_SET_MESSAGE)
LOCAL nCol     := maxCol()
LOCAL cSaveMsg := SaveScreen(nFila,0,nFila,MaxCol())
LOCAL aMensajes


aMensajes := { nFila,         ;
               nCol,          ;
               cSaveMsg       ;
             }

// Pinta lo determinado por la clusula MESSAGE

@ nFila,0 SAY padc(cMensaje, nCol+1) COLOR cColMsg

RETURN aMensajes


/* Ŀ
    xQUITAMENSAJE                
                                 
    */
FUNCTION xQuitaMensaje (aMensaje)

restscreen (aMensaje[1], 0, aMensaje[1], aMensaje[2], aMensaje[3])

RETURN .t.






/* Ŀ
    xPONTITULO                   
                                 
    */
FUNCTION xPonTitulo (cTitulo, cColTitulo, nLinea)

LOCAl cAux


  if (nLinea = nil, nLinea := 0, nil)

  // Centro la cadena con espacios a ambos lados
  cAux := center(cTitulo,maxcol()+1,.t.)

  @ nLinea, 0 SAY cAux COLOR cColTitulo

RETURN .t.




/* ͻ
                                                  
     C O P I A S   D E   S E G U R I D A D        
                                                  
   ͼ */


/* Ŀ
    xRESTCOPIA                   
                                 
    */
/* Sintaxis:

      xRestCopia (cRutaU) --> lExito

   Descripcion:

      <cRutaU>: Nombre de la unidad de disco para recuperar copias
                (solamente se permite que sea una unidad de disco
                como A o B)

      La funcion realiza la restauracin de una copia de seguridad realizada
      previamente con una llamada a xCopiaSeg(). Se lee el catalogo de copia
      "copia.cat" y se restauran los ficheros en su posicion almacenada.
      Si el directorio donde deben colocarse los ficheros no existe se crea,
      y so alguno de los ficheros existe se sobreescribe

   Devuelve:

      .t. <--> todo correcto
*/
FUNCTION xRestCopia (cRutaU)

LOCAL lOk
LOCAL ventana
LOCAL barra
LOCAL cCatalogo := ""
LOCAL aCatalogo := {}
LOCAL i
LOCAL nLong
LOCAL cUnidad := upper(substr(cRutaU,1,1))
LOCAL cAux
LOCAL cOrigen
LOCAL cSeguro := ""
LOCAL nTotal
LOCAL nDisquete := 1
LOCAL nSize
LOCAL nSizeActual
LOCAL nContador
LOCAL nPos
LOCAL nError
LOCAL cError
LOCAL cColor  := SetColor (COL_V2)
LOCAL nCursor := SetCursor (SC_NONE)


if (cUnidad >= "C") .or. len(cUnidad) != 1
   return .f.
endif

ventana := xPonVentana (7,18,18,59,COL_V2,SOBRE)
xPonVentana (11,20,16,57,COL_V2,SUB)
@ 9,23  say "RESTAURACION COPIA DE SEGURIDAD"
@ 12,25 say "Restaurando"
@ 14,29 say "Fichero"
@ 15,28 say "Disquete"

// me aseguro de que el disquete tenga la etiqueta COPIA1
// 

lOk := xNuevoDR (cUnidad, "COPIA1")
if .not. lOk
   xQuitaVentana (ventana)
   SetColor (cColor)
   SetCursor (nCursor)
   return .f.
endif

lOk := xPregunta ({"","Est seguro de querer continuar?", ;
                   "La restauracin de copias borrar todos", ;
                   "los datos actuales...",""}, ;
                  COL_V2, COL_V2R, QUESTION)
if .not. lOk
   xQuitaVentana (ventana)
   SetColor (cColor)
   SetCursor (nCursor)
   return .f.
endif

// leo el catalogo del disquete, si no est me marcho
// lo guardo en aCatalogo en la forma {nombre, tamao}
// 

cCatalogo := filestr (cUnidad + ":\COPIA.CAT")
nLong := len(cCatalogo)
if  nLong = 0
   xMensaje ({"","Imposible leer catlogo", ;
              "No puedo recuperar la copia", ""}, ;
             COL_V2, COL_V2R, WARNING)
   xQuitaVentana (ventana)
   SetColor (cColor)
   SetCursor (nCursor)
   return .f.
endif
cCatalogo := substr (cCatalogo, 2)
nLong := len(cCatalogo)
do while nLong != 0
   aadd (aCatalogo, {substr (cCatalogo, 1, at(SEP2, cCatalogo)-1), ;
      int(val(substr(cCatalogo,at(SEP2,cCatalogo)+1,at(SEP1,cCatalogo)-1)))})
   cCatalogo := substr(cCatalogo, at(SEP1, cCatalogo)+1)
   nLong := len(cCatalogo)
enddo

nTotal := len(aCatalogo)

// Restauracion de copia
// 

FOR i := 1 TO nTotal

   // Me aseguro de que el directorio destino existe efectivamente
   nPos := rat("\", aCatalogo[i][1])
   if nPos != 0
      // cAux contiene el nombre del directorio
      cAux := substr(aCatalogo[i][1], 1, nPos-1)
      if DirChange(cAux) != NO_DISK_ERR
         // El directorio no existe, lo creo
         nError := DirMake(cAux)
         if nError != NO_DISK_ERR
            xMensaje ({"","Error creando directorio", ;
                       "Imposible recuperar copia",""},;
                       COL_V2,COL_V2R, WARNING)
            xQuitaVentana (ventana)
            SetColor (cColor)
            SetCursor (nCursor)
            return .f.
         endif
      endif
   endif

   // si existe el fichero lo renombramos; solo lo borraremos
   // cuando todo haya salido bien
   if file(aCatalogo[i][1])
      nPos := rat ("\", aCatalogo[i][1])
      if nPos = 0
         cSeguro := "xxx.tmp"
         filedelete (cSeguro)
         nError := renamefile (aCatalogo[i][1], cSeguro)
      else
         cSeguro := substr(aCatalogo[i][1], 1, nPos) + "xxx.tmp"
         filedelete (cSeguro)
         nError := renamefile (aCatalogo[i][1], cSeguro)
      endif
      if nError != 0
         do case
            case nError = -2
                 cError := "Fichero no encontrado"
            case nError = -3
                 cError := "Ruta no encontrada"
            case nError = -5
                 cError := "Acceso denegado"
            case nError = -17
                 cError := "Fichero no est en la misma red"
         endcase
         xMensaje ({"","Error renombrando ficheros", ;
                    cError,""},COL_V2,COL_V2R, WARNING)
         xQuitaVentana (ventana)
         SetColor (cColor)
         SetCursor (nCursor)
         return .f.
      endif
   endif

   nContador := 0
   nSize := aCatalogo[i][2]
   nSizeActual := 0

   // cOrigen solamente tiene nombre y extension
   cOrigen := substr (aCatalogo[i][1], rat("\", aCatalogo[i][1])+1 )
   @ 12,37 say padr (cOrigen, 12)
   @ 14,37 say padr (alltrim(str(i)) + " de " + alltrim(str(nTotal)), 14)
   @ 15,37 say padr (alltrim(str(nDisquete)), 10)

   // cOrigen solamente con el nombre
   nPos := rat (".", cOrigen)
   if nPos != 0
      cOrigen := substr (cOrigen, 1, nPos-1)
   endif

   // cAux completo
   cAux := cUnidad + ":\" + cOrigen + "." + ntoc (nContador,10,3,"0")

   // hacemos la restauracion
   nSizeActual := fileAppend (cAux, aCatalogo[i][1])

   // Se han copiado todos los datos del fichero?
   do while nSizeActual < nSize
      // el anterior fichero esta repartido en ms disquetes
      // pedimos el siguiente volumen
      nDisquete++
      lOk := xNuevoDR (cUnidad,"COPIA" + alltrim(str(nDisquete)))
      if .not. lOk
         // nos vamos dejando un fichero en el aire
         if file(cSeguro)
            filedelete (aCatalogo[i][1])
            nError := renamefile (cSeguro, aCatalogo[i][1])
         endif
         if nError != 0
            do case
               case nError = -2
                 cError := "Fichero no encontrado"
               case nError = -3
                 cError := "Ruta no encontrada"
               case nError = -5
                 cError := "Acceso denegado"
               case nError = -17
                 cError := "Fichero no est en la misma red"
            endcase
            xMensaje ({"","Error renombrando ficheros", ;
                       cError,""},COL_V2,COL_V2R, WARNING)
         endif
         xQuitaVentana (ventana)
         SetColor (cColor)
         SetCursor (nCursor)
         return .f.
      endif
      @ 15,37 say padr (alltrim(str(nDisquete)), 10)
      nContador++
      cAux := cUnidad + ":\" + cOrigen + "." + ntoc (nContador,10,3,"0")
      nSizeActual := nsizeActual + fileAppend (cAux, aCatalogo[i][1])
   enddo
   filedelete (cSeguro)

NEXT

xQuitaVentana (ventana)
SetColor (cColor)
SetCursor (nCursor)

RETURN .t.





/* Ŀ
    xNUEVODR                     
                                 
    */
/* Sintaxis:

      xNuevoDR (cUnidad, cCopia) --> lOk

   Descripcion:

      La rutina comprueba que el disquete de cUnidad este preparado
      para poder ser leido, adems de que contiene una copia de
      seguriadad, para lo cual la etiqueta debe ser cCopia

      cUnidad: nombre de la unidad de disco a comprobar (A o B)
      cCopia: Etiqueta que debe tener el disquete

   Devuelve:

      .t. <--> todo correcto
*/
FUNCTION xNuevoDR (cUnidad, cCopia)

LOCAL lOk, lAceptar
LOCAL lSalir := .f., lIterar
LOCAL nCursor := SetCursor (SC_NONE)

if len(cUnidad) != 1
   SetCursor (nCursor)
   return .f.
endif

do while .not. lSalir

lOk := xMensaje ({"","Introduzca el disquete etiquetado", ;
                  "",cCopia, "", ;
                  "en la unidad " + upper(cUnidad),""}, ;
                  COL_V2,COL_V2R)
if .not. lOk
   lAceptar := xPregunta ({"","Quiere abandonar restauracin de copia?",""}, ;
                          COL_V2,COL_V2R, QUESTION)
   if lAceptar .or. lastKey() = K_ESC
      SetCursor (nCursor)
      return .f.
   endif
endif
if .not. diskready(cUnidad, netdisk(cUnidad))
   lIterar := .t.
   do while lIterar
      lOk := xMensaje ({"","Disquete no preparado",""}, ;
                        COL_V2,COL_V2R, WARNING)
      if .not. lOk
         lAceptar := xPregunta ({"","Quiere abandonar restauracin de copia?",""}, ;
                                COL_V2,COL_V2R, QUESTION)
         if lAceptar .or. lastKey() = K_ESC
            SetCursor (nCursor)
            return .f.
         endif
      endif
      lIterar := .not. diskready(cUnidad, netdisk(cUnidad))
   enddo
endif

// lee la etiqueta de volumen
if upper(fileseek (cUnidad + ":\*.*", 8)) != cCopia
   xMensaje ({"","Disquete errneo",""},COL_V2,COL_V2R, WARNING)
else
   lSalir := .t.
endif

enddo
SetCursor (nCursor)

RETURN .t.






/* Ŀ
    xCOPIASEG                    
                                 
    */
/* Sintaxis:

      xCopiaSeg (aFicheros, cRutaDest) --> lExito

   Descripcion:

      <aFicheros>: array unidimensional en el que cada componente
                   es un nombre de fichero, de los cuales se va a
                   hacer una copia de seguridad, con el camino
                   necesario para encontrarlos
      <cRutaDest>: ruta de destino de la copia de seguridad
                   (solamente se permite que sea una unidad de disco
                   como A o B)

      La funcion realiza una copia de seguridad en la unidad <cRutaDest>
      de los ficheros que se pasen en <aFicheros>. Los ficheros se guardan
      con su nombre original y extensiones numericas, que comienzan en
      000 y continuan segun el fichero se deba de copiar en ms de un disco
      Adems se crea un catlogo de copia llamado "copia.cat"

   Devuelve:

      .t. <--> todo correcto
*/
FUNCTION xCopiaSeg (aFicheros, cRutaDest)

LOCAL nTotal := len (aFicheros), nDisquete := 1
LOCAL nContador, i, nPos, nSize
LOCAL cRuta   := alltrim (cRutaDest)
LOCAL cUnidad := upper(substr(cRuta,1,1))
LOCAL cDestino, cAux, lOk
LOCAL ventana
LOCAL cColor    := SetColor (COL_V2)
LOCAL nCursor   := SetCursor (SC_NONE)
LOCAL cCatalogo := ""


if (cUnidad >= "C") .or. (nTotal < 1)
   return .f.
endif

ventana := xPonVentana (7,18,18,59,COL_V2,SOBRE)
xPonVentana (11,20,16,57,COL_V2,SUB)
@ 9,30 say "COPIA DE SEGURIDAD"
@ 12,28 say "Copiando"
@ 14,29 say "Fichero"
@ 15,28 say "Disquete"

// pido primer disco y lo etiqueto
// 

lOk := xNuevoDW (cUnidad, "COPIA1")
if .not. lOk
   xQuitaVentana (ventana)
   SetColor (cColor)
   SetCursor (nCursor)
   return .f.
endif

// guardo catalogo de los archivos a copiar
// 

for i := 1 to nTotal
   nSize := filesize(aFicheros[i])
   if nSize = -1
      xMensaje ({"","Error en el archivo", aFicheros[i],""}, ;
                COL_V2, COL_V2R, WARNING)
      xQuitaVentana (ventana)
      SetColor (cColor)
      SetCursor (nCursor)
      return .f.
   endif
   cCatalogo := cCatalogo + SEP1 + aFicheros[i] + SEP2 + alltrim(str(nSize))
next
cCatalogo := cCatalogo + SEP1
strfile (cCatalogo, cUnidad + ":copia.cat")

// BackUp de todos los ficheros
// 

for i := 1 to nTotal

   // si no existe el fichero pasamos al siguiente
   if .not. file(aFicheros[i])
      loop
   endif

   nContador := 0

   // cDestino solamente tiene nombre y extension
   cDestino := substr (aFicheros[i], rat("\", aFicheros[i])+1 )
   @ 12,37 say padr (cDestino, 12)
   @ 14,37 say padr (alltrim(str(i)) + " de " + alltrim(str(nTotal)), 14)
   @ 15,37 say padr (alltrim(str(nDisquete)), 10)

   // cDestino solamente con el nombre
   nPos := rat (".", cDestino)
   if nPos != 0
      cDestino := substr (cDestino, 1, nPos-1)
   endif

   // En cAux coloco el nombre del fichero con extension "000"
   cAux := cUnidad + ":\" + cDestino + "." + ntoc (nContador,10,3,"0")

   // hacemos el backup
   fileCopy (aFicheros[i], cAux, .t.)

   // Se han copiado todos los datos del fichero?
   do while fileCOpen ()
      nDisquete++
      // el anterior fichero no ha cabido en el disquete
      lOk := xNuevoDW (cUnidad, "COPIA" + alltrim(str(nDisquete)))
      if .not. lOk
         xQuitaVentana (ventana)
         SetColor (cColor)
         SetCursor (nCursor)
         return .f.
      endif
      @ 15,37 say padr (alltrim(str(nDisquete)), 10)
      nContador++
      cAux := cUnidad + ":\" + cDestino + "." + ntoc (nContador,10,3,"0")
      fileCCont (cAux)
   enddo
next
xQuitaVentana (ventana)
SetColor (cColor)
SetCursor (nCursor)

RETURN .t.




/* Ŀ
    xNUEVODW                     
                                 
    */
/* Sintaxis:

      xNuevoDW (cUnidad, cCopia) --> lOk

   Descripcion:

      La rutina comprueba que el disquete de cUnidad este preparado
      para poder ser escrito

      cUnidad: nombre de la unidad de disco a comprobar (A o B)
      cCopia: etiqueta de volumen que se la va a dar

   Devuelve:

      .t. <--> todo correcto
*/
FUNCTION xNuevoDW (cUnidad, cCopia)

LOCAL lOk, lAceptar
LOCAL lSalir := .f., lIterar
LOCAL nCursor := SetCursor (SC_NONE)

if len(cUnidad) != 1
   SetCursor (nCursor)
   return .f.
endif

do while .not. lSalir

lOk := xMensaje ({"","Introduzca un nuevo disquete en unidad " + ;
                  upper(cUnidad), ;
                  "y etiquetelo para su identificacin como","", ;
                  cCopia + " " + dtoc(date()), ""},COL_V2,COL_V2R)
if .not. lOk
   lAceptar := xPregunta ({"","Quiere abandonar copia de seguridad?",""}, ;
                           COL_V2,COL_V2R, QUESTION)
   if lAceptar .or. lastKey() = K_ESC
      SetCursor (nCursor)
      return .f.
   endif
endif

if .not. diskreadyw(cUnidad, netdisk(cUnidad))
   lIterar := .t.
   do while lIterar
      lOk := xMensaje ({"","Disquete no preparado o", ;
                        "protegido contra escritura",""}, ;
                       COL_V2,COL_V2R, WARNING)
      if .not. lOk
         lAceptar := xPregunta ({"","Quiere abandonar copia de seguridad?",""}, ;
                                 COL_V2,COL_V2R, QUESTION)
         if lAceptar .or. lastKey() = K_ESC
            SetCursor (nCursor)
            return .f.
         endif
      endif
      lIterar := .not. diskreadyw(cUnidad, netdisk(cUnidad))
   enddo
endif

if diskfree(cUnidad) != diskTotal(cUnidad)
   lAceptar := xPregunta ({"","El disquete no est vaco", ;
                           "Desea sobreescribir los datos?",""}, ;
                          COL_V2,COL_V2R, QUESTION)
   if lAceptar
      lSalir := filedelete (cUnidad + ":*.*")
   endif
else
   lSalir := .t.
endif

// le damos la etiqueta de volumen
volume (cUnidad + ":" + cCopia)

enddo
SetCursor (nCursor)

RETURN .t.




/* ͻ
                                                  
     G E S T I O N   D E   D I V I S A S          
                                                  
   ͼ */



/* Sintaxis:

      xFaseEuro() --> lEuro

   Descripcion:

      La rutina comprueba la fase Euro en la que estamos
      segun la fecha de la contabilidad cargada.
      A partir del ao contable 2001 solamente Euros.

   Devuelve:

      .t. <--> Estamos en fase Euro
      .f. <--> Estamos en fase Peseta
*/
FUNCTION xFaseEuro()
LOCAL nEjercicio := val(xGetConfig("CN_EJERCICIO"))

if ( ((nEjercicio >= 50) .and. (nEjercicio <= 99)) .or. (nEjercicio = 0) )
  RETURN .f.
else
  RETURN .t.
endif
RETURN nil


/* Sintaxis:

      xFaseConvivencia() --> lConvivencia

   Descripcion:

      La rutina comprueba la fase de convivencia entre
      euros y pesetas en la que estamos segun la fecha
      de la contabilidad cargada.

   Devuelve:

      .t. <--> Estamos en fase convivencia Euro/Peseta
      .f. <--> Caso contrario
*/
FUNCTION xFaseConvivencia()
LOCAL nEjercicio := val(xGetConfig("CN_EJERCICIO"))
LOCAL nTrimestre := val(xGetConfig("CN_TRIMESTRE"))
// Convivencia solo para el 2001
RETURN nEjercicio = 1


/* Sintaxis:

      xDivisa(nImporte) --> cNombreDivisa

   Descripcion:

      La rutina devuelve el codigo estandar de
      las letras correspondiente a la divisa
      de la fase Euro actual, o bien al tipo
      de importe si se indica

      nImporte: importe opcional para indicar
      el tipo de divisa cuya descripcion queremos
      obtener. Si tiene decimales se devolvera EUR.

   Devuelve:

      Fase Euro o <nImporte> con decimales <--> EUR
      Fase Peseta o <nImporte> sin decimales <--> PTS
*/
FUNCTION xDivisa(nImporte)
LOCAL cDivisa
if (nImporte = nil)
  cDivisa := if (xFaseEuro(), "EUR", "PTS")
else
  cDivisa := if (int(nImporte) != nImporte, "EUR", "PTS")
endif
RETURN cDivisa


/* Sintaxis:

      xConversion(nImporte) --> nImporteConvertido

   Descripcion:

      La rutina convierte el importe indicado
      a Euros o Pesetas segun convenga.

      nImporte: importe a convertir, se supone
      que correspondiente a la divisa de la
      fase euro actual. Si estamos en fase Euro
      el importe vendra en EUR.

      lFaseEuro: boolean que permite forzar la
      fase euro en caso de necesidad. Si se
      indica a .f. se realizara siempre una
      conversion PTS-->EUR (p.e.)

   Devuelve:

      Importe convertido a la divisa contraria
      de la indicada
*/
FUNCTION xConversion(nImporte, lFaseEuro)
local nConversion
if (lFaseEuro = nil)
  lFaseEuro := xFaseEuro()
endif
// EUR --> PTS
if (lFaseEuro)
  nConversion := round(nImporte * 166.386, 0)
// PTS --> EUR
else
  nConversion := round(nImporte / 166.386, 2)
endif
RETURN nConversion


/* Sintaxis:

      xMascaraImporte() --> cMascaraImporte

   Descripcion:

      La rutina devuelve la mascara a aplicar en
      una clausula PICTURE para un importe de
      acuerdo a la fase Euro en la que nos
      encontremos.

   Devuelve:

      Fase Euro <--> mascaraNumLEUR
      Fase Peseta <--> mascaraNumLPTS
*/
FUNCTION xMascaraImporte()
RETURN if (xFaseEuro(), maskNumLEUR, maskNumLPTS)


/* Sintaxis:

      xMascaraIva() --> cMascaraIva

   Descripcion:

      La rutina devuelve la mascara a aplicar en
      una clausula PICTURE para un % IVA de
      acuerdo a la fase Euro en la que nos
      encontremos.

   Devuelve:

      Fase Euro <--> mascaraIvaEUR
      Fase Peseta <--> mascaraIvaPTS
*/
FUNCTION xMascaraIva()
RETURN if (xFaseEuro(), maskIvaEUR, maskIvaPTS)


/* Sintaxis:

      xLongImporte() --> nLongitudImporte

   Descripcion:

      La rutina devuelve la longitud total de un
      campo de la BD que representa un importe.
      Esta longitud representa la longitud total
      del importe, incluyendo si es preciso el punto
      decimal y los decimales (caso de Euros).

   Devuelve:

      Fase Euro <--> L_IMPORTE_EUR
      Fase Peseta <--> L_IMPORTE_PTS
*/
FUNCTION xLongImporte()
RETURN if (xFaseEuro(), L_IMPORTE_EUR, L_IMPORTE_PTS)


/* Sintaxis:

      xLongIVA() --> nLongitudIVA

   Descripcion:

      La rutina devuelve la longitud total de un
      campo de la BD que representa un porcentaje
      de impuesto tipo IVA. Esta longitud representa
      a longitud total del campo, incluyendo si es
      preciso el punto decimal y los decimales
      (caso de Euros).

   Devuelve:

      Fase Euro <--> L_TIPOIVA_EUR
      Fase Peseta <--> L_TIPOIVA_PTS
*/

FUNCTION xLongIVA()
RETURN if (xFaseEuro(), L_TIPOIVA_EUR, L_TIPOIVA_PTS)


/* Sintaxis:

      xNumeroDecimales() --> nNumeroDecimales

   Descripcion:

      La rutina devuelve el numero de decimales
      de un campo numerico dependiendo de la fase
      Euro en la que nos encontremps.

   Devuelve:

      Numero de decimales de un campo numerico

*/
FUNCTION xNumeroDecimales()
RETURN if (xFaseEuro(), 2, 0)

